drkns 02.02.2011 08:36:12 +0200 - build 1807

1. Уточнение 1804.1.

svs 01.02.2011 18:10:02 +0300 - build 1806

1. Mantis#0001418: Реакция VMenu на RClick аналогично диалогам

2. В файлы помощи добавлен раздел, содержащий списки установленных макросов.


svs 01.02.2011 16:07:38 +0300 - build 1805

1. Mantis#0001690: FDLG_NODTITLE - не менять заголовок консоли по заголовку диалога
   (from samlyukov)
   Вместо предлагаемого FDLG_NODTITLE добавлен флаг диалога FDLG_KEEPCONSOLETITLE, 
   позволяющий отключить установку заголовка консоли по нулевому элементу диалога.
   2samlyukov: с тебя корректировка Писания :-)

2. Macro: коррекция build 1791

3. Mantis#0001684: Падение FileList:GetCurName во время чтения сетевой папки
   (from Maximus)
   Падает из-за того, что из CheckForEscSilent вызывается ProcessSynchroEvent. 
   А плагин зовет ACTL_GETWINDOWINFO.
   Фар еще не закончил чтение каталога и CurFile больше чем FileCount.
   Что приводит к падению.

4. Mantis#0001677: При запуске макроса через MCMD_POSTMACROSTRING задавать код "запускающей" клавиши
   Траблы с AKey...
   Надо протестировать!

5. Mantis#0001480: Расширить substr() для того, чтоб она могла возвращать подстроку начиная с конца строки
     если start  >= 0, то вернётся подстрока, начиная со start-символа от начала строки.
     если start  <  0, то вернётся подстрока, начиная со start-символа от конца строки.
     если length >  0, то возвращаемая подстрока будет состоять максимум из length символов исходной строки начиная с start
     если length <  0, то в возвращаемой подстроке будет отсутствовать length символов от конца исходной строки, при том, что она будет начинаться с символа start.

     пустая строка возвращается:
       если length = 0
       если ... (уточнить!)


drkns 01.02.2011 14:02:14 +0200 - build 1804

1. Поиск в режиме "На всех несъёмных дисках"/"На всех локальных дисках" учитывает непримонтированные диски тоже. 

2. Mantis#0001693: Incorrect settings in File descriptions dialog

drkns 29.01.2011 12:31:15 +0200 - build 1803

1. Уточнение поиска альтернативных потоков в папках.

svs 27.01.2011 13:30:39 +0300 - build 1802

1. Macro: Уточнение кода возврата для callplugin
   Функция callplugin возвращает 0, если вызываемого плагина нет или плагин вернул 0. 
   В других случаях функция возвращает значение, отличное от 0.
   Функция callplugin

svs 25.01.2011 18:35:03 +0300 - build 1801

1. Macro: Уточнение кода возврата для callplugin

svs 25.01.2011 16:53:18 +0300 - build 1800

1. Mantis#0001673: Добавить флаг OPEN_FROMMACROSTRING к существующему OPEN_FROMMACRO
   Тестим...

   <АХТУНГ>

     Замечание для OpenPluginW:
       Если в параметре OpenFrom выставлен флаг OPEN_FROMMACRO, то значения в младшем слове 
       содержат не идентификатор из перечисления OPENPLUGIN_OPENFROM, а номер текущей макрообласти, 
       определенной в перечислении FARMACROAREA.
       
   </АХТУНГ>


2. Mantis#0001677: При запуске макроса через MCMD_POSTMACROSTRING задавать код "запускающей" клавиши
   В структуру ActlKeyMacro::Param::PlainText добавлено поле "AKey".
   

drkns 23.01.2011 13:02:35 +0200 - build 1799

1. Ошибка в FCTL_SETSORTMODE.

2. Ещё раз #0001670.

drkns 22.01.2011 18:31:13 +0200 - build 1798

1. Ещё раз #0001670.

drkns 20.01.2011 20:18:54 +0200 - build 1797

1. Уточнение разделения прав доступа на "read"/"modification" в apiCreateFile.

drkns 20.01.2011 00:52:42 +0200 - build 1796

1. В некоторых случаях не работало копирование/перенос ссылок.

drkns 19.01.2011 21:21:30 +0200 - build 1795

1. Ещё немного паранойи в elevation:
     - имя канала = GUID;
     - проверка PID.

drkns 18.01.2011 14:47:00 +0200 - build 1794

1. Там же:
     - уточнение 1793;
     - paranoia mode on: именованный канал теперь доступен только для привилегированных процессов.

drkns 18.01.2011 00:53:26 +0200 - build 1793

1. Изменения в elevation по мотивам Mantis#0001670.

drkns 17.01.2011 13:27:27 +0200 - build 1792

1. Mantis#0001667: can't paste hex numbers

svs 16.01.2011 18:02:14 +0300 - build 1791

1. Mantis#0001660: Оператор XOR для булевых выражений
   Добавлен условный оператор "^^" - XOR, исключающее ИЛИ

drkns 16.01.2011 00:20:57 +0200 - build 1790

1. Переключатель "[x] File processing (OpenFilePlugin)" в настройках менеджера плагинов теперь 3-позиционный:
     [ ] - не показывать меню;
     [?] - показывать меню везде, кроме ситуаций "вход в архив по Enter" и "поиск в архивах";
     [x] - показывать меню везде.

2. GCC warnings.

svs 14.01.2011 17:39:03 +0300 - build 1789

1. Mantis#0001631: добавка в PluginsControl() - PCTL_FORCEDLOADPLUGIN
   (from: samlyukov)
   Добавка к АПИ: PCTL_FORCEDLOADPLUGIN - грузит плагин не в кэш, а сразу в память, что позволят 
                  использовать сторонние плагины при межплагиновом взаимодействии.

svs 14.01.2011 17:11:42 +0300 - build 1788

1. Macro: уточнение для iif в части проверки на строку (см. build 1786 п.3)

2. Macro: уточнение для $if(строка) в части проверки на строку (см. build 1786 п.3)

drkns 13.01.2011 22:33:26 +0200 - build 1787

1. Неофициальный тестовый режим запускателя - "не мерцаем панелями при запуске неконсольных приложений".
   Включается при System\Executor\SilentExternal=dword:1.

svs 13.01.2011 11:43:12 +0300 - build 1786

1. Mantis#0001655: Неверное сообщение об ошибке при разборе макроса

2. Mantis#0001642: При проверке макропоследовательности возвращается неправильная позиция ошибки

3. Macro: изменения в поведении проверки условий для $if/$while
   Строка в условии проверяется на пусто и не пусто.
     
     %a="";
     $if (%a) не исполняем $else будет исполнено $end
     $if ("") не исполняем $else будет исполнено $end
     
     %a="все что угодно, в т.ч. просто 0";
     $if (%a) будет исполнено $else не исполняем $end
     $if ("все что угодно") будет исполнено $else не исполняем $end
     $if ("0") будет исполнено $else не исполняем $end

   + подсократим код :-)

4. Macro: введенная в build 1773 в строй функция Scr.Scroll переименована в Window.Scroll

5. Mantis#0001656: Отладочная версия валится в TruncStr

drkns 12.01.2011 16:15:14 +0200 - build 1785

1. И ещё.

drkns 12.01.2011 13:14:15 +0200 - build 1784

1. Ещё пара уточнений в запускателе.

drkns 11.01.2011 21:49:13 +0200 - build 1783

1. Уточнение 1782.2.

drkns 11.01.2011 21:38:40 +0200 - build 1782

1. Ключ /rc удалён - исходное состояние консоли восстанавливается всегда.

2. Поддержка запуска команд с повышением привилегий (aka "Run as administrator") в панелях, комстроке и истории. Хоткей - CtrlAltEnter.

3. Перетрях запускателя, в связи с п. 2. Вроде бы ничего не отвалилось, но соблюдаем осторожность.

drkns 10.01.2011 21:27:48 +0200 - build 1781

1. Вернём отображение количества обработанных файлов в диалог копирования.

2. Общий индикатор копирования теперь работает и при переносе в пределах одного диска.

drkns 10.01.2011 14:20:32 +0200 - build 1780

1. Немного оптимизации: если отсутствуют плагины, экспортирующие OpenFilePlugin/Analyse, то и лишних действий (открытия/чтения/закрытия файла)
   при попытке "входа" в файл не выполняется.

2. Пара мелочей.

drkns 09.01.2011 12:50:26 +0200 - build 1779

1. При установке заведомо неправильной даты файла эта дата могла заменяться случайными значениями.

2. Более корректная интерпретация 2-значных годов.

drkns 08.01.2011 22:48:50 +0200 - build 1778

1. Не игнорируются попытки запуска файлов, тип которых неизвестен ОС.

drkns 07.01.2011 22:34:21 +0200 - build 1777

1. Mantis#0001644: Падение после "Cannot load language data".

drkns 05.01.2011 19:21:38 +0200 - build 1776

1. Уточнение 1775.

drkns 05.01.2011 10:50:10 +0200 - build 1775

1. Mantis#0001640: Необходимость сохранения строк между вызовами DialogInit и DialogFree
   Теперь Far копирует себе FarDialogItem.History и FarDialogItem.Mask, хранить их в плагине постоянно больше не нужно.

drkns 02.01.2011 12:57:22 +0200 - build 1774

1. Уточнение вывода дат в формате yyyy-MM-dd.

2. Немного почищен interf.cpp.

svs 29.12.2010 16:09:28 +0300 - build 1773

1. Mantis#0001538: Обновление панели при выполнении некоторых макрокоманд

2. Macro: добавлена функция N=Scr.Scroll(Lines[,Axis])
      Lines - Положительное число - вперёд (вниз/вправо), отрицательное - назад (вверх/влево).
      Axis - Необязательный параметр, 0 - вертикаль (по умолчанию), 1 - горизонталь.

      Функция возвращает 0 - перемотка не состоялась (например, Lines был равен 0), иначе 1

drkns 29.12.2010 11:30:42 +0200 - build 1772

1. В 1741 погнулась работа с шарами SharePoint.
   Похоже, в Microsoft кладут на собственное API.

drkns 28.12.2010 12:55:27 +0200 - build 1771

1. Продолжение 1763 - годы отображаются без ведущего нуля.

2. Изменения в DIF_MASKEDIT: Del/BS не сдвигают оставшийся текст.

3. Во время работы PrepareDiskPath() Elevation отключается.

svs 28.12.2010 09:49:18 +0300 - build 1770

1. Коррекция build 1769

2. Mantis#0001594: FAR запущеный как редактор или вьювер загружает макросы для UserMenu
   Временно отключим юзерменю в редакторовьювере...

3. Mantis#0001614: Построчный скроллинг в режиме far.exe /w
   (from DAtaMan)
   Построчное скроллирование консольного буфера клавишами Ctrl-Alt-Up/Down

   <АХТУНГ>

     После появления макро-функции scroll (http://forum.farmanager.com/viewtopic.php?f=15&t=5409)
     из менеджера будет удалена всякая обработка клавиш для скроллинга экранного буфера.

   </АХТУНГ>

4. В диалоге SetAttr дублируются хоткеии для "&Hidden" и "C&hange time:".
   Для "Change time:" хоткей будет "g".

svs 27.12.2010 12:45:54 +0300 - build 1769

1. Mantis#0001634: Иногда функция panel.item возвращает для файла пустое описание
   (from DAtaMan)
   panel.item(0,0,11) возвращает пустое значение, если не включён режим с отображением описаний или не было вызова CtrlZ

drkns 24.12.2010 10:37:23 +0200 - build 1768

1. Продолжение 1764 - время записи тоже берём у источника.

zg 20.12.2010 13:46:31 +0200 - build 1767

1. с форума:
   набираем в командной строке macro:post panel.setpath(1, "C:/") (меняем путь в пассивной панели) 
   и нажимаем F5 Enter на любом файле или папке в активной панели. 
   Получаем ошибку "Can not find the file".

drkns 19.12.2010 23:49:18 +0200 - build 1766

1. Уточнение 1763.

svs 19.12.2010 22:52:53 +0300 - build 1765

1. Mantis#0001623: Новая команда в FARMACROCOMMAND - MCMD_GETAREA - Получить текущую макрообласть
   (from Yegor)

drkns 18.12.2010 20:59:54 +0200 - build 1764

1. При "[x] Copy contents of symbolic links" в диалоге подтверждения перезаписи для симлинков отображается размер источника.

drkns 18.12.2010 18:20:53 +0200 - build 1763

1. Уточнение 1762.1 для дат в формате "Year-Month-Day".

drkns 17.12.2010 18:58:27 +0200 - build 1762

1. Поступили слухи, что в диалоге атрибутов некорректно отображались пятизначные года.

drkns 15.12.2010 22:05:28 +0200 - build 1761

1. Диалоги больше не центрируются при изменении размера консоли.

drkns 14.12.2010 16:13:10 +0200 - build 1760

1. Уточнение 1757.4.

drkns 13.12.2010 18:12:58 +0200 - build 1759

1. Откат 1756.

drkns 12.12.2010 20:01:39 +0200 - build 1758

1. Уточнение 1757.2.

drkns 12.12.2010 19:43:37 +0200 - build 1757

1. Mantis#0001618: Числовая сортировка и по остальным колонкам.

2. "Регистрозависимость" сортировки - теперь не свойство режима панели, а свойство самой панели (по аналогии с числовой сортировкой).
   Соответствующая опция переехала из диалога настройки режима панели в меню критерия сортировки.

3. В API добавлены PFLAGS_CASESENSITIVESORT и FCTL_SETCASESENSITIVESORT.

4. В debug-сборку добавлена проверка соответствия пар malloc()/free(), new/delete, new[]/delete[] для выявления ошибок типа "int* a=new int[10]; delete a;"

drkns 12.12.2010 14:30:26 +0200 - build 1756

1. В редактор не приходили некоторые мышиные события.

chupakabra 11.12.2010 16:02:00 +0200 - build 1755

1. В Editor::Block2Text выделялся слишком большой блок памяти (вплоть до полного размера файла).

drkns 10.12.2010 22:36:15 +0200 - build 1754

1. Уточнение внутренней реализации FindFirstStream.

drkns 10.12.2010 20:02:21 +0200 - build 1753

1. "[x] Automatic update of environment variables" -> "[ ] Automatic update of environment variables".

2. Уточнение console::Write().

drkns 10.12.2010 10:51:32 +0200 - build 1752

1. Опция "[x] Automatic update of environment variables".

t-rex 10.12.2010 00:06:20 +0200 - build 1751

1. Ctrl-Ins больше не копирует файлы в клипбоард, теперь этим занимается Ctrl-C.
   Ctrl-C - Поместить помеченные файлы в Буфер Обмена (без учёта состояния командной строки).

drkns 08.12.2010 23:50:39 +0200 - build 1750

1. В диалоге атрибутов опция "[ ] Обрабатывать вложенные папки" для файлов не отображается.

2. Сломалось блокирование кнопки "[ Панель ]" в результатах поиска при отсутствии соответствующих плагинов.

drkns 08.12.2010 19:07:03 +0200 - build 1749

1. С форума: В меню выбора режимов сортировки пункт Show selected first — это на самом деле Show directories first, а последний вообще не работает, даже галка не ставится.

2. С форума: Глюк при переходе в "C:\Documents and Setting\All Users"

3. С форума: Фар падает при нажатии Ctrl+Shift+End в поле ввода фиксированного размера (например, Options - Editor settings - Tab size)

drkns 07.12.2010 18:09:12 +0200 - build 1748

1. Handle leak в предыдушем билде.

drkns 07.12.2010 12:41:41 +0200 - build 1747

1. Mantis#0001615: Возможность зайти в панелях в несуществующий на диске или в сети путь

drkns 07.12.2010 11:29:41 +0200 - build 1746

1. Уточнение 1741.

drkns 07.12.2010 08:45:22 +0200 - build 1745

1. Ещё пара мелочей.

drkns 07.12.2010 01:02:52 +0200 - build 1744

1. Mantis#0001408: Paste в автодополняемое поле иногда оставляет текст "серым".

drkns 07.12.2010 00:04:33 +0200 - build 1743

1. Mantis#0001612: Установка текущего времени в диалоге изменения файловых атрибутов

drkns 06.12.2010 20:09:35 +0200 - build 1742

1. При чтении файлов местных меню от Far 1.x учитывается, что раньше разделитель задавался иначе.

drkns 06.12.2010 19:42:33 +0200 - build 1741

1. Поддержка четвёртого времени файла - "Change Time", время изменения.
   Отличие от Last Write Time в том, что Change Time обновляется при любых манипуляциях с файлом, а не только при изменении содержимого.

2. Коррекция hlf/lng - "дата/время модификации" -> "дата/время последней записи".

3. Простая глобальная защита от нехваток памяти: при неудачной аллокации вместо падения выполнение будет приостановлено с возможностью повтора или продолжения.

4. gcc warnings.

drkns 04.12.2010 11:11:27 +0200 - build 1740

1. From Tim Sobolev: коррекция заголовка окна редактора.

2. Уточнение 1738.2.

svs 03.12.2010 17:01:42 +0300 - build 1739

1. From Alexey Samlyukov: для режима far.exe /w добавлены клавиши: Ctrl-Alt-Home/End листают окно в начало/конец буфера

drkns 02.12.2010 20:06:35 +0200 - build 1738

1. Mantis№0001608: Мелкий баг при поиске дубликатов кодовых страниц

2. Коррекция типов.

drkns 01.12.2010 16:08:46 +0200 - build 1737

1. Уточнение 1729.1.

drkns 26.11.2010 23:25:10 +0200 - build 1736

1. Неправильно обрабатывался список масок, разделенный ';' и содержащий "%pathext%".

drkns 26.11.2010 20:44:41 +0200 - build 1735

1. Mantis#0001591: Добавка в FileFilterControl: Custom-фильтры

2. Не показываем ненужные элементы в диалоге создания ссылки.

yjh 26.11.2010 11:00:23 +0300 - build 1734

1. Коррекция ошибки внесённой в 1732

drkns 25.11.2010 21:15:37 +0200 - build 1733

1. From Alexey Samlyukov: флаги PFLAGS_USECRC32/OPIF_USECRC32, явно определяющие, что у элементов плагиновой панели заполнено поле CRC32.

drkns 25.11.2010 15:07:10 +0200 - build 1732

1. Уточнение 1730.1 - В Windows 7 и выше "App Paths" один.

drkns 25.11.2010 13:52:52 +0200 - build 1731

1. Не работала опция "[x] use additional privileges"

yjh 25.11.2010 14:50:16 +0300 - build 1730

1. В win64 'App Paths' в регистри надо просматривать в "двух версиях" - для
   32х и 64х битовых процессов (оне разные :)

drkns 25.11.2010 10:30:48 +0200 - build 1729

1. При переименовании/переносе опция "[ ] Обрабатывать несколько имён файлов" отключена и не используется.

yjh 25.11.2010 08:55:14 +0300 - build 1728

1. def-файл ulink'а был закоммичен в "отладочном" виде

yjh 25.11.2010 04:42:51 +0300 - build 1727

1. Редизайн vc10.asm так, что он занимает чуть меньше места :).

2. В случае компоновки ulink'ом не используем vc10 - вместо этого делаем
   эти 2 процедуры в режиме delayload и "подменяем" их только в ситуации
   когда они не проимпортировались.
     Такой разнице в поведении 3 причины: этот вариант более корректный,
   ulink запрещает "прямое использование" __imp_ префиксов у имён (это 
   редкостная экзотика, а вот ошибки такие случаются), ну и, наконец,
   ms-link не поддерживает partial delyay load.

drkns 23.11.2010 20:39:55 +0200 - build 1726

1. From Alexey Samlyukov: не работал FreePluginDirList.

2. From Alexey Samlyukov: GetPluginDirList умеет работать с пассивной панелью.

drkns 22.11.2010 22:20:00 +0200 - build 1725

1. Для VC2010-билда минимальные системные требования теперь не XP SP3, а 2k SP4 + KB816542.

drkns 22.11.2010 14:27:37 +0200 - build 1724

1. Mantis#0001600: Не входит в 'C:\Users\<User>\Application Data'

2. Пара мелочей.

drkns 17.11.2010 00:12:50 +0200 - build 1723

1. Опечатка в 1722.

drkns 16.11.2010 19:14:24 +0200 - build 1722

1. Убираем из копира поддержку переименования файла в своё SFN - реализация приводит к глюкам при обычном переименовании.

2. Попытка переименования файла в то же самое имя теперь автоматически считается удачной и не приводит к ошибке "Нельзя копировать файл в самого себя".

3. SFN в панелях отображаются в правильном регистре.

4. По просьбам телезрителей - FarRecursiveSearch не ищет по SFN.

5. Оптимизация некоторых api*-обёрток.

drkns 15.11.2010 13:47:00 +0200 - build 1721

1. С форума: "Проблема при записи макроса".

t-rex 12.11.2010 21:32:19 +0200 - build 1720

1. Mantis#1527: В истории ввода помеченные пункты не остаются вверху выпадающего списка и могут быть из него удалены как устаревшие.

drkns 12.11.2010 19:39:44 +0200 - build 1719

1. Уточнение 1718.

drkns 12.11.2010 13:47:00 +0200 - build 1718

1. Mantis#0001587: Поломался переход far:goto "c:\long path"

drkns 12.11.2010 07:53:51 +0200 - build 1717

1. Поправка 1715.3.

drkns 11.11.2010 11:11:11 +0200 - build 1716

1. Продолжение 1715.3. Для gcc минимальная версия w32api теперь 3.15.

drkns 10.11.2010 20:50:52 +0200 - build 1715

1. Уточнение надписей в диалоге создания ссылок

2. Mantis#0000329: Изменить цвета по умолчанию для Неизмененного текста
   Ну и для единообразия в комстроке выделение теперь cyan, a не gray.

3. Выкинут мусор из headers.hpp.

ts 09.11.2010 22:43:29 +0200 - build 1714

1. Macro: BM.back() теперь выполняет функции, ранее принадлежавшие BM.prev()
   BM.prev() выполняет только ожидаемую функцию возврата на предшествующую закладку

svs 08.11.2010 18:07:58 +0300 - build 1713

1. Macro: Удалены BM.first() и BM.last(). Вносили избыточность функционала...

   <АХТУНГ>

     вместо BM.first использовать BM.goto(1) 
     вместо BM.last  использовать BM.goto(BM.stat(0))
   
   </АХТУНГ>

2. Macro: уточнение работы (точнее отсутствия онной) Menu.XXX в диалогах со списками.

drkns 08.11.2010 16:10:32 +0200 - build 1712

1. Обход идиотского бага древних Windows:
   Конструкция ExpandEnvironmentStringsW(L"%__CD__%", NULL, 0); вызывала AV в ntdll:RtlExpandEnvironmentStrings_U.
   Плюс немного оптимизации.

ts 06.11.2010 20:45:04 +0200 - build 1711

1. Уточнение 1710.

svs 05.11.2010 16:50:49 +0300 - build 1710

1. Macro: добавка к букмаркам (from: Tim Sobolev)
    N=BM.first() - переход на первую закладку
    N=BM.last() - переход на последнюю закладку
    N=BM.goto([pos]) - переход на закладку с указанным индексом (pos=0 или не указан --> текущую)
    N=BM.push() - сохранить текущую позицию в виде закладки в конце стека
    N=BM.pop() - восстановить текущую позицию из закладки в конце стека и удалить закладку

  Добавка к BM.stat(I) - для I=1 возвращается индекс текущей закладки (0 если закладок нет)

  Примечание для BM.add() и BM.prev()

  Если была выполнена операция BM.add() и после неё BM.prev(), произойдёт
  следующее:

  а) Если текущая позиция в редакторе соответствует позиции, сохранённой в
  BM.add(), то произойдёт переход на предшествующую, созданной BM.add(),
  закладку.
  б) Если текущая позиция в редакторе не соответствует позиции, сохранённой в
  BM.add(), то текущая позиция будет сохранена и произойдёт переход на закладку,
  созданную BM.add().


drkns 03.11.2010 10:15:20 +0200 - build 1709

1. Уточнение 1708.

drkns 31.10.2010 22:24:07 +0200 - build 1708

1. Экспериментально:
   - дополнение умеет работать не с начала строки ("cd c:\wi" и т.п.).

drkns 30.10.2010 20:37:40 +0200 - build 1707

1. Не работало копирование симлинков с атрибутом "только для чтения".

drkns 28.10.2010 16:48:32 +0200 - build 1706

1. Mantis#0001559: Ошибка Cannot find the file после смены папки из истории папок

svs 27.10.2010 13:23:28 +0300 - build 1705

1. Macro: коррекция поведения Selected, Bof, Eof, Empty.
   Теперь работают, как заявлено в Писании.

zg 27.10.2010 12:47:55 +0200 - build 1704

1. gcc build.

svs 26.10.2010 12:25:02 +0300 - build 1703

1. Первое приближение Mantis#0000466. Временно обернуто в PROCPLUGINMACROFUNC (в обычной сборке недоступно)

2. Перетасовка коде между macro.cpp и syntax.cpp
   Введено (внутренне) понятие "регистрация функции".

drkns 26.10.2010 00:45:47 +0200 - build 1702

1. По просьбам телезрителей: откат отката.
   Вернём назад опцию про привилегии, + теперь она по умолчанию выключена.

drkns 25.10.2010 21:39:28 +0200 - build 1701

1. Откат 1699.

drkns 25.10.2010 11:56:14 +0200 - build 1700

1. При VCTL_GETINFO возвращалось некорректное значение ViewerInfo::WindowSizeY.

drkns 24.10.2010 20:35:03 +0200 - build 1699

1. Отдельная опция для управления использованием дополнительных привилегий.

drkns 23.10.2010 00:21:14 +0200 - build 1698

1. При запуске bat-файла вида:

@echo off
cls
echo 1
echo 2
echo 3

- не отображались первые два пункта.

drkns 21.10.2010 11:57:27 +0200 - build 1697

1. Вайп симлинка портил файл, на который он ссылался.

drkns 20.10.2010 11:42:42 +0200 - build 1696

1. Включение/выключение запросов повышения прав вынесено в интерфейс.

drkns 20.10.2010 10:45:45 +0200 - build 1695

1. Mantis#0001557: Неверный показ атрибутов symlink

2. Некорректное отображение диалога атрибутов для случая, когда элемент одновременно является и жесткой и символической ссылкой.

drkns 15.10.2010 13:23:23 +0200 - build 1694

1. PluginInfo::DiskMenuNumbers -> PluginInfo::Reserved0.

drkns 15.10.2010 09:22:33 +0200 - build 1693

1. Уточнение 1692.

drkns 14.10.2010 20:01:32 +0200 - build 1692

1. Экспериментально:
   - горячие клавиши для плагинов в меню выбора диска теперь задаются не плагинами, а пользователем по F4.
   - в качестве горячей клавиши может выступать не только цифра, но и любой другой уникодный символ.

drkns 06.10.2010 19:59:59 +0200

1. ASLR.

drkns 03.10.2010 14:28:31 +0200 - build 1691

1. Уточнение 1683.

drkns 03.10.2010 00:28:13 +0200 - build 1690

1. Ошибка в обработке elevation-варианта SetFilePointerEx.

drkns 02.10.2010 23:36:23 +0200 - build 1689

1. Mantis#0001525: Copy folders with symbolic links (to other folders) inside

t-rex 01.10.2010 20:30:56 +0200 - build 1688

1. Mantis#1522: Лишний слеш в заголовке панели.
   Баг тут немного не в том. Мы конечно можем обрабатывать (удалять) эти слэши но этим как бы бессмысленно заниматься,
   и как раз то что часть из них удалилась это и есть баг.

t-rex 01.10.2010 08:21:10 +0200 - build 1687

1. Mantis#1520: crash on cd %tmp%
   Коррупция хипа в PrepareDiskPath(). За одно сделал мелкие оптимизации там же.

t-rex 01.10.2010 04:17:16 +0200 - build 1686

1. В случае "preloaded" плагина который требует более новый фар (GetMinFarVersion) сообщение об ошибке загрузки показывалось два раза.

chupakabra 30.09.2010 21:33:00 +0200 - build 1685

1. Поправка для 1684

chupakabra 30.09.2010 21:16:00 +0200 - build 1684

1. Mantis#0001514: Некорректная работа ConvertPath(CPM_REAL, ...) на DFS
   В internalNtQueryGetFinalPathNameByHandle() добавлена простая обработка сетевых путей.

drkns 28.09.2010 13:47:00 +0200 - build 1683

1. Хоткей для редактора F4 == "выход", по аналогии с вьювером.

2. Пара мелочей в elevation.

svs 27.09.2010 16:59:30 +0300 - build 1682

1. Mantis#0001512: Не срабатывают автостартующие макросы

2. Macro: mmode(2) - вернуть информацию (область и флаги) об условиях запуска "этой" макропоследовательности (исполняемой сейчас).
    Функция возвращает в младшем байте номер макрообласти, из которой стартовал макрос:

         0 - Other           -  Режим копирования текста с экрана, вертикальные меню
         1 - Shell           -  Файловые панели
         2 - Viewer          -  Внутренняя программа просмотра
         3 - Editor          -  Редактор
         4 - Dialog          -  Диалоги
         5 - Search          -  Быстрый поиск в панелях
         6 - Disks           -  Меню выбора дисков
         7 - MainMenu        -  Основное меню
         8 - Menu            -  Прочие меню
         9 - Help            -  Система помощи
        10 - Info            -  Информационная панель
        11 - QView           -  Панель быстрого просмотра
        12 - Tree            -  Панель дерева папок
        13 - FindFolder      -  Поиск папок
        14 - UserMenu        -  Меню пользователя
        15 - AutoCompletion  -  Список автодополнения
       255 - Common          -  Общая область

    остальные значения - флаги условий запуска (в т.ч. некоторые служебные флаги)

       Условия запуска:
         0x00000200 - НЕ передавать плагинам клавиши во время записи/воспроизведения макроса
         0x00000800 - этот макрос запускается при старте ФАРа
         0x00001000 - запускать, если командная линия пуста
         0x00002000 - запускать, если командная линия не пуста
         0x00004000 - запускать, если есть выделение в редакторе
         0x00008000 - запускать, если есть нет выделения в редакторе
         0x00010000 - активная:  запускать, если есть выделение
         0x00020000 - пассивная: запускать, если есть выделение
         0x00040000 - активная:  запускать, если есть нет выделения
         0x00080000 - пассивная: запускать, если есть нет выделения
         0x00100000 - активная:  запускать, если это плагиновая панель
         0x00200000 - пассивная: запускать, если это плагиновая панель
         0x00400000 - активная:  запускать, если это файловая панель
         0x00800000 - пассивная: запускать, если это файловая панель
         0x01000000 - активная:  запускать, если текущий объект "файл"
         0x02000000 - пассивная: запускать, если текущий объект "файл"
         0x04000000 - активная:  запускать, если текущий объект "папка"
         0x08000000 - пассивная: запускать, если текущий объект "папка"
                                                                                              
       Доп.инфа:
         0x00000100 - подавить обновление экрана во время выполнения макроса
         0x10000000 - текст макроса многострочный (REG_MULTI_SZ)
         0x40000000 - этот макрос необходимо запомнить при сохранении макросов
         0x80000000 - этот макрос отключен (помеченные этим флагом макросы не запускаются - ни с клавиатуры, ни из eval())

       TODO: последние 2 флага в принципе возможно сделать не ReadOnly

    Так же перетасовал значения MACROFLAGS_MFLAGS и удалил неиспользуемый MFLAGS_REUSEMACRO.

svs 23.09.2010 00:26:57 +0300 - build 1681

1. Mantis#0001508: Падение Far при выполнении макроса на медленно обновляемой панели
   Во время вызова макрофункций Panel.SetPos(), panel.SetPath() и Panel.SetPosIdx() макросы замораживаются
   до момента выполнения этих функций: на "больших" каталогах (например, сетевые, с большим количеством 
   файловых объектов и/или медленных каналах) эти функции могут выводить сообщения о процессе сбора 
   данных о файлах/каталогах, с возможностью отменить процесс по Esc.

   TODO: Сейчас в код добавлены куски кода, убирающие перед работой функций лочку экрана (и выставляющие 
         ее обратно, после исполнения) - см. между тэгами <Lock?> и </Lock?>.
         Это решение позволяет "увидеть" тот самый месаг о процессе сбора данных.
         Здесь "непонятки" - нужны ли эти куски?
         * если нужны, то возникает ситуация для случая, когда месаг появился и 
           юзер прервал сканирование... незаконченная транзакция
         * если не нужны, то ситуация обратная - пользователь для такого макроса 
           будет видеть не реагирующий ни на что Far (до момента завершения сканирования каталога)

drkns 21.09.2010 20:38:32 +0200

1. Очередная неполноценность gcc-хидеров.

warp 21.09.2010 00:30:00 +0100 build 1680

1. Случайно просочилось левое во враппер. Возвращаю.

warp 21.09.2010 00:15:00 +0100 build 1679

1. Экспериментально. Добавлена поддержка определения BD-ROM (раньше работало 
   плохо), BD-RW, HDDVD, HDDVD-RW.

2. Выкинул функцию определения типа привода по формату носителя. Это какое-то 
   уж слишком сильное колдунство.

drkns 18.09.2010 19:11:51 +0200 - build 1678

1. From svs:  По мотивам Mantis#0000928. У редактора и вьюверю в макросах состояние Modal так же выставляется.

2. From svs: неправильно позиционировалось меню по CtrlF12.

3. В plugin.hpp раскомментированы флаги XLAT_USEKEYBLAYOUTNAME и XLAT_CONVERTALLCMDLINE.

4. x64 warnings.

svs 17.09.2010 17:13:31 +0300 - build 1677

1. Mantis#0001502: Выделение элементов в меню режимов сортировки (Ctrl-F12)
     Клавиша #+# устанавливает прямую сортировку.
     Клавиша #-# устанавливает обратную сортировку.
     Клавиша #*# меняет сортировку на обратную.

t-rex 17.09.2010 12:49:19 +0200 - build 1676

1. Неправильная обработка oldfar::DM_GETTEXT при oldfar::FarDialogItemData.PtrLength==0.
   Надо удалить такое поведение в 2.0 API.

drkns 17.09.2010 10:53:53 +0200 - build 1675

1. Ошибка в логике расшифровки файлов при копировании.

drkns 16.09.2010 20:12:34 +0200 - build 1674

1. Уточнение 1511 билда: заголовок редактора "насовсем" меняется только для юникодных плагинов.

svs 16.09.2010 17:50:23 +0300 - build 1673

1. Mantis#0001504: Обеспечить возможность издавать звук в зависимости от раскладки
   Добавлены функции (macro):
	N=beep([N])
	  Здесь параметр (как у функции WinAPI MessageBeep):
		MB_ICONASTERISK = 0x00000040
			Звук Звездочка
		MB_ICONEXCLAMATION = 0x00000030
			Звук Восклицание
		MB_ICONHAND = 0x00000010
			Звук Критическая ошибка
		MB_ICONQUESTION = 0x00000020
			Звук Вопрос
		MB_OK = 0x0
			Стандартный звук
		SIMPLE_BEEP = 0xffffffff
			Встроенный динамик
	  Возвращает 1 или 0 (в случае неудачи)

	Прочие "извращения" со звуком - через плагины (после "решения" Mantis#0000466)

	N=kbdLayout([N])
	  Работа с раскладками клавиатуры
	  Параметр N:
		а) конкретика: 0x0409 или 0x0419 или...
		б) 1 - следующую системную (по кругу)
		в) -1 - предыдущую системную (по кругу)
		г) 0 или не указан - вернуть текущую раскладку.
 
	  Возвращает 0 в случае ошибки или предыдущую раскладку (для параметра N=0 - текущую)
	  Ошибки: не удалось определить имя текущей раскладки для консоли или не удалось получить хэндл консольного окна.

	  В случае указания конкретной НЕ существующей раскладки функция ошибку не выдаст и просто вернет текущую раскладку.

	Например,
	  print(itoa(kbdLayout(0x421),16))
	    При текущей русской раскладке просто вернет 4190419
	  print(itoa(kbdLayout(),16))
	    При текущей русской раскладке вернет 4190419
	  print(itoa(kbdLayout(0x409),16))
	    При текущей русской раскладке вернет 4190419 и переключит раскладку на английскую
	  print(itoa(kbdLayout(1),16))
	    При текущей русской раскладке вернет 4190419 и переключит на следующую раскладку (по кругу)

2. Macro: Удалена макрокоманда $KbdSwitch
   <АХТУНГ>

     Замените у себя $KbdSwitch на kbdLayout(1)
   
   </АХТУНГ>

3. Mantis#0001423 - Узнать состояние пункта меню
   Уточнение про состояние Checked.

   Теперь функция Menu.ItemStatus() возвращает в старшем слове символ пометки (U+XXXX)
   Если выставлен флаг 0x2 и старшее слово равно 0, то Far использует свой символ (0x221A)
   Если выставлен флаг 0x2 и старшее слово не равно 0, то Far использует символ пометки из старшего слова
   Если НЕ выставлен флаг 0x2 и старшее слово не равно 0, то это нишиша не обозначает

chupakabra 14.09.2010 21:33:00 +0200 - build 1672

1. Mantis#0000840: включаем Low-fragmentation Heap для CRT heap.

drkns 14.09.2010 09:58:33 +0200 - build 1671

1. Неправильно обрабатывались метасимволы вида !?$history$(!.!)?!

drkns 13.09.2010 11:30:02 +0200 - build 1670

1. Уточнение 1669 :)

drkns 13.09.2010 11:28:01 +0200 - build 1669

1. Потерялась строка в imports.cpp

warp 10.09.2010 23:39:00 +0300 - build 1668

1. Исправление в ProcessName(PN_GENERATENAME), теперь должен работать ProxyFTP через 
   враппер (при соответствующей версии враппера).

drkns 10.09.2010 19:45:44 +0200 - build 1667

1. Mantis#0001497: EditorControl (ECTL_GETBOOKMARKS) работает неправильно.

2. Mantis#0001498: Курсор не прячется при утаскивании диалога за пределы экрана.

drkns 09.09.2010 09:50:09 +0200 - build 1666

1. Mantis#0001495: Ошибка при поиске (AltF7) в %PATH%.

chupakabra 05.09.2010 14:33:00 +0200 - build 1665

1. При PutFilesW()=1 не устанавливаем курсор на каталоги.

chupakabra 02.09.2010 19:41:00 +0200 - build 1664

1. Откат 1661.

drkns 31.08.2010 12:40:01 +0200 - build 1663

1. Т.к. setupapi.dll есть везде - линкуем статически.
   Там же: несколько функций CM_* заменены на рекомендуемые SetupDi*-аналоги.

2. Коррекция lng.

zg 30.08.2010 01:25:01 +0200 - build 1662

1. добавлен гуид диалогу перемещения/переименования. раньше гуид совпадал с гуидом диалога копирования.

chupakabra 26.08.2010 22:54:00 +0200 - build 1661

1. Всегда передаем в GetFilesW полный путь.

chupakabra 26.08.2010 22:22:00 +0200 - build 1660

1. ACTL_PROGRESSNOTIFY - Far выполняет стандартное оповещение о завершении операции (мерцание кнопкой в таскбаре).

drkns 26.08.2010 21:02:33 +0200 - build 1659

1. Уточнение работы DN_GETDIALOGINFO.

2. Косметика в hotplug.cpp.

drkns 27.08.2010 09:50:32 +0200

1. Spanish translation (lng file) from Mauro72.

svs 26.08.2010 07:50:23 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal
   Обновлен PluginW.pas

zg 25.08.2010 12:12:25 +0200 - build 1658

1. добавлены гуиды диалогам:
   - вопрос о перезаписи r/o файла. раньше гуид совпадал с гуидом обычного диалога перезаписи.
   - копирование файла.
   - создание жёстких связей

svs 25.08.2010 12:40:09 +0300 - build 1657

1. Panel API: добавлены FCTL_GETPANELFORMAT и FCTL_GETPANELHOSTFILE.
   (Mantis#0001472: Добавить FCTL_GETPANELFORMAT, FCTL_GETPANELHOSTFILE)

svs 25.08.2010 11:17:55 +0300 - build 1656

1. Mantis#0001471: QuickView в панели плагина показывает случайную информацию о каталогах
   Для плагинов уберем показ некоторых параметров папок (выводится нереальный мусор)

2. Первый этап перелопачивания FolderShortcuts
    - Функции GetShortcutFolder() и SaveFolderShortcut() понятия не имеют что такое "клавиша".
    - математика реагирования на RCtrl[Shift]-0..9 вынесена из FileList::ProcessKey() в class Panel в виде функций ExecShortcutFolder() и SaveShortcutFolder().
    - про функцию GetShortcutFolderSize() забыли - остатки роскоши былой.

zg 24.08.2010 20:38:59 +0200 - build 1655

1. добавлены гуиды диалогам:
   - открытие файла в редакторе.
   - сохранение файла в редакторе.
   - создание папки.
   - установка атрибутов.

drkns 23.08.2010 19:54:28 +0200 - build 1654

1. Автодополнение работает и для путей вида %env%\foo.

drkns 22.08.2010 08:30:54 +0200 - build 1653

1. При определении виртуальных дисков обрабатываются только жёсткие диски.

svs 21.08.2010 23:18:55 +0300 - build 1652

1. Macro: добавлен термин "точная строка" ("verbatim string", как в C#)
   Точная строка начинается со знака @ и заключена в двойные кавычки.
   В ней escape-последовательности не обрабатывается, что позволяет использовать такую строку там, где
   последовательность формируется с применением метасимволов, например в UserMenu. Например, в пути заменяем все '\' на '/'
    print(replace(@"!\!.!", @"\", ""))
   Чтобы включить знак двойной кавычки в "точную строку", следует использовать знак кавычек дважды:
     @"""Слово!"" в двойных кавычках."

svs 21.08.2010 11:00:41 +0300 - build 1651

1. Macro: не работала функция mload()

zg 20.08.2010 18:10:13 +0200 - build 1650

1. Mantins#0001469: Editor Word Completion перестал понимать нажатие Right.

drkns 20.08.2010 15:08:21 +0200 - build 1649

1. В меню дисков работает отсоединение виртуальных дисков по Del.

drkns 19.08.2010 23:07:06 +0200 - build 1648

1. Кто-то внедрил хитрую оптимизацию: получать путь к временной папке при старте, сохранять в переменную и использовать в дальнейшем.
   В результате переопределение этого пути обходило нас стороной.

drkns 19.08.2010 20:21:57 +0200 - build 1647

1. Поправка к 1646.

drkns 19.08.2010 19:36:20 +0200 - build 1646

1. В меню смены диска опознаются виртуальные (VHD) жёсткие диски. Опционально отображается имя VHD-контейнера.
   Работает в Windows 7/Windows Server 2008 R2 и выше.

2. Несколько ненужных IsProcessAssignMacroKey и ещё по мелочи.

svs 19.08.2010 14:56:31 +0300 - build 1645

1. Macro: добавлена функция N=mload(S) 
     считать из реестра (область Vars) переменную S
     вернет 1 - есть такая переменная и она успешно считана в память
            0 - нет такой переменной в реестре, переменная не создается,
                если переменная была в памяти, а из реестра стерли, то значение в памяти не изменяется.
     функция понимает REG_SZ, REG_MULTI_SZ, REG_DWORD и REG_QWORD.

svs 18.08.2010 22:31:22 +0300 - build 1644

1. Mantins#0001305: wish: Show some cols of Find window
   Настройка колонок находится в диалоге "Find file advanced options" (в поисковике кнопка "Advanced")
   Синтаксис типов колонок - как у панелей.
   Отличия и ограничения - описаны в хелпе к диалогу "Find file advanced options".

   Про развитие:
     1. сделать, что бы список формировал строку вывода (сейчас списку готовую строку подсовывают)
     2. после этого добавить еще 9 режимов отображения и снять ограничение на имя ("всегда в конце")
     4. в итоге можем получить динамичное переключение режимов отображения результатов по Ctrl-цифра (как в панелях)
   
2. Попутно бага нашлась - в колонке "G" для ".." показывалась какая то ерунда.

3. ViewSettingsToText() и  TextToViewSettings() более не члены класса FileList

drkns 17.08.2010 20:15:03 +0200 - build 1643

1. При перемещении в корзину соответствующая кнопка диалога подтверждения подписывается как "move", а не "delete".

drkns 16.08.2010 18:27:26 +0200 - build 1642

1. Доработка меню для OpenFilePlugin:
   - "Even if only one plugin found" зависит от "Show standard association item";
   - отдельная настройка для ShiftF1;
   - для ShiftF1 пункт "standard association" не показывается.

drkns 09.08.2010 13:47:00 +0200 - build 1641

1. Mantis#0001459: проблема с Drag and Drop files

2. Уточнение работы NTPath. Больше не должно появляться ситуаций, подобных M#0001458. Также теперь работают пути вида "C:\\\\\Dir1////Dir2".

3. При считывании каталога перерисовка и опрос консоли производится как везде - каждые 200 мс, а не после каждых 64 файлов. Там же: убрано ненужное сообщение после отмены считывания.

drkns 09.08.2010 12:27:32 +0200 - build 1640

1. Забытый отладочный код :)

drkns 07.08.2010 00:20:54 +0200 - build 1639

1. Mantis#0001455: Очень большая задержка при отмене копирования на сетевой диск.

drkns 05.08.2010 23:30:53 +0200 - build 1638

1. Уточнение 1633.2.

svs 05.08.2010 15:50:06 +0300 - build 1637

1. Mantis#0001451: Странности MCMD_CHECKMACRO
   Виснет при старте для "пустышки"
     "Sequence"="\"\""

drkns 05.08.2010 14:15:16 +0200 - build 1636

1. При < сохранении файла встроенным редактором | обновлении файла описаний | редактировании локального меню > не теряются альтернативные потоки данных.

2. Mantis#0001443: Неудобная реакция на клик мышкой в окне поиска.

3. FindFirstFile -> FindFirstFileEx. В Windows 7/2008 R2 возможно некоторое ускорение просмотра папок.

svs 04.08.2010 11:45:04 +0300 - build 1635

1. Mantis#0001451: Странности MCMD_CHECKMACRO
   Доработаем UserDefinedList.

yjh 31.07.2010 07:09:58 +0300 - build 1634

1. Уж не знаю кто "боролся" с диагностикой приведения BOOL к bool после 
   тернарной операции, но, в результате и диагностика осталась и получился
   нерабочий конструкт.

drkns 30.07.2010 23:47:23 +0200 - build 1633

1. При копировании каталогов теперь сохраняются их альтернативные потоки данных.

2. Прибита логика "если копируем каталог и включён фильтр и файлы в фильтр не попали, то пустой каталог не нужен".

t-rex 30.07.2010 21:27:16 +0200 - build 1632

1. From Max Moysyuk: дополнительная правка для Mantis#1419: Очень длительный переход на локальный диск (AltF1/AltF2).

2. GCC ворнинги.

drkns 29.07.2010 21:09:20 +0200 - build 1631

1. Mantis#0001443: Неудобная реакция на клик мышкой в окне поиска.

2. Mantis#0001449: Сообщение об ошибке смены диска не влезает в консоль.

3. Кнопки "Go to", "View" и  "Panel" в диалоге поиска блокируются, если ничего не нашли.

4. Кнопка "Filter" в диалогах копирования и поиска блокируется, если не включена опция "[ ] Use filter"

drkns 28.07.2010 10:00:00 +0200 - build 1630

1. Изменения в usermenu.
   - разделителем теперь считается пункт с горячей клавишей "--" и любой меткой.
   - горячая клавиша "-" теперь всегда считается горячей клавишей "-".

2. Подсократим число восклицаний!!!111 в языковых файлах.

drkns 27.07.2010 17:44:36 +0200 - build 1629

1. Mantis#0001447: Виснем при переходе к файлу после поиска

svs 27.07.2010 14:18:55 +0300 - build 1628

1. Mantis#0001446: функция Date() возвращает 0

drkns 26.07.2010 21:21:04 +0200 - build 1627

1. Не работало создание символических ссылок из-под ограниченной учётной записи в 64-битных ОС.

drkns 26.07.2010 13:33:33 +0200 - build 1626

1. При CtrE/CtrlX/Up/Down/MsWheelUp/MsWheelDown в комстроке автодополнение больше не включается.

2. Mantis#0001443: Неудобная реакция на клик мышкой в окне поиска.

drkns 21.07.2010 16:41:47 +0200 - build 1625

1. Mantis#0001438: Far 2.0.1624: Изменение поведения редактора по сравнению с 1623 (и до).

drkns 20.07.2010 22:08:47 +0200 - build 1624

1. Mantis#0001437: Far 2.0.1623: Пример изменения поведения редактора.

2. Уточнение 1609.2: CF_HDROP используется только для "стандартного" CtrlIns, <CtrlShift|CtrlAlt|AltShift>Ins копируют только текст.

drkns 20.07.2010 01:21:33 +0200 - build 1623

1. Аттракцион невиданной щедрости. Цикличный вызов ECTL_GETSTRING работает в 100500 раз быстрее. Просто так, без ритуальных приседаний с ECTL_SETPOSITION + ECTL_GETSTRING(-1).

t-rex 16.07.2010 20:13:36 +0200 - build 1622

1. "Show total copy progress indicator" on by default.

svs 16.07.2010 10:03:22 +0300 - build 1621

1. Начало "Ахтунгов" в макросах (см. комментарий к 1454 и 1455).

   * удалена команда $Date
       заменить на print(Date(блаблабла_или_пусто))
   
   * удалена команда $MMode
       заменить на mmode(1,2)
   
   * удалено состояние IClip
       заменить на clip(5,-1) (при этом учесть, что clip() вернет 1 или 2)
   
   * удалена команда $IClip
       заменить на clip(5,0) или просто clip(5)

   * удалено состояние DisableOutput (не флаг макроса!)
       заменить на вызов функции mmode(1,-1)

drkns 15.07.2010 13:47:00 +0200 - build 1620

1. Перетасовка настроек:
   Диалог "Plugin selection" вырос до "Plugins manager", сюда же переехал "Path for personal plugins" и добавлена пара новых опций:
   "OEM plugins support" - глобальное включение/отключение поддержки старых плагинов;
   "Scan symbolic links" - загружать/не загружать плагины из ссылок.

2. Уточнение 1616.1.

drkns 15.07.2010 10:00:00 +0200 - build 1619

1. x64.

drkns 15.07.2010 10:00:00 +0200 - build 1618

1. Небольшая оптимизация ScreenBuf::MoveCursor()

drkns 14.07.2010 18:04:04 +0200 - build 1617

1. Уточнение алгоритма блочной записи/чтения консоли.

drkns 12.07.2010 19:38:29 +0200 - build 1616

1. Расширена функциональность диалога ошибки смены диска - теперь можно не отходя от кассы выбрать более другой диск.

t-rex 12.07.2010 10:45:46 +0200 - build 1615

1. Mantis#1432: проблемы сборки в gcc.

svs 12.07.2010 10:44:28 +0300 - build 1614

1. Mantis#0001412: F1 при просмотре *.hlf

drkns 09.07.2010 13:04:33 +0200 - build 1613

1. Переменная faradminmode наследовалась от родительского процесса.

t-rex 08.07.2010 20:10:14 +0200 - build 1612

1. Исправление 1607 (http://forum.farmanager.com/viewtopic.php?p=65440#p65440).

t-rex 08.07.2010 19:29:44 +0200 - build 1611

1. И ещё раз, Mantis#1429: Некоректная работа при открытии через "... | far.exe /v -"
   apiCreateFile() добавляет флаги (может это всё таки убрать а то не очевидно совсем?),
   а CONIN$ можно открывать только с очень определёнными флагами.

drkns 06.07.2010 16:47:23 +0200 - build 1610

1. Продолжение 1609: содержимое CF_HDROP-буфера может вставляться в редактор/строки ввода в виде текста.

drkns 06.07.2010 13:55:22 +0200 - build 1609

1. Пара багов в установке атрибутов.

2. В порядке эксперимента: при копировании с панели имён файлов в буфер обмена используется также формат CF_HDROP,
   что позволяет "вставлять" эти файлы из буфера в более других программах (проводник и т. п.).
   Обратная операция (копировать "там" и вставлять "здесь") пока не поддерживается, но всё возможно.

t-rex 08.07.2010 00:34:21 +0200 - build 1608

1. From Max Moysyuk: Mantis#1419: Очень длительный переход на локальный диск (AltF1/AltF2)

t-rex 08.07.2010 00:12:29 +0200 - build 1607

1. Mantis#1428: Падение при FCTL_SETNUMERICSORT.

drkns 06.07.2010 22:36:48 +0200 - build 1606

1. при определении типа CD-привод кроме чтения зачем-то открывался ещё на запись.

svs 06.07.2010 18:00:12 +0300 - build 1605

1. Mantis#0000986: Far 2 API - pascal
   Обновлены FarColorW.pas, FarKeysW.pas и PluginW.pas

2. Mantis#0000968: waitkey() пропускает AltIns

drkns 05.07.2010 11:00:00 +0200 - build 1604

1. В диалоге создания ссылок доступен ещё один "тип" символических ссылок - без явного указания, файл это или папка.
   Нужный вариант выбирается автоматически по атрибутам объекта, на который указывает ссылка.

2  В FSF.MkLink доступен флаг FLINK_SYMLINK, автоматически выбирающий тип символической ссылки.

drkns 02.07.2010 16:17:18 +0200 - build 1603

1. Mantis#0001425: глюк после сброса настроек раскраски файлов

t-rex 02.07.2010 15:20:09 +0200 - build 1602

1. Снова поломался "far /v -".

svs 02.07.2010 11:22:10 +0300 - build 1601

1. Mantis#0000926: Eval() устанавливает DisableOutput=1
   функция KeyMacro::GetCurRecord() не те данные возвращала (вместо данных из рабочего макроса брала библиотечный код)

2. Mantis#0001423: Узнать состояние пункта меню
     N=Menu.ItemStatus([N]);

     Вернуть состояние N-го пункта меню (N - 1-based), или текущего пункта, если N==0 или не указан.

     Работает в абсолютном пространстве пунктов меню (без учета фильтров пр. механизмов сокрытия)
     
     Возвращает набор флагов:
       0x00000001 - Selected (текущий пункт)
       0x00000002 - Checked (отображена метка выбора)
       0x00000004 - Separator (пункт является разделителем)
       0x00000008 - Disabled (пункт недоступен)
       0x00000010 - Grayed ("серый")
       0x00000020 - Hidden (скрыт фильтром)

       0xFFFFFFFF - нету нишиша/ошибка (N вне диапазона наличности)

     TODO (после реализации Mantis#0001422):
       0x00000040 - Hotkey present (имеет хоткей)
       0x00000080 - Hotkey manual (хоткей был назначен юзером)

drkns 01.07.2010 22:20:00 +0200 - build 1600

1. Mantis#0001420: far manager не запрещает винде хибернейт во время копирования(перемещения).

t-rex 30.06.2010 21:21:26 +0200 - build 1599

1. Ещё один перетрях CacheRead (надеюсь последний),
   починило дофига разных мистических глюков при поиске в просмотре в больших файлах в последних билдах.

svs 29.06.2010 15:01:56 +0300 - build 1598

1. Mantis#0001416: waitkey(0,0) не реагирует на клики мышки с модификаторами

2. Macro: ошибка парсера функций с необязательными элементами.
   "...наткнулся на неработоспособность макроса msgbox(menu.value,gethotkey()) в таком сочетании menu.value ничего не возвращает..."
   (возможно нужно уточнение)

t-rex 27.06.2010 13:43:59 +0200 - build 1597

1. Поиск во вьювере в общем не работал для больших файлов.

2. GCC ворнинг.

t-rex 26.06.2010 21:03:19 +0200 - build 1596

1. Grey+/- во въювере приводили к не совсем ожидаемым результатам.

drkns 26.06.2010 16:28:50 +0200 - build 1595

1. Не работал запуск из истории внешних команд просмотра/редактирования.
   Причём лет 5 уже.

chupakabra 24.06.2010 14:34:00 +0200 - build 1594

1. Форсируем отображение имени первого обрабатываемого файла при установке атрибутов
   (иначе при установке атрибута Compressed для больших файлов отображается пустое поле).

drkns 16.06.2010 13:47:00 +0200 - build 1593

1. После 1583 вьювер тормозил при работе по сети.

2. Мигаем таскбарной кнопкой 5 раз, а не бесконечно.

drkns 16.06.2010 11:21:12 +0200 - build 1592

1. Более быстрая реализация File::Eof()

2. Немного bool.

drkns 16.06.2010 18:56:32 +0200 - build 1591

1. Mantis#0001409: Падение во время удаления папки.

2. Глюк в хелпе.

t-rex 15.06.2010 00:05:09 +0200 - build 1590

1. В CtrlF12 добавлена возможность сортировать по Custom data.

t-rex 14.06.2010 00:56:58 +0200 - build 1589

1. Mantis#1405: После cls на экране остаётся C:\>cls

t-rex 12.06.2010 19:14:06 +0200 - build 1588

1. Экспериментально, неофициально и криво на посмотреть, поиграться и подумать:
   поддержка кастом колонки (C0) заполняемой плагинами в не плагиновых файловых панелях
   int WINAPI GetCustomDataW(const wchar_t *FilePath, wchar_t **CustomData)
   void WINAPI FreeCustomDataW(wchar_t *CustomData)
   если несколько плагинов возвращают кастом данные для одного и того же файла то будет показано "Plugin1 Plugin2 Plugin3"

2. Выскакивала ошибка языкового файла при открытия диалога редактирования панельных режимов.

drkns 12.06.2010 08:58:26 +0200 - build 1587

1. И ещё раз.

drkns 12.06.2010 08:43:29 +0200 - build 1586

1. Поправка 1584.2.

t-rex 11.06.2010 18:16:03 +0200 - build 1585

1. Тоже что и 1584.1 но для обновления плагиновой панели.

drkns 11.06.2010 13:47:00 +0200 - build 1584

1. При обновлении панели не было проверки активности фильтра. Говорят, приводило к тормозам.

2. Косметические изменения в коде.

drkns 09.06.2010 11:17:22 +0200 - build 1583

1. Отучение вьювера от FILE*.
   Должно заработать повышение прав.
   Просмотр \\.\physicaldrive0, \\.\cdrom0 и т. п. отвалился. Но это временно.

t-rex 08.06.2010 22:44:13 +0200 - build 1582

1. Фикс как и в 1579.2 только для VBlock2Text().

drkns 07.06.2010 21:07:35 +0200 - build 1581

1. Переменная FARUSER могла быть установлена и при отсутствии ключа /u (наследовалась от родительского процесса).

yjh 07.06.2010 15:41:36 +0300 - build 1580 

1. В список QutedSymbols добавлен oem(0xFF) ("sopft-space") - этого требуют
   стандартные консольные тулзы (copy/move/etc)

drkns 06.06.2010 22:01:56 +0200 - build 1579

1. Уточнение работы ACTL_GETFARRECT.

2. По CtrlX на пустой строке в буфер обмена попадал мусор.

drkns 01.06.2010 14:12:22 +0200 - build 1578

1. Метасимвол !=\ зачем-то окавычивал строку.

drkns 31.05.2010 22:40:13 +0200 - build 1577

1. Вместо макроса countof используем макрос ARRAYSIZE.
   Смысл сего в том, что ARRAYSIZE - только для массивов и попытка запихнуть туда поинтер даст ошибку копиляции (а не выполнения, как с sizeof/sizeof).

drkns 29.05.2010 13:08:42 +0200 - build 1576

1. После ShiftEnter на папке не перерисовывались панели.

2. Уточнения 256- и 16-цветных вариантов far.ico.

drkns 29.05.2010 12:14:02 +0200 - build 1575

1. Ещё пара мелочей на ту же тему.

drkns 28.05.2010 23:47:51 +0200 - build 1574

1. Ещё порция про запускатель и перерисовки.

2. Уточнение 1564.2 - учитываем, что вызовы функций oem-плагинов бывают вложенными.

3. При изменениях размера окна в режиме "/w" содержимое консоли не стирается.
   Экспериментально, возможны мелкие артефакты и прочие ахтунги.

drkns 25.05.2010 19:57:53 +0200 - build 1573

1. ACTL_GETFARRECT - "правильный" способ получения координат "окна" FAR в консольном буфере;
   ACTL_GETCURSORPOS - получение координат курсора относительно "окна" FAR;
   ACTL_SETCURSORPOS - установка координат курсора относительно "окна" FAR.

drkns 25.05.2010 07:37:52 +0200 - build 1572

1. Продолжение 1568.

drkns 24.05.2010 22:45:41 +0200 - build 1571

1. Mantis#0001393: Артефакты на экране при запуске приложения с помощью макроса

drkns 24.05.2010 22:34:42 +0200 - build 1570

1. Продолжение 1568.

t-rex 24.05.2010 09:19:39 +0200 - build 1569

1. from Konstantin Stupnik: Mantis#1388: Регулярные выражения: неправильное значение в группе.

drkns 23.05.2010 23:23:23 +0200 - build 1568

1. После 1564-1566 вылезли скрытые проблемы с отрисовкой в запускателе.

drkns 23.05.2010 14:08:39 +0200 - build 1567

1. Mantis#0001389: Крэш при WindowMode=0 и ScreenBufferSize.Height=9999
   Теоретически, теперь far должен работать при любых размерах буфера.

drkns 22.05.2010 22:45:48 +0200 - build 1566

1. И ещё.

drkns 22.05.2010 22:16:38 +0200 - build 1565

1. Уточнения предыдущего билда.

drkns 22.05.2010 20:00:00 +0200 - build 1564

1. Инкапсуляция всех используемых консольных функций.
   Как следствие - стало возможным очередное "то, о чём так долго говорили большевики": Far умеет работать в пределах окна (а не буфера) консоли.
   Поставив высоту буфера побольше, можно медитировать на длинные выводы консольных программ. Кнопки CtrlAlt<PgUp|PgDn> расширят кругозор в соответствующем направлении.

   АХТУНГ! - в этом режиме гарантированно будет напрочь сносить крышу плагинам, самостоятельно рисующим что-либо
   в консоли напрямую, или наивно предполагающим, что размер фара можно получать через CONSOLE_SCREEN_BUFFER_INFO::dwSize.

2. После завершения работы неюникодных плагинов выполняется SetFileApisToANSI().

t-rex 21.05.2010 18:25:32 +0200 - build 1563

1. Mantis#1387: Зависание при обработке User Menu на имени файла с символом &.

2. Некорректная работа HiStrLen().

t-rex 20.05.2010 20:32:18 +0200

1. Mantis#1386: gcc ошибка компиляции (некорректный регистр в имени заголовочного файла).

t-rex 19.05.2010 23:06:06 +0200 - build 1562

1. В PluginDialogBuilder для AddEditField() теперь надо задавать размер (в символах) выходного буффера.

drkns 19.05.2010 20:09:11 +0200 - build 1561

1. Mantis#0001384: Слегка приглушить символ пробела в режиме Show Whitespace.

t-rex 19.05.2010 18:53:42 +0200 - build 1560

1. GetSize() в UnicodeString для получения размера внутренего буффера.

2. Оптимизация ReplaceStrings().

3. Удалил каплю мусора.

t-rex 19.05.2010 15:57:31 +0200 - build 1559

1. С форума http://forum.farmanager.com/viewtopic.php?p=63127#p63127
   Крэш в истории, коррупция хипа в ReplaceStrings().
   
drkns 19.05.2010 12:50:22 +0200 - build 1558

1. Уточнение обновления окружения.

drkns 17.05.2010 20:06:14 +0200 - build 1557

1. Уточнение обработки WM_SETTINGCHANGE.

drkns 15.05.2010 22:26:55 +0200 - build 1556

1. Излишняя активность в панели задач при копировании c [x] Show total copy progress indicator.

t-rex 15.05.2010 16:10:31 +0200 - build 1555

1. from Alexander Kornienko: Mantis#1383: Дополнения для Mantis#1224 (VBlock2Text)

t-rex 14.05.2010 16:56:29 +0200 - build 1554

1. from Alexander Kornienko: Mantis#1224: copying big block of binary data causes big mem/cpu usage and heap thrashing.
   Надо бы такой же фикс и в VBlock2Text() сделать.

2. Потенциальная утечка памяти в Block2Text() и VBlock2Text(). 

svs 14.05.2010 16:13:05 +0300 - build 1553

1. Macro: добавлена функция S=Menu.GetValue([N]) - возвращает текст пункта меню для заданной позиции (позиция меню не меняется).
   Если N не указан или равен 0 - действие аналогично применению Menu.Value
   для отсутствующего пункта возвращается пустая строка.

zg 14.05.2010 02:18:32 +0200 - build 1552

1. после 1444 в DN_GOTFOCUS Param1 <> SendDlgMessage(DM_GETFOCUS).

2. экспериментально DN_GOTFOCUS приходит после установки выделения для элементов с флагом DIF_SELECTONENTRY.

3. gcc warning.

drkns 14.05.2010 01:55:38 +0200 - build 1551

1. Mantis#0001380: проблема с выставлением значения в поле часов/минут в Filters -> Date/Time -> Relative

drkns 14.05.2010 00:07:38 +0200 - build 1550

1. Излишняя активность в панели задач при включенном отображении описаний.

drkns 13.05.2010 17:33:18 +0200 - build 1549

1. Уточнение предыдущего билда.

drkns 13.05.2010 15:47:47 +0200 - build 1548

1. Теперь у нас есть цикл обработки оконных сообщений.
   Как следствие, доступна следующая магия:
   - автообновление дискового меню и списка hotplug-устройств при добавлении/удалении usb, cd/dvd и пр.;
   - автообновление переменных окружения при изменении их в настройках ОС.

svs 13.05.2010 16:03:14 +0300 - build 1547

1. + CPM_NATIVE для FSF.ConvertPath()
   Возвращает полный путь с префиксом "\\?\"
   (from drkns)

drkns 13.05.2010 00:21:42 +0200 - build 1546

1. Класс Event: обёртка над HANDLE/<Create|Set|Reset>Event/WaitForSingleObject.

drkns 11.05.2010 22:53:26 +0200 - build 1545

1. From Anton Sinitsin: "Ё" в FarRus.lng.

2. Утончения документации и сборки.

drkns 11.05.2010 15:25:32 +0200 - build 1544

1. Ошибки в отрисовке вертикального текста и расчете размеров диалога.

svs 11.05.2010 15:05:18 +0300 - build 1543

1. Небольшие уточнения про хоткеи в менюхах...
   Кроме Upper/Lower добавлен анализа на раскладку (вызов KeyToKeyLayout())

svs 11.05.2010 09:59:58 +0300 - build 1542

1. Macro: Содержимое 
      
      [A|P]Panel.HostFile, [A|P]Panel.Prefix, [A|P]Panel.Path0, [A|P]Panel.Path, 
      [A|P]Panel.UNCPath, [A|P]Panel.Current, Editor.SelValue, Editor.Value, Help.FileName, 
      Help.Topic, Help.SelTopic, Viewer.FileName

   принудительно приводится к "строке", что позволяет избежать ситуации, когда для пустого 
   содержимого возвращается число 0.

   Что у нас еще такого, особенного осталось?

drkns 09.05.2010 23:50:50 +0200

1. From Anton Sinitsin: "Ёфицирование" хелпа.

svs 07.05.2010 16:24:45 +0300 - build 1541

1. Help. From "Alexey Samlyukov"

2. Добавлен "@ElevationDlg". Заготовка, дабы не материлосё оно...

drkns 06.05.2010 22:21:32 +0200 - build 1540

1. В фильтрах по относительному времени не отображались миллисекунды.

2. С форума: "В билде 1539 появилось странное: после Ctrl-O в углу остаётся кусок рамки".

drkns 05.05.2010 23:16:12 +0200 - build 1539

1. Уточнение 1536: при, например, "macro:post F7" индикатор исчезал только после нажатия любой клавиши.

drkns 04.05.2010 23:42:49 +0200 - build 1538

1. Не работало повышение прав при редактировании симлинков.

2. Генерирование ассемблерного листинга для vc-билда по умолчанию выключено. Регулируется флагом ASM_LISTING мейка.

t-rex 04.05.2010 13:53:24 +0200 - build 1537

1. Где то в последних билдах описания стали записываться с '\0' перед переводом строки
   что приводило к различным проблемам с 3rd party программ для описаний.

drkns 03.05.2010 12:45:16 +0200 - build 1536

1. С Mantis#1362 проблемы: эта "индикация выполнения" приводила к постоянным перерисовкам всего экрана.
   Ну и 'Р' теперь зелёного цвета :)

t-rex 02.05.2010 21:46:41 +0200 - build 1535

1. Mantis#1288: Медленная работа с сетевыми папками в режиме показа овнеров.

drkns 02.05.2010 19:13:38 +0200 - build 1534

1. Коррекция размеров для DIF_CENTERGROUP

2. Ещё пара уточнений 1530.2.

3. Mantis#0001356: После копирования в заголовке окна остается "копирование"

drkns 30.04.2010 17:14:30 +0200 - build 1533

1. Ещё пара уточнений 1530.2.

svs 30.04.2010 13:20:57 +0300 - build 1532

1. Mantis#0001362: Индикация выполнения макроса символом в углу экрана
   Символ 'P'.

drkns 30.04.2010 11:09:22 +0200 - build 1531

2. Уточнение 1530.2: DIF_DEFAULT и DIF_FOCUS используются в инициализации (DialogDataEx), а в элементах (DialogItemEx) по прежнему DefaultButton и Focus.

drkns 30.04.2010 01:01:01 +0200 - build 1530

1. Для default button можно задавать цвет.

2. В качестве подготовки к слому API: вместо поля DefaultButton в диалоговых структурах теперь флаг DIF_DEFAULT, вместо Focus - DIF_FOCUS.
   Относится это только к internals, для плагинов всё по старому. Пока.

drkns 29.04.2010 11:38:38 +0200 - build 1529

1. Вернём удаление пустых файлов описаний.

2. Флага FMSG_DOWN больше нет.

3. Косметические изменения в lng.

svs 29.04.2010 09:55:53 +0300 - build 1528

1. Macro: в функцию eval добавлена возможность программного вызова макроса, назначенного на кнопкосочетание
   http://forum.farmanager.com/viewtopic.php?f=15&t=5257

   Для этого 
   а) второй параметр функции установить в 2
   б) первым параметром указать строку в формате "Area/Key"
      здесь:
        "Area" - область, из которой хотим вызвать макрос
        "/" - разделитель
        "Key" - название клавиши
      "Area/" можно не указывать, в этом случае поиск "Key" будет вестись в текущей активной макрообласти, 
         если в текущей области "Key" не найден, то поиск продолжится в области Common.
         Что бы отключить поиск в области Common (ограничится только "этой" областью), 
         необходимо в качестве "Area" указать точку.

   Для режима 2 функция вернет 
     -1 - ошибка
     -2 - нет макроса, заданного кпопкосочетанием (или макрос заблокирован)
      0 - Ok

   Примеры.
     eval("Shell/CtrlP",2) - вызвать макрос, навешенный на CtrlP из области Shell
     eval("CtrlP",2) - вызвать макрос, навешенный на CtrlP из текущей макрообласти, если в текущей CtrlP нет, то вызвать из области Common
     eval("./CtrlP",2) - вызвать макрос, навешенный на CtrlP только из текущей макрообласти

     eval("Shell/Alt/",2) - вызвать макрос, навешенный на Alt/ из области Shell
     eval("Alt/",2) - вызвать макрос, навешенный на Alt/ из текущей макрообласти, если в текущей Alt/ нет, то вызвать из области Common
     eval("./Alt/",2) - вызвать макрос, навешенный на Alt/ только из текущей макрообласти


drkns 28.04.2010 00:42:17 +0200 - build 1527

1. В Message() теперь для единообразия всегда резервируется строка под текст сообщения, даже если сам текст отсутствует.

drkns 27.04.2010 19:51:09 +0200 - build 1526

1. Ещё пара мелочей.

drkns 27.04.2010 16:47:00 +0200 - build 1525

1. И снова всякое про FindFiles.

chupakabra 27.04.2010 16:32:00 +0200

1. makefile_vc: для VS2010 Platform=x64.

drkns 27.04.2010 15:47:00 +0200 - build 1524

1. Ещё одно уточнение в Message().

2. Изменения в записи diz-файлов.

3. Ещё всякое про FindFiles.

drkns 26.04.2010 15:47:00 +0200 - build 1523

1. Уточнение расчета размеров диалогов для функции Message().

2. Неправильно работало определение кодовой страницы по BOM, если кроме BOM в файле ничего не было.

drkns 26.04.2010 00:14:16 +0200 - build 1522

1. В качестве продолжения Mantis#0001096 - отрезание пробелов убрано ещё из пары мест.

t-rex 25.04.2010 22:48:55 +0200 - build 1521

1. Mantis#1316: Ошибка копирования в буфер обмена вертикальных блоков.
   Ещё одна внутренняя переделка работы с клипбордом, теперь кроме обычных функций есть ещё и класс,
   в местах где производятся несколько поочерёдных операций над клипбордом нужно использовать класс напрямую
   чтоб сделать всё "в одну транзакцию".

drkns 25.04.2010 22:38:17 +0200 - build 1520

1. Уточнение предыдущего билда.

drkns 25.04.2010 19:55:48 +0200 - build 1519

1. Продолжение начатого в 953 и 972. Перетрях поиска. Часть третья, глобальная.

2. Mantis#0001213: Некорректный заголовок консоли в диалоге поиска файлов.

3. Mantis#0001353: Диалог запроса повышения полномочий скрыт за окном поиска.

4. Для DI_BUTTON доступен новый флаг: DIF_SETSHIELD - "аналог" BCM_SETSHIELD.

5. Mantis#0000315: Подсветка кнопок по умолчанию диалогов.

6. Mantis#0000647: Button styles in the dialogs.

7. Mantis#0001217: Не работает метасимвол !@!.

8. Разные мелочи в системе повышения полномочий.

drkns 22.04.2010 21:11:09 +0200 - build 1518

1. Уточнение 1517.5: предупреждение об ошибке преобразования выводилось и тогда, когда этого не требовалось.

2. Запросы повышения полномочий логически разделены на "запросы чтения" и "запросы модификации" и теперь их можно включать/выключать по отдельности.
   Интерфейса пока что нет, только через реестр.

drkns 21.04.2010 14:47:00 +0200 - build 1517

1. Mantis#0001347: Убрать . (точка) при автодолнении.
   Элементы "." и"..", иногда возвращаемые Find<First|Next>File, теперь режутся централизованно на уровне класса FindFile, а не в куче разных мест.
   Код, использующий FindFile, НЕ ДОЛЖЕН предполагать наличие этих элементов и бороться с ними.

2. Порция предупреждений от статического анализатора VS2010.

3. При создании папок вида \1\2\3\4 производились попытки создавать каждый элемент, даже если он уже существовал.

4. Поиск файлов не восстанавливает время последнего доступа.

5. Если при загрузке файла в редактор или при переключении кодовой страницы произошли ошибки преобразования текста - при сохранении будет требоваться дополнительное подтверждение, + соообщения теперь более подробны.

svs 21.04.2010 10:18:10 +0300 - build 1516

1. Уточнение build 1515 - односимвольные префиксы игнорируем

svs 21.04.2010 09:34:16 +0300 - build 1515

1. Mantis#0001338: Префикс в параметрах ком.строки
   (описано в хелпе)
   from Maximus

t-rex 20.04.2010 23:56:06 +0200 - build 1514

1. Поддержка MinGW GCC 4.5.0.

2. GCC ворнинги.

3. Косметические мелочи.

drkns 20.04.2010 00:33:57 +0200 - build 1513

1. Уточнение предыдущего билда.

drkns 19.04.2010 16:39:34 +0200 - build 1512

1. Поправка к 1371.2.

2. В фильтрах доступны миллисекунды.

svs 19.04.2010 15:51:19 +0300 - build 1511

1. Mantis#0001334: Позволить плагину менять заголовок редактора "насовсем"
   Теперь выставленный плагином "заголовок" в редакторе (в статусной строке, посредством ECTL_SETTITLE) не будет автоматом сбрасываться 
   после отработки плагина (вызванного по F11).
   Плагины теперь сами должны заботится о восстановлении заголовка редактора (Info.EditorControl(ECTL_SETTITLE,NULL)).

drkns 19.04.2010 10:50:21 +0200 - build 1510

1. Очередная порция замены apiCreateFile/ReadFile/WriteFile/etc. более интеллектуальными классами. Как следствие, запрос на повышение привилегий может заработать ещё в некоторых операциях.

2. При редактировании пользовательского меню по AltF4 во временный файл дописывались излишние byte order mark'и (по одному на каждое подменю вместо одного на весь файл).

drkns 17.04.2010 11:44:42 +0200 - build 1509

1. Mantis#0001348: Блокировка папки процессом FAR после повышения прав.

drkns 17.04.2010 00:57:46 +0200 - build 1508

1. Редактор очищен от остатков libc и, как следствие, умеет запрашивать привилегии для открытия/сохранения файлов.

2. Изменения того же рода в юзерменю и описаниях.

svs 15.04.2010 14:34:28 +0300 - build 1507

1. Mantis#0001346: Макросы, назначенные на "`" (ё) и подобные работают с ошибками

drkns 15.04.2010 11:34:38 +0200 - build 1506

1. В 1494 погнулось системное копирование при "[ ] Copy files opened for writing".

drkns 15.04.2010 11:05:12 +0200 - build 1505

1. Уточнение предыдущего билда.

drkns 15.04.2010 10:55:21 +0200 - build 1504

1. Если пользователь уже обладает правами администратора - обойдемся без запуска дополнительного процесса.

svs 13.04.2010 23:15:33 +0300 - build 1503

1. Macro: bug - падение, при вызове [A|P]Panel.HostFile для неплагиновой панели.

svs 13.04.2010 14:48:25 +0300 - build 1502

1. Mantis#0001344: Падение при переходе по ссылкам хелпа
   size_t "рулит" :-(
   Этот фикс избавляется только от падения.
   Для "исправления ошибок" хелпов нужно править парсер (выходит за рамки данного исправления)

t-rex 13.04.2010 00:04:24 +0200 - build 1501

1. В паре мест StrLength(string) -> string.GetLength().

drkns 12.04.2010 22:54:07 +0200 - build 1500

1. Более информативные сообщения при необходимости повышения привилегий.

svs 12.04.2010 17:53:57 +0300 - build 1499

1. Вис help на файлах, у которых между секциями отсутствовала пустая строка
   (например, "Regular Expression Search and Replace, version 7.04")

drkns 12.04.2010 16:46:32 +0200 - build 1498

1. Всякие мелочи на тему повышения привилегий.

2. Унифицирована работа CtrlEnd в диалогах и комстроке: из комстроки взят круговой перебор вариантов, из диалогов - выделение дописываемого.

svs 12.04.2010 12:38:45 +0300 - build 1497

1. Bug: [A|P]Panel.path0 не возвращает путь
   http://forum.farmanager.com/viewtopic.php?p=61218#p61218

svs 12.04.2010 11:38:27 +0300 - build 1496

1. Mantis#0000830: Неверный расчет перемещения в функции Viewer::Up() для UTF-8

chupakabra 11.04.2010 23:20:00 +0200 - build 1495

1. Исправлена ошибка перемещения фокуса, внесенная в 1444.

drkns 11.04.2010 02:23:13 +0200 - build 1494

1. Повышение привилегий:
   - запрос происходит только тогда, когда это действительно надо (доступ запрещён через ACL), а не на каждый ERROR_ACCESS_DENIED.
   - изменение времени файлов и состояния атрибутов "сжатый" и "разреженный".
   - поиск по содержимому.
   - теоретически должна работать и самопальная реализация копирования ("[ ] Use system copy routine"). Особо не тестировалось, соблюдаем осторожность.

2. Некоторые api-функции (CreateFile/ReadFile/WriteFile/...) логически объединены в отдельный класс File, в дальнейшем предпочтительно использовать уже его.

3. Не работал CtrlEnd в диалогах при отключенном дополнении.

svs 09.04.2010 16:32:01 +0300 - build 1493

1. Macro: [A|P]Panel.Path0 - путь на реальной FS (до вызова плагинов, создающих свою панель)
   Состояния аналогичные [A|P]Panel.Path, но содержать путь реальной FS.
   Если на панели реальная FS, то 
     [A|P]Panel.Path == [A|P]Panel.Path0
   Если панель плагиновая, то 
     [A|P]Panel.Path != [A|P]Panel.Path0 

svs 09.04.2010 09:38:19 +0300 - build 1492

1. Модуль печати в отвале - не учитывался текущий каталог.

drkns 08.04.2010 15:30:25 +0200 - build 1491

1. Mantis#0001337: Ошибка при чтении содержимого папки.

2. Для элемента ".." в панелях отображался неправильный владелец.

svs 08.04.2010 11:01:14 +0300 - build 1490

1. Mantis#0000884: Рвётся текст справки при длине строки больше 300 символов.
   Перевод хелпа на массив строк (TArray)
   Немного шаманства в TArray по поводу сортировки.
   Удаление "мусора" из кода хелпа

drkns 08.04.2010 00:39:10 +0200 - build 1489

1. Mantis#0001336: Сообщение об ошибке при открытии каталога.

drkns 07.04.2010 14:04:32 +0200 - build 1488

1. Уточнение 1483.

svs 07.04.2010 13:10:41 +0300 - build 1487

1. Mantis#0001335: Использование некорректного текстового ресурса

2. Mantis#0001331: Макрофункция для управления статусной строкой

drkns 07.04.2010 11:46:46 +0200 - build 1486

1. Запрет на преобразование пути в некоторых вызовах apiGetFindDataEx вроде бы уже неактуален, посему уберём.

drkns 06.04.2010 20:02:46 +0200 - build 1485

1. Уточнение 1483.

svs 06.04.2010 13:41:39 +0300 - build 1484

1. Macro: новая функция "N=Editor.SetTitle([Title])" установка заголовка в статусной строке редактора
   Возвращает 1 - успешно, 0 - редактор не в фокусе.
   Если параметр отсутствует или равен пустой строке, то восстанавливается предыдущее значение статусной строки

drkns 06.04.2010 10:35:35 +0200 - build 1483

1. Продолжение 1468:
   С полномочиями администратора могут выполняться:
   - просмотр каталогов;
   - получение атрибутов;
   - установка владельца.

2. FindFirstFile/FindNextFile/FindClose логически объединены в отдельный класс FindFile, в дальнейшем предпочтительно использовать уже его.

svs 05.04.2010 18:18:38 +0300 - build 1482

1. Уточнение Mantis#0001323

2. Macro: [A|P]Panel.path для Плагиновой панели
   http://forum.farmanager.com/viewtopic.php?f=15&t=5254

3. Macro: [A|P]Panel.Prefix - возвращает пусто, либо префикса, как их отдают плагины

4. Macro: [A|P]Panel.UNCPath возвращает (для плагиновой панели) prefix:[hostfile/]path

garry 03.04.2010 22:44:32 +0300 - build 1481

1. После 1456 отвалился вывод кодовых страниц для ANSI-плагинов (например, FTP).

drkns 03.04.2010 19:30:12 +0200 - build 1480

1. 1479.2: Как выяснилось, gcc не поддерживает forward enum declaration.

drkns 03.04.2010 11:23:56 +0200 - build 1479

1. И ещё раз Mantis#0001321: DM_MOVEDIALOG: ограниченный диапазон перемещения диалога.

2. Косметика в adminmode.?pp

svs 03.04.2010 11:45:44 +0300 - build 1478

1. Mantis#0000098: неправильные сообщения при попытке создания папки/файла с запрещенными символами

zg 03.04.2010 02:26:08 +0200 - build 1477

1. Mantis#0001329: Поиск в прямом направлении, шаблон = $.

zg 02.04.2010 11:42:58 +0200 - build 1476

1. в связи с 1219 Ctrl-Shift-Numpad5 в панелях заменён на Ctrl-Alt-Numpad5.

svs 02.04.2010 10:29:40 +0300 - build 1475

1. Mantis#0001323: gethotkey(0) возвращает следующий по порядку сивол (вместо "3" - "4", вместо "x" - "y")

drkns 01.04.2010 20:00:00 +0200 - build 1474

1. Mantis#0001321: DM_MOVEDIALOG: ограниченный диапазон перемещения диалога.
   При относительном перемещении координаты, равные -1, больше не центрируют диалог.

2. Более компактное расположение элементов диалога поиска.

drkns 01.04.2010 13:47:00 +0200 - build 1473

1. Уточнение 1472.2: различаем symlink и junction;

2. Создание жёстких ссылок может выполняться с полномочиями администратора.

svs 01.04.2010 12:56:20 +0300 - build 1472

1. Mantis#0001265: Глюк с размером буфера и заголовком панели
   Утчонение п.2 ("При нечетной ширине консоли заголовок панели (правой) рисуется некорректно (на левой)")

2. Mantis#0001327: В окне поиска найденные связи отображаются как папки

zg 01.04.2010 03:12:18 +0200 - build 1471

1. Mantis#0001322: Поиск и замена в редакторе пропускает пустые строки.

drkns 31.03.2010 21:52:05 +0200 - build 1470

1. Уточнение 1468 - терялись результaты GetLastError().

drkns 31.03.2010 16:29:11 +0200 - build 1469

1. Mantis#0001315: В tmp-панели связи отображаются как папки.

2. Mantis#0001321: DM_MOVEDIALOG: ограниченный диапазон перемещения диалога.

drkns 31.03.2010 15:24:32 +0200 - build 1468

1. Продолжение 1466:
   - удаление в корзину может выполняться с полномочиями администратора;
   - при копировании работает индикатор прогресса, отмена и т. п.

t-rex 31.03.2010 01:05:50 +0200 - build 1467

1. В диалоге настройки фильтра поменял местами поля даты чтоб было более интуитивно,
   пока не придумаем более понятный дизайн диалога.

drkns 30.03.2010 15:44:02 +0200 - build 1466

1. Продолжение 1465:
   С полномочиями администратора могут выполняться:
   - перенос файлов;
   - копирование файлов;
   - копирование/редактирование reparse point'ов.

drkns 30.03.2010 00:44:57 +0200 - build 1465

1. Начальная поддержка повышения полномочий при работе из-под ограниченной учётной записи.

   С полномочиями администратора в данный момент могут быть выполнены следующие операции:
   - создание папок;
   - удаление папок;
   - удаление файлов;
   - установка атрибутов;
   - создание символических ссылок.

   Со временем этот список будет расти.

zg 29.03.2010 04:01:39 +0200 - build 1464

1. Mantis#0001302: При запуске с параметром ком.строки FAR зависает на "черном экране" до нажатия Enter.

zg 29.03.2010 03:37:49 +0200 - build 1463

1. Mantis#0001310: Запускать редактор с заданной абсолютной колонкой, а не экранной (как из плагинов, так и из комстроки).

zg 29.03.2010 01:55:26 +0200 - build 1462

1. оптимизация билда 1460. при создании панели два раза делалось show и сортировалось. хотя не надо ни разу.

2. после 1448 сортировка в случае сортировки по расширению, отключённой сортировки каталогов 
   по расширению и отключённой опции папки вначале была неустойчивой.

t-rex 28.03.2010 21:42:53 +0200 - build 1461

1. Mantis#1314: Filters - Date/Time - Relative

chupakabra 27.03.2010 08:20:00 +0200 - build 1460

1. Не выполнялась пересортировка после FCTL_SETNUMERICSORT и FCTL_SETDIRECTORIESFIRST.

svs 27.03.2010 08:17:48 +0300 - build 1459

1. Mantis#0001312: При отмене редактирования пункта не нужно обновлять файл farmenu.ini
   from Maximus

garry 26.03.2010 16:51:16 +0300 - build 1458

1. Дополнение к 1456.

drkns 26.03.2010 14:58:23 +0200 - build 1457

1. Нажатие PgDn в диалоге поиска могло приводить к переполнению стека.

garry 26.03.2010 15:28:59 +0300 - build 1456

1. Добавлена возможность редактирования через интерфейс имён кодовых страниц (убрано течинфо #80);

2. При некоторых условиях при открытии меню кодовых страниц курсор позиционировался не на ту запись (в каком то из
   билдов починили меню и сделанные мною в меню кодовых страниц костыли стали мешать);

3. Настройка кодовых страниц добавлена в основное меню настроек;

4. Для русского языка в меню настроек поправлены пересекающиеся и отсутствующие горячие клавиши.

svs 26.03.2010 11:57:54 +0300 - build 1455

1. Bug: far /e имя_файла ShiftEnter AltF9 --> трап.

2. Macro: у функции Clip(N,V) добавлен 5-й режим (первый параметр) - работа с режимами клипборда.
    N=5
    V:
      -1 - что сейчас используется? 1 - виндовый буфер, 2 - внутренний
       0 - flip (аналог $IClip)
       1 - включить виндовый буфер обмена
       2 - включить внутренний буфер обмена

    Возвращает предыдущее значение (1 - виндовый буфер, 2 - внутренний)

3.  <АХТУНГ>

     Исправляйте свои макросы:

       а) $IClip заменить на Clip(5,0) или Clip(5), т.к. $IClip будет удаляться.
       б) IClip заменить на Clip(5,-1) (при этом учесть, что clip() вернет 1 или 2), т.к. IClip будет удаляться.

     указанных 2 "объекта" будут удалены... скажем через 2 месяца :-)

   </АХТУНГ>


svs 25.03.2010 18:38:53 +0300 - build 1454

1. Macro: добавлена константа RCounter - содержит текущее значение счетчика оператора цикла $Rep.
   Область видимости - текущий $Rep (для вложенных $Rep - значение для текущего цикла), например

   RCounter = undefined
   $rep(%i)
     ...
     RCounter = значению для цикла "$rep(%i)"
     ...
     $rep(%j)
       ...
       RCounter = значению для цикла "$rep(%j)"
       ...
     $end
     ...
     RCounter = значению для цикла "$rep(%i)"
     ...
   $end
   RCounter = undefined

   За пределами цикла значение константы неопределенное/любое/нет смысла использовать.

2. Macro: Добавлена функция "N=Print(Str)" - вывести содержимое строки str туда, где курсор.
   Аналогична $Text, но параметр Str может быть выражением.
   Возвращает всегда 1.

3. Macro: Добавлена функци "v = MMode(Action[,Value])" - выставить/получить режимы текущего макроса.
   Аналогична $MMode, но параметр mode может быть выражением.
   Action - что хотим поменять
     1 - режим лочки экрана ("DisableOutput")
         "MMode(1,-1)" подобен состоянию "DisableOutput"
   Value  - значение
    -1 - get (функция возвращает текущее значение)
     0 - off (функция выключает Action и возвращает предыдущее значение)
     1 - on  (функция включает Action и возвращает предыдущее значение)
     2 - flip  (функция переключает Action и возвращает предыдущее значение)


4.  <АХТУНГ>

     Исправляйте свои макросы:

       а) $Text заменить на print(), т.к. $Text будет удаляться.
       б) $Date заменить на print(Date(блаблабла или пусто)), т.к. $Date будет удаляться.
       с) "$MMode 1" заменить на "MMode(1,2)", т.к. $MMode будет удаляться.
       d) состояние "DisableOutput" заменить на вызов функции "MMode(1,-1)", т.к. состояние "DisableOutput" (не флаг макроса!) будет удаляться.

     указанных 4 "объекта" будут удалены... скажем через 2 месяца :-)

   </АХТУНГ>


chupakabra 23.03.2010 00:51:00 +0200 - build 1453

1. Переписана функция числовой сортировки.

drkns 22.03.2010 20:18:31 +0200 - build 1452

1. Убираем ИИ, различающий "связи" и "точки монтирования" в колонках панели.
   Увы, сильно страдает производительность.

2. х64 warnings.

chupakabra 22.03.2010 04:03:00 +0200 - build 1451

1. Исправление для 1444.

chupakabra 22.03.2010 02:02:00 +0200 - build 1450

1. Mantis#0001301: листбокс не перерисовывался после DM_LISTUPDATE.

t-rex 22.03.2010 00:27:43 +0200

1. Корректировка 1448.3.

chupakabra 21.03.2010 20:59:00 +0200 - build 1449

1. Исправлена ошибка режима сортировки по полному имени.

chupakabra 21.03.2010 20:43:00 +0200 - build 1448

1. Опция для отображения каталогов в начале списке при сортировке (Ctrl+F12).

2. Plugin API: FCTL_SETDIRECTORIESFIRST, PFLAGS_DIRECTORIESFIRST, SM_NUMSTREAMS, SM_STREAMSSIZE, SM_FULLNAME.

3. В makefile поправлены зависимости.

chupakabra 21.03.2010 01:11:00 +0200 - build 1447

1. Mantis#0001081: режим сортировки по полному имени учитывает числовую сортировку и группы сортировки.

2. Сортировка: заменено копирование строк на вызов функций сравнения с явным указанием длин сравниваемых строк.

drkns 20.03.2010 09:26:41 +0200 - build 1446

1. В 1443 отвалился QView.

chupakabra 20.03.2010 05:46:00 +0200 - build 1445

1. Mantis#0001081: режим сортировки по полному имени (полному пути) файла.

chupakabra 20.03.2010 04:38:00 +0200 - build 1444

1. Mantis#0001290: Некорректная обработка нажатий на кнопки со стилем DIF_NOFOCUS + DIF_BTNNOCLOSE.

drkns 20.03.2010 00:42:00 +0200 - build 1443

1. Mantis#0001309: В диалоге применения атрибутов не работает Cancel при вводе неправильного владельца

2. При вызове свойств папки в некоторых ОС могли вызываться свойства файла с тем же именем и расширением из %pathext%.

3. FCTL_GETCMDLINESELECTEDTEXT возвращал на 1 символ меньше, чем надо.

4. Массовое внедрение списков инициализации.

5. Немного C++0x: внедрение nullptr. Для VC2010 - нативно, для остальных - #define на NULL.

t-rex 19.03.2010 12:27:10 +0200 - build 1442

1. Mantis#1308: Не собирается в gcc из-за некорректной инструкции #include (неправильный регистр).

svs 19.03.2010 11:56:32 +0300 - build 1441

1. VK_OEM_102. Уточнение... 1440

svs 19.03.2010 11:38:51 +0300 - build 1440

1. Добавлена обработка VK_OEM_102, которая "обозвана" как: "<>" or "\|" on RT 102-key kbd.
   Сейчас это '\'.
   Требуется уточнение для AltGr- (Ctrl-Alt-), ...возможно еще что.
   Т.с. Wелкам!

chupakabra 19.03.2010 04:41:00 +0200 - build 1439

1. Поломалась синхронизация текущего каталога для плагинов с OPIF_REALNAMES (из build 1157).

svs 18.03.2010 19:54:06 +0300 - build 1438

1. Mantis#0001307: Возвращаемый результат функции panel.fexist
   Теперь panel.fexist() возвращает: 0 - нет такого элемента, > 0 - позиция/индекс файлового элемента на панели.
   Без учета фильтров!

svs 17.03.2010 16:42:40 +0300 - build 1437

1. Macro: уточнение прототипа "Panel.Select()".
   Теперь работают Mode=2 и 3. Для этих режимов разделителем элементов списка могут быть: ';' ',' и '\r\n'.
   Пример: 
     Panel.Select(1,1,2,clip(0))
     На пассивной панели выделить те файлы, имена которых находяться в клипборде.

2. У FileList::SelectFiles теперь доп.параметр (маски) и функция возвращает количество обработанных элементов (пока используется на нужды макросов)

svs 16.03.2010 17:48:46 +0300 - build 1436

1. Keys.hpp
   1) KEY_CTRLMASK теперь 0xFFF00000
   2) Удален KEY_LOCKSCREEN - остатки роскоши былой, не используется
   3) "описаны" KEY_KILLFOCUS, KEY_GOTFOCUS и KEY_CONSOLE_BUFFER_RESIZE
   4) расширение диапазона KEY_MACRO_BASE

2. SysLog. Добавлен конструктор 
   CleverSysLog(int Line,const wchar_t *Title);

3. Macro: добавлен прототип "V=Panel.Select(panelType,Action[,Mode[,Items]])"
   по мотивам http://forum.farmanager.com/viewtopic.php?f=15&t=5077
   На сегодня умеет: 
   panelType - как обычно: =0 - активная панель, =1 - пассивная панель.
   Action:
     0 - снять выделение; возвращает количество элементов с которых сняли выделение
     1 - выделить
     2 - инвертировать
     3 - восстановить выделение, аналог Ctrl-M; возвращает количество восстановленных элементов
   Mode:
     0 или отсутсвует - выполнить действие Action  для всех элементов
     1 - Items является числом - индексом
   Items:
     для Mode==0 - игнорируется
     для Mode==1:
       Items==0 или отсутствует - выполнить действие Action для текущего элемента
       Items>0 - выполнить действие Action для элемента с индексом Items
   Функция возвращает количество элементов, над которыми производилось Action
   (получить инфу о текущем количестве выделенных - как обычно через [A|P]Panel.SelCount :-)

   Планируется добавить Mode=2 и 3 (рассматривать Items как строки - имя или маска)

4. Macro добавлены [A|P]Panel.HostFile - пусто или имя хост-файла плагиновой панели.

drkns 10.03.2010 19:29:31 +0200 - build 1435

1. Mantis#0001297: Сохранение в настройках переменных окружения

2. Mantis#0001300: Наследовать флаг VF_DISABLEHISTORY при переключении в редактор (F6), и наоборот

3. Не устанавливались дата/время у reparse point'ов в подкаталогах.

drkns 10.03.2010 14:20:17 +0300 - build 1434

1. Продолжение 1425 - владелец доступен для редактирования.

2. Mantis#1299: SavedDialogHistory: SearchText, ReplaceText

yjh 09.03.2010 15:52:16 +0300 - build 1433

1. Дефлотная маска для архивов поддерживает .tbz и .txz (новые linux-дистрибутивы)


svs 03.03.2010 17:33:17 +0300 - build 1432

1. Функция CheckFolder() переименована в TestFolder(), соответствующим образом изменены наименование кодов возврата.

2. Macro: Новая функция: N=testfolder(S) - тестирование каталога, возвращает
      2 - нет такого
      1 - не пусто
      0 - пусто
     -1 - нет доступа
     -2 - ошибка (неправильные параметры или нехватило памяти для выделения промежуточных буферов)

   Константы:
     REGEDIT4

     [HKEY_CURRENT_USER\Software\Far2\KeyMacros\Consts]
     "TSTFLD_NOTFOUND"=dword:00000002
     "TSTFLD_NOTEMPTY"=dword:00000001
     "TSTFLD_EMPTY"=dword:00000000
     "TSTFLD_NOTACCESS"=dword:FFFFFFFF
     "TSTFLD_ERROR"=dword:FFFFFFFE

3. Macro: немного тестовых добавок в "машину".

drkns 02.03.2010 18:32:43 +0200 - build 1431

1. Лишний callback при вставке текста в строку ввода.

drkns 01.03.2010 21:10:08 +0200 - build 1430

1. Потенциальное UB в диалоге атрибутов.

svs 01.03.2010 19:00:24 +0300 - build 1429

1. Mantis#0000981: Far падает, после вызова плагина через CallPlugin

2. Macro: у функции date параметр можно не указывать, в этом случае используется форматная строка "%a %b %d %H:%M:%S %Z %Y"

3. Macro: добавлен "$Continue" - для циклов

4. Бага с шорткатами в редакторе/вьювере:
   а) LCtrl-<N> (где <N> неназначенный шорткат) - прыгал в самое начало файла
   б) Сохранение шорткатов в реестре было возможно только, если был назначен нулевой элемент (RCtrl-0)

   Здесь Ахтунг!
   Из-за весьма ранних багов в реестре могло сохраняться содержимое шорткатов, заполненных нулями.
   Поэтому рекомендуется в реестре Editor\LastPositions и Viewer\LastPositions выкинуть значения ShortXXX

5. Для единообразия... в Opt.ViOpt.SaveViewerPos и Opt.ViOpt.SaveViewerShortPos убрано "слово" Viewer.

drkns 28.02.2010 11:29:36 +0200 - build 1428

1. Истории ввода, просмотра, папок, диалогов и сохранённых позиций расширены до 512 элементов по умолчанию.

yjh 28.02.2010 04:42:01 +0300 - build 1427

1. К 1424 - если уж делать largeaddressaware, то для всех линкеров :)

drkns 28.02.2010 01:43:09 +0200 - build 1426

1. Поправка к 2 пункту предыдущего билда, дабы и в пещерных ОС работало.

drkns 27.02.2010 23:30:38 +0200 - build 1425

1. Добавка к 1054.2: в меню дисков по CtrlA/F4 выводится не системный, а встроенный диалог атрибутов.

2. Из встроенного диалога атрибутов можно вызывать системный.

3. Mantis#0000088: Добавить поле "Владелец файла".

4. Там же в список атрибутов добавлен "Reparse point".

drkns 27.02.2010 19:16:33 +0200 - build 1424

1. Собираем с /largeaddressaware.

chupakabra 27.02.2010 07:51:00 +0200 - build 1423

1. Mantis#0000840: включаем Low-fragmentation Heap.
   http://msdn.microsoft.com/en-us/library/aa366750%28VS.85%29.aspx

drkns 27.02.2010 00:07:33 +0200 - build 1422

1. Не работала опция "Lock editing of read-only files".

t-rex 26.02.2010 20:36:01 +0200 - build 1421

1. Не надо вызывать apiGetVolumeNameForVolumeMountPoint() для репарс поинтов которые не папки (видимо Mantis#1288).

2. Ворнинг в GCC.

drkns 24.02.2010 15:48:25 +0200 - build 1420

1. Продолжаем давить printf.

2. 32-битного FilePositionCache больше нет, теперь везде 64-битный.

3. Убраны ограничения из TI#11 .

svs 22.02.2010 17:10:45 +0300 - build 1419

1. Macro: уточнение replace(). Зацикливается, если Find - пустая строка.

drkns 22.02.2010 15:49:34 +0200 - build 1418

1. Продолжение предыдущего билда. Теперь, вероятно, и волки будут сыты, и овцы целы -
   ./.. показываются, но крышу у глючных драйверов от проверок не сносит.

t-rex 22.02.2010 13:53:43 +0200 - build 1417

1. Убрал всю заморочку с проверкой на "." и "..".
   Она приводила к различным проблемам у нормальных пользователей и всё ради того
   чтоб фиг знает кто мог себе создавать такие настоящие папки на фате.
   Если вы всё таки создаёте папки "." и ".." то фар их показывать не будет.

drkns 21.02.2010 21:57:47 +0200 - build 1416

1. В 1413 забыли зажим внутри пациента :)

zg 21.02.2010 13:10:12 +0200 - build 1415

1. не собиралось gcc.

svs 20.02.2010 22:44:13 +0300 - build 1414

1. Macro: bug: panel.setposidx(0,0,1) возвращает 0, если отмеченный файл - последний на панели

drkns 20.02.2010 20:24:44 +0200 - build 1413

1. Выкинуто шаманство с DETECT_ALT_ENTER, теперь автоустановка 80x25 при переключении в полноэкранный режим работает.

2. ACTL_CONSOLEMODE больше нет.

3. Состояние Windowed в макроязыке заменено на Fullscreen.

svs 19.02.2010 17:18:28 +0300 - build 1412

1. Macro: Bug: [A|P]panel.Filter всегда выдает 1, независимо от того, включён фильтр на панели или нет

2. Macro: проблемы с eval()

3. Macro: некорректная работа panel.setposidx()
   Теперь вот так:
     Panel.SetPosIdx(0,0,0) - вернет координаты в массиве файлов с учетом фильтра
     Panel.SetPosIdx(0,0,1) - вернет координаты в виртуальном массиве отмеченных файлов с учетом фильтра

4. В Config переменные, относящиеся к макросам, собраны в одну структуру.

5. Добавлено временное правило KeyMacros/CallPluginRules:dword (по мотивам Mantis#1280)
     0 - блокировать макросы при вызове плагина функцией CallPlugin, 1 - разрешить макросы (ахтунг!)
     по умолчанию 0 - блокировать
   "временное" - чтобы понять на сколько это критично.

drkns 19.02.2010 13:47:00 +0200 - build 1411

1. В 1410 отвалилось копирование на плагиновые панели.

drkns 18.02.2010 23:03:00 +0200 - build 1410

1. Падение при отсутствии языковых файлов.

2. Падение при выгрузке плагина при открытом меню конфигурации.

3. Выкинуто ещё немного мусора из копира.

4. Исключатор: добавлена возможность передать исключение во внешний отладчик, выкинут разнообразный мусор.

t-rex 18.02.2010 21:28:44 +0200 - build 1409

1. Косметические правки пред. билда.

svs 18.02.2010 20:02:35 +0300 - build 1408

1. Macro: функция Menu.Select не работает, если третий параметр (Dir) не равен 0.
   (еще бы оно работало, когда направление не учитывалось совсем :-))

svs 18.02.2010 14:33:53 +0300 - build 1407

1. Mantis#0001286: Добавить состояние кликов мыши
   Добавлена константа MsEventFlags. Набор битов (see http://msdn.microsoft.com/en-us/library/ms684239%28VS.85%29.aspx):
     DOUBLE_CLICK = 0x0002
        The second click (button press) of a double-click occurred. 
        The first click is returned as a regular button-press event.
     MOUSE_HWHEELED = 0x0008
        The horizontal mouse wheel was moved.
     MOUSE_MOVED = 0x0001
        A change in mouse position occurred.
     MOUSE_WHEELED = 0x0004
        The vertical mouse wheel was moved.

2. Macro: panel.setposidx()
   a) добавлен 3-й необязательный параметр InSelection
        N=Panel.SetPosIdx(panelType,Idx[,InSelection])
      если InSelection = 1, то Idx - индекс в виртуальном массиве отмеченных видимых файлов
      если InSelection = 0, то Idx - индекс в виртуальном массиве видимых файлов
   b) теперь эта функция работает только с видимыми файлами, с учетом примененных фильтров на панели.
   c) второй параметр Idx:
        < 0 - "искать" от конца в начало
        > 0 - "искать" от начала в конец
        = 0 - игнорировать переход, просто вернуть текущую позицию (естественно  учетом фильтра)

3. Macro: добавлены булевые состояния [A|P]Panel.Filter - "на активной/пассивной панели включен фильтр?"

4. Macro: уточнение 1401

5. Добавлены virtual public Panel::FileInFilter(long idxItem) и Panel::IsSelected(long idxItem)


drkns 17.02.2010 22:22:31 +0200 - build 1406

1. Продолжение #0001273. После 1395 начали проявляться разнообразные древние, присыпанные листьями грабли.

garry 17.02.2010 18:00:27 +0300 - build 1405

1. Ошибка компиляции x64 версии в 1400.

svs 17.02.2010 17:49:19 +0300 - build 1404

1. Macro: снова про загрузку.
    "...Имеется какой-либо макрос для панелей. Вызываем MacroView, вносим ошибку в макрос.
    FAR сообщает об ошибке в выражении, этот макрос больше не срабатывает, но перестают работать все макросы, кроме панельных.
    Если ошибка в макросе редактора или вьюера, то перестают работать common-макросы..."

2. Mantis#0001283: Глюк с областью выполнения макросов
   Пусть манагер всегда принудительно выставляет область для текущего фрейма (CurrentFrame).
   Хмм... возможно повторение этого Инца, но только для тех объектов, кто "не с нами" (не производный от Frame).

drkns 16.02.2010 19:32:46 +0200 - build 1403

1. Уточнение работы FCTL_CLEARSELECTION.

drkns 16.02.2010 13:47:00 +0300 - build 1402

1. Mantis#0000942: far hangs at exit after using of proclist

2. Mantis#0001273: Медленная работа и излишний сетевой трафик при работе с сетевыми папками.

3. Добавлена команда FCTL_CLEARSELECTION - снять выделение с элемента панели. Param1 - номер выбранного элемента (0<=Param1<PanelInfo.SelectedItemsNumber).

4. Пара мелочей.

svs 16.02.2010 11:05:58 +0300 - build 1401

1. Макро: теперь ошибки пропускаются (остальные макросы грузяться)

2. Немного PROJECT_DI_MEMOEDIT.

3. В editor.cpp удален лишний кусок закомменченного кода про Editor::ReadFile()

garry 15.02.2010 17:37:17 +0300 - build 1400

1. Падения при обработке файлов с увеличивающимся размером:
   1. Редактор падал при выводе прогресса для файла, размер которого увеличивается
      в процессе открытия;
   2. Вьювер падал при выводе прогресса в процессе поиска для файла, размер которого
      увеличивается во время просмотра.

t-rex 14.02.2010 00:48:27 +0200 - build 1399

1. Mantis#1274: Некорректная работа фильтра панелей при выборе только папок.
   Вообще был определённый прокол в логике обработке папок, починились похожие и не очень
   глюки и в поиске и в пометке.

zg 14.02.2010 00:12:02 +0200 - build 1398

1. не собиралось gcc.

svs 12.02.2010 18:15:56 +0300 - build 1397

1. Mantis#0001270: MCMD_LOADALL не возвращает ошибку при наличии ошибок

drkns 11.02.2010 14:06:15 +0200 - build 1396

1. Уточнение логики добавления BOM при сохранении.

drkns 11.02.2010 13:47:00 +0200 - build 1395

1. Т.к. в ConvertNameToReal больше не используется ручной анализ содержимого репарс-поинта, уберём оттуда ограничения для сетевых путей.

2. В диалоге атрибутов редактирование содержимого репарс-поинта доступно и для сетевых путей.

3. Mantis#0000650: FAR не дает создать символическую ссылку на корневую шару.

svs 12.02.2010 14:15:21 +0300 - build 1394

1. Некорректная работа Info.FSF->FarNameToKey
   http://forum.farmanager.com/viewtopic.php?f=8&t=5058

   Функция ждет строку по вот такой спецификации:
     1. Сочетания, определенные в структуре keyboard.cpp::FKeys1[]
     2. Опциональные модификаторы (Alt/RAlt/Ctrl/RCtrl/Shift) и 1 символ, например, AltD или CtrlC
     3. "Alt" (или RAlt) и 5 десятичных цифр (с ведущими нулями)
     4. "Spec" и 5 десятичных цифр (с ведущими нулями)
     5. "Oem" и 5 десятичных цифр (с ведущими нулями)
     6. только модификаторы (Alt/RAlt/Ctrl/RCtrl/Shift)

drkns 11.02.2010 23:52:09 +0200 - build 1393

1. Mantis#0001271: Диалог: символы, недопустимые в данной кодировке.

2. Диалог перехода (AltF8) в редакторе переведён на DialogBuilder.

svs 11.02.2010 22:26:57 +0300 - build 1392

1. Mantis#0001268: В фильтр диалогов вставляется только первый символ
   Добавка Ctrl-V/Shift-Ins (только для режима "мы в фильтре")

svs 11.02.2010 21:57:33 +0300 - build 1391

1. Mantis#0001268: В фильтр диалогов вставляется только первый символ
   ...что не мудрено, судя по коду :-)

   И да, здесь, в фильтре, в качестве эксперимента :-) при обработке $Text добавлена реакция на символ 0x8 (Bs). Нада?

2. Mantis#0001266: Far падает при разборе Macro
   А про двойные кавычки я и забыл... :-(
     В класс UserDefinedList добавлен флаг ULF_NOTUNQUOTES

drkns 11.02.2010 13:47:00 +0200 - build 1390

1. Mantis#0001269: Не указан макрос в сообщении о неверном макросе при загрузке Фара

2. Лишний вызов callback-функций при замене блока в строках ввода.

drkns 11.02.2010 01:15:24 +0200 - build 1389

1. В 1381 отвалились клики правой кнопкой мыши по линейке функциональных клавиш.

zg 10.02.2010 22:13:45 +0200 - build 1388

1. в регэкспах - ошибка в обработке верхней границы в диапазонах, заданной в виде \xyyyy.

drkns 10.02.2010 15:04:39 +0200 - build 1387

1. Обрабатываем Alt-<Left|Right|Home|End> в списке дополнения.

svs 10.02.2010 12:55:31 +0300 - build 1386

1. Варнинги

2. Macro: MCMD_CHECKMACRO - инициализация кода успешного чекинья макроса
   Здесь нужно понимать, что ActlKeyMacro.Param - это union и что Param.PlainText.SequenceText затрется после отработки MCMD_CHECKMACRO, т.е.
   Far вернет Param.MacroResult.*

drkns 10.02.2010 00:57:46 +0200 - build 1385

1. Некорректное позиционирование фокуса в меню кодовых страниц.

zg 09.02.2010 17:59:01 +0200 - build 1384

1. в апи добавлены ESPT_SETBOM и EOPT_BOM.

2. по дороге исправлена ситуация когда открыли в редакторе файл без бом, удалили, сохранили, в итоге файл с бом.

svs 09.02.2010 18:02:24 +0300 - build 1383

1. Продолжаем мучить MCMD_CHECKMACRO.
   - строка и позиция для плагинов начинается с 0, как и положено
   - MPEC_EXPECTED заменена на удобочитаемую MPEC_EXPECTED_TOKEN
   - добавлен флаг KSFLAGS_SILENTCHECK - при чекании Far должен молчать (не выводить диалог)

drkns 09.02.2010 15:04:21 +0200 - build 1382

1. Уточнения раскраски диалоговых элементов.

2. Косметика в коде диалога назначения макроклавиш.

svs 09.02.2010 12:50:38 +0300 - build 1381

1. Macro: макрос на F1 "msgbox(akey(1))"
          жмём в панелях, диалогах и т.п. - работает адекватно.
          жмём в меню - видим не F1, а кнопку, вызвавшую это меню.

2. "Опубликован" MCMD_CHECKMACRO, возвращает ActlKeyMacro.Param.MacroResult
     struct
     {
       DWORD ErrCode;  // код ошибки (see FARMACROPARSEERRORCODE)
       COORD ErrPos; // строка и позиция в строке, где парсер нашел ошибку
       const wchar_t *ErrSrc; // "слово" вызвавщее ошибку, может быть пустым в зависимости от кода ошибки
     } MacroResult;

3. Mantis#0001266: Far падает при разборе Macro
   Забыл, что UserDefinedList не берет на грудь 1 значение (в данном случае однострочный макрос)
   Затычки поставлены, но...
     TODO: переделать UserDefinedList, чтобы мог изображать из себя массив из одного элемента.

drkns 09.02.2010 10:51:57 +0200 - build 1380

1. Уточнение обработки мыши в диалогах.

drkns 09.02.2010 09:39:19 +0200 - build 1379

1. Поправка к 1378.2.

drkns 08.02.2010 19:07:17 +0200 - build 1378

1. Продолжение 1367.

2. Ещё пара мелочей.

svs 08.02.2010 17:26:40 +0300 - build 1377

1. Macro: добавлен "алиас" PANEL.ITEM для функции PANELITEM (для единообразия в названии)

2. Macro: учтонение парсера.

3. В UserDefinedList добавлен флаг ULF_NOTTRIM - дабы не резать пробелы.

drkns 08.02.2010 16:03:25 +0200 - build 1376

1. Уточнение трюка, введённого в 1205: восстанавливаем размеры окна только если после получения фокуса они были уменьшены.

drkns 08.02.2010 11:18:56 +0200 - build 1375

1. Mantis#0001264: выводить процент выполнения удаления в заголовке.

2. В диалоге подтверждения расшифрования не работал выбор 'Skip all'.

3. Ошибка при обработке метасимволов.

drkns 06.02.2010 15:10:19 +0200 - build 1374

1. При обработке FCTL_<SET|INSERT>CMDLINE отключаем дополнение.

drkns 05.02.2010 20:42:59 +0200 - build 1373

1. Уточнение логики закрытия плагиновой панели.

2. Mantis#0001259: неперерисовка файловой панели после смены папки.

drkns 04.02.2010 20:48:39 +0200 - build 1372

1. В 1369 отвалилось удаление пунктов пользовательского меню.

drkns 03.02.2010 21:23:01 +0200 - build 1371

1. По просьбам телезрителей средняя кнопка мыши вновь работает как Enter в панелях, справке и меню.
   Причём всегда. Опции нет, ибо есть макросы.

2. Несколько переделана обработка мыши в справке.

3. x<wcs|str>n<cpy|cat> изменены, теперь третий параметр - размер приёмника.

4. Ошибка в oldfar::ESPT_GETWORDDIV.

5. gcc warning.

drkns 03.02.2010 15:08:26 +0200 - build 1370

1. При выборе элемента из истории команд вызывалось ненужное в этом случае дополнение.

2. Убраны неактуальные BlockExtKey.

3. Поиск файлов больше не падает при нажатии F11, также там теперь доступен список задач.

drkns 02.02.2010 20:36:50 +0200 - build 1369

1. Поправка к 1366.

2. Продолжаем давить *printf.

chupakabra 02.02.2010 16:20:00 +0200 - build 1368

1. Некорректно отображалась дата для папок на панели плагина.

drkns 01.02.2010 23:28:33 +0200 - build 1367

1. Поправка к 1366.

drkns 01.02.2010 21:44:16 +0200 - build 1366

1. From Alexey Samlyukov: при наличии в hlf-файле секции ".Options" не учитывалась секция ".PluginContents".

2. В строках ввода работает выделение текста мышью. К редактору это пока не относится.

3. С правого края командной строки отображается кликабельная стрелка, по аналогии с комбинированным списком в диалогах.

drkns 31.01.2010 20:56:38 +0200 - build 1365

1. Не обновлялись панели после применения фильтров.

svs 31.01.2010 17:57:22 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal

drkns 31.01.2010 16:37:49 +0200 - build 1364

1. В плагиновых панелях не показывался упакованный размер элементов.

drkns 30.01.2010 20:09:48 +0200 - build 1363

1. Mantis#0001257: File sharing violation when attempting to open Editor from Viewer.

drkns 29.01.2010 22:29:05 +0200 - build 1362

1. После 597 поломалась плагиновая сортировка элементов панели.

drkns 29.01.2010 21:01:29 +0200 - build 1361

1. Ещё раз о макросах и дополнении.

drkns 28.01.2010 18:47:28 +0200 - build 1360

1. В диалогах по F11 могло вызываться панельное меню плагинов.

2. Любителям макросов: у списка автодополнения теперь своя область - "AutoCompletion".

svs 28.01.2010 16:45:53 +0300 - build 1359

1. Macro: Некорректная работа AKey()/$AKey.

drkns 28.01.2010 11:27:44 +0200 - build 1358

1. Mantis#0001256: При наборе текста в командной строке стираются закладки плагина PanelTabs

t-rex 27.01.2010 21:59:14 +0200 - build 1357

1. Mantis#1255: Фар виснет при запуске far /v -

chupakabra 26.01.2010 19:57:00 +0200 - build 1356

1. From Maximus: Mantis#0001117: Ошибочная пометка файлов кнопкой мышки при прокрутке.

chupakabra 26.01.2010 19:34:00 +0200 - build 1355

1. FSF.GetDirList теперь возвращает полные пути к файлам.

chupakabra 24.01.2010 18:15:00 +0200 - build 1354

1. Mantis#0001251: Некорректный показ типа оптического привода.

yole 23.01.2010 14:15:00 +0300 - build 1353

1. В меню Alt-F1/Alt-F2 клавиша F9 показывает диалог для настройки режимов отображения меню -
   чтобы не перебирать Ctrl-циферки. Также в меню добавлена подсказка по доступным клавишам.

2. Включим показ типа CD-ROM по дефолту.  

svs 22.01.2010 17:15:01 +0300 - build 1352

1. Mantis#0001201: В Far 2 не работает переход на URL

2. Уточнение в хелпе URL`ов (раздел "@PluginsReviews")

svs 22.01.2010 14:46:29 +0300 - build 1351

1. Mantis#0001240: Внешний редактор не запускается если путь к нему содержит пробелы и предварён символом @

drkns 22.01.2010 00:40:31 +0200 - build 1350

1. Пара мелочей по автодополнению.

chupakabra 20.01.2010 21:19:00 +0200 - build 1349

1. Ошибка в FarGetDirList. Из-за этого не работало копирование содержимого каталогов в TmpPanel.

2. ACTL_QUIT не срабатывала если было открыто меню.

chupakabra 20.01.2010 08:05:00 +0200 - build 1348

1. ACTL_QUIT - завершает работу Far.

chupakabra 20.01.2010 07:38:00 +0200 - build 1347

1. Под win2k QueryDosDevice() выдает ошибку при большом размере буфера. Добавлена apiQueryDosDevice().

2. UnicodeString::SubStr().

zg 19.01.2010 22:58:11 +0200 - build 1346

1. в списке дополнений не отображается символ "&".

svs 18.01.2010 10:26:51 +0300 - build 

1. Mantis#0001246: Не собирается в gcc под Linux'ом. Некорректный include в edit.cpp

svs 17.01.2010 21:26:17 +0300 - build 1345

1. Mantis#0001242: Некорректная работа AKey$
   $AKey теперь возвращает реально-нажатое сочетание, которым вызывался макрос

2. Mantis#0001239: Получение через AKey нажатой клавиши с учетом раскладки клавиатуры
   Добавлен необязательный параметр функции akey()
     V=akey(Mode[,Type])
       Mode = 0 - число
              1 - строка
       Type = 0 - возвращает реально-нажатое сочетание, которым вызывался макрос
              1 - возвращает клавишу, на которую назначен макрос.

yole 17.01.2010 00:20:00 +0300 - build 1344

1. Научимся узнавать BD-ROM драйвы в Alt-F1/Alt-F2.

yole 16.01.2010 18:50:00 +0300 - build 1343

1. DialogBuilder поддерживает layout control'ов в две колонки.

2. Переведём настройки вьюера и редактора на DialogBuilder.

yole 16.01.2010 14:45:00 +0300 - build 1342

1. Продолжаем рефакторить DialogBuilder с целью его использования в плагинах.

2. Для полей ввода числовых значений, создаваемых при помощи DialogBuilder,
   автоматически выставляется маска, разрешающая вводить только цифры.

drkns 16.01.2010 12:39:15 +0200 - build 1341

1. С форума: "Глюк с заменой в редакторе".
   Тянется вроде как ещё с 498 билда.

drkns 16.01.2010 00:42:36 +0200 - build 1340

1. Продолжение 1338.

drkns 15.01.2010 07:57:05 +0200 - build 1339

1. При создании символических ссылок некорректно запрашивались требуемые привилегии.

drkns 14.01.2010 20:45:19 +0200 - build 1338

1. Поправлены регрессы 1337.

drkns 13.01.2010 20:42:34 +0200 - build 1337

1. Имена файлов, оканчивающиеся на точку, неправильно отображались в режимах панели с включенным выравниванием расширений.

2. Рефакторинг. Удалена связанная с дополнением копипаста. Возможны последствия, соблюдаем осторожность.

3. x64 warnings.

drkns 13.01.2010 19:22:50 +0200 - build 1336

1. И снова TreeCmp, более правильный вариант.

t-rex 12.01.2010 23:07:52 +0200 - build 1335

1. FarDialogItem.Param.ListPos теперь централизовано выставляется при всех "получениях" структуры от фара.
   Кривые плагины которые надеялись что будет выставлен FarDialogItem.Param.ListItems полетят.
   О таких случаях в анси плагинах просьба сообщать, хотя быть такое не должно.

svs 12.01.2010 11:53:24 +0300 - build 1334

1. Дерево. Откат функции сортировки TreeCmp на предыдующую ревизию (3917) (было в build 1295)

2. Уточнения SysLog`ов

drkns 11.01.2010 20:07:38 +0200 - build 1333

1. Поправлены зависимости в проектах.

2. DIF_EDITPATH/FIB_EDITPATH в api.

3. Текст в строках ввода иногда оказывался левее X1 и не отображался.

4. Разные косметические мелочи.

5. Уточнения справки.

chupakabra 11.01.2010 02:28:00 +0200 - build 1332

1. const в plugin api.

drkns 11.01.2010 01:19:27 +0200 - build 1331

1. Mantis#0000848: Find Folder: неправильная обработка символа *.

t-rex 10.01.2010 23:55:43 +0200 - build 1330

1. Избавляемся от NM в plugin.hpp.

2. GCC ворнинг.

drkns 10.01.2010 23:39:29 +0200 - build 1329
 
1. C форума: Find Folder: неправильная отрисовка дерева в Фар 2.
 
2. x64 warnings.
 
3. gcc сборка.

4. Устаканивание дополнения.

yole 10.01.2010 18:50:00 +0300 - build 1328

1. Начало большого рефакторинга DialogBuilder'а, позволяющего использовать один и тот же
   API для построения диалогов и в самом FAR'е, и в его плагинах.

drkns 09.01.2010 14:17:27 +0200 - build 1327

1. Вернём обратно FarDialogItem.MaxLen )

drkns 09.01.2010 13:51:28 +0200 - build 1326

1. DWORD Reserved2 -> DWORD_PTR Reserved2.

drkns 09.01.2010 12:59:15 +0200 - build 1325

1. Вместо FarDialogItem.MaxLen теперь DWORD Reserved2. Должен быть равен 0.

drkns 08.01.2010 22:51:39 +0200 - build 1324

1. Логическое продолжение 1277 - синхронизируем CurrentDirectory только если есть неуникодные плагины.

2. Прибит DIF_NOTCVTUSERCONTROL + мелкая косметика во враппере. 

drkns 08.01.2010 18:00:43 +0200 - build 1323

1. Mantis#0001238: Неправильная подсветка при замене в редакторе.

t-rex 08.01.2010 13:54:21 +0200 - build 1322

1. компиляция vc для 1321.

zg 08.01.2010 13:46:03 +0200 - build 1321

1. забытые файлы в 1320.

zg 08.01.2010 13:30:56 +0200 - build 1320

1. диалог перезаписи файла имеет идентификатор {9FBCB7E1-ACA2-475d-B40D-0F7365B632FF}.

drkns 08.01.2010 01:30:08 +0200 - build 1319

1. Ещё всякое по автодополнению + зачатки конфигурации.

2. Все автогенерируемые во время сборки файлы теперь складываются в отдельный каталог, дабы не маячили.

zg 07.01.2010 18:21:09 +0200 - build 1318

1. убиты LIF_USETEXTPTR и MIF_USETEXTPTR.

zg 07.01.2010 17:44:21 +0200 - build 1317

1. const в plugin api.

2. GetComputerNameEx в gcc.

svs 07.01.2010 17:12:00 +0300 - build 1316

1. Немного пересобрал InfoList. Вместо абс.указываемых координат Y используются относительные.

2. Уточнение для subst-дисков - ранее показывалась инфа от родительского корня.
   вместо strDriveRoot, полученного из GetPathRoot, применим ExtractPathRoot(strCurDir), ибо
   GetPathRoot старается раскрутить все по полной.

3. В настройки InfoPanel добавлена опция "Формат вывода имени компьютера" (о чем описанов в хелпе).
   Теперь бы вменяемо (исходя из описания) обозвать эти пункты комбобокса :-)

yole 07.01.2010 12:00:00 +0300 - build 1315

1. Вернём на место опцию, потерянную при переводе настроек на динамические диалоги.

2. Система динамического построения диалогов обучена работать с комбо-боксами.
   Переведен на новую систему диалог InfoPanel Settings.

drkns 07.01.2010 01:19:43 +0200 - build 1314

1. И ещё пара мелочей.

drkns 07.01.2010 00:57:40 +0200 - build 1313

1. Ещё всякое по автодополнению.

zg 06.01.2010 22:36:35 +0200 - build 1312

1. gcc warnings.

drkns 06.01.2010 18:54:47 +0200 - build 1311

1. Изменения в FSF.MkTemp - функция возвращает требуемый размер буфера.

drkns 05.01.2010 20:52:04 +0200 - build 1310

1. С форума: уточнение поведения списка "Already existing files" в диалоге копирования.

2. Следствие 1 пункта: в открытый комбинированный список теперь приходит событие DN_LISTHOTKEY.

3. Удалён OPIF_FINDFOLDERS за ненадобностью.

drkns 05.01.2010 19:50:30 +0200 - build 1309

1. Новые actl-команды: ACTL_SETPROGRESSSTATE, ACTL_SETPROGRESSVALUE.
   Предназначены для управления кнопкой Far на панели задач.

2. Удалена ACTL_GETWCHARMODE за ненадобностью.

drkns 03.01.2010 21:37:53 +0200 - build 1308

1. Ещё всякое по автодополнению.

drkns 03.01.2010 18:36:49 +0200 - build 1307

1. Изменения/уточнения работы нового режима дополнения.

2. Откат 1306 - ложная тревога )

drkns 03.01.2010 16:42:56 +0200 - build 1306

1. FSF.ConvertPath не возвращала необходимый размер буфера.

drkns 02.01.2010 13:38:25 +0200 - build 1305

1. Mantis#0001233: При замене в редакторе не подсвечивается место, которое предлагается заменить.

svs 29.12.2009 15:10:25 +0300 - build 1304

1. На счет языкозависимого %FARADMINMODE% погорячился :-)
   
   Очередная итерация...
   
   Теперь 
     %FARADMINMODE% число и равно 1, если под мы админом
   
   У cmdprompt новый '$@xx' (см. MConfigCmdlinePromptFormatAdmin)
   здесь 'xx' - два символа, которыми будет обрамлено слово "Администратор" 
   Например, "$@{}$s$p$g" будет представлен как "{Администратор} C:\>"

svs 29.12.2009 13:33:22 +0300 - build 1303

1. Mantis#0001228: Macro Problem (wrong results in 'Index')
   Добавлены доп.пораметры для макрофункций
      N=index(S1,S2[,Mode])
      S=rindex(S1,S2[,Mode])
      Result=replace(Str,Find,Replace[,Cnt[,Mode]])
   Здесь Mode: 
      0 - case insensitive
      1 - case sensitive

2. Macro: msave() для значения типа double сохраняет значение в виде строки.

3. Если Far в режиме "администратор", то выставляется переменная среды FARADMINMODE, равная "(Администратор)"  (см. MConfigCmdlinePromptFormatAdmin)
   Может применяться в CmdPrompt.

drkns 29.12.2009 00:44:26 +0200 - build 1302

1. Расставляем DIF_EDITPATH во всех нужных диалогах.

2. Уточнения нового режима дополнения.

yole 29.12.2009 00:11:00 +0300 - build 1301

1. Продолжаем работать над системой динамического построения диалогов.
   Добавлена поддержка сепараторов, радиокнопок, префиксного текста, истории.
   Переведены system settings, panel settigns, file description settings.

drkns 28.12.2009 19:10:00 +0200 - build 1300

1. Очередные эксперименты с автодополнением.
   Теперь поведение оного максимально приближено к системному, а именно:
   при наборе автоматически раскрывается список с подходящими вариантами, сокращающийся по мере ввода.
   Т.е. ничего никуда против воли пользователя не подставляется и при этом вроде всё интуитивно понятно.
   Надеюсь, этот вариант устроит всех.

   Через интерфейс пока ничего настраивается, уж извиняйте. Позже.

   З.Ы. В качестве бонуса (и для полного соответствия системному поведению) туда же добавлено примитивное дополнение файловых имён.
   Работает в комстроке и тех диалоговых строках ввода, у которых установлен флаг DIF_EDITPATH.
   На данный момент сей флаг установлен только в диалогах открытия/сохранения файла (ShiftF4/ShiftF2).

yole 26.12.2009 19:30:00 +0300 - build 1299

1. Продолжаем работать над системой динамического построения диалогов.
   Добавлена поддержка edit fields, статического текста, automation.
   Ещё пара диалогов из настроек переведены на новую систему.

drkns 26.12.2009 16:14:42 +0200 - build 1298

1. Уточнение 1295.2.

yole 26.12.2009 16:20:00 +0300 - build 1297

1. Заготовка для системы динамического построения диалогов: DlgBuilder.cpp/hpp

2. Опция для включения/выключения слепого режима autocompletion.

yole 25.12.2009 23:32:10 +0300 - build 1296

1. Слепой режим для autocompletion (эксперимент):
   http://bugs.farmanager.com/view.php?id=274

drkns 25.12.2009 19:24:01 +0200 - build 1295

1. Восстановим визуализацию при ошибках сохранения в редакторе.

2. Новые кнопкосочетания в панелях: CtrlShift<Up|Down|Num8|Num2>.
   Меняют высоту только текущей панели.

2. Массовое истребление бессмысленных и беспощадных снятий константности в Local, LocalOEM и других местах.

3. Массовое истребление объявлений счётчика за пределами цикла.

t-rex 25.12.2009 16:46:03 +0200 - build 1294

1. Логическое завершение 1246. Теперь в общем плагины могу делать детач окну фара и это вроде как должно работать.
   Пока что заметил что частично поломался плагин MakeIt, будем разбиратся.
   Интересно знать если ещё что то такое с не стандартным выводом поломалось.

chupakabra 24.12.2009 23:37:00 +0200 - build 1293

1. При загрузке Far мог появлятся индикатор записи макро из-за того что KeyMacro::Recording не была инициализирована.

drkns 24.12.2009 21:33:21 +0200 - build 1292

1. Уберём пока DList из MacroState, до лучших времён.

drkns 24.12.2009 17:53:01 +0200 - build 1291

1. Опечатка в 1290.

drkns 24.12.2009 01:51:44 +0200 - build 1290

1. Задавим ещё немного memcpy и memset.

2. Если плагин пытался изменить фокус в момент открытия комбинированного списка - последствия были печальны.

drkns 23.12.2009 20:13:46 +0200 - build 1289

1. Уточнения 1287 билда.

2. Уточнения справки.

t-rex 22.12.2009 22:21:07 +0200 - build 1288

1. Mantis#1147: Ошибка при запуске \

2. Немного разной чистки.

drkns 22.12.2009 21:23:23 +0200 - build 1287

1. Используем DList вместо повторных имплементаций списка ещё в нескольких местах.

2. Немного добавок в DList.

drkns 18.12.2009 22:14:58 +0200 - build 1286

1. В регулярных выражениях \x теперь поддерживает до четырёх 16-ричных цифр, дабы охватить уникод.

2. При замене в редакторе выделение зачем-то рисовалось вручную поверх текста.
   Если при этом туда попадали символы табуляции - начинались чудеса.

3. Хелп для "Far window title addons".

t-rex 18.12.2009 17:59:11 +0200 - build 1285

1. По запросам публики, дополнение к 1282, если в настройках интерфэйса фара опция Mouse отключена,
   то доп. режим консоли quick edit не будет отключен если он включен для шортката/окна.

drkns 17.12.2009 21:00:01 +0200 - build 1284

1. К шаблонам заголовка консоли добавлен %Platform (x86/x64/IA64) и шаблоны теперь регистронезависимые.

drkns 13.12.2009 22:22:11 +0200 - build 1283

1. TI#48 не влияло на NumDel.

t-rex 13.12.2009 00:40:22 +0200 - build 1282

1. ЖЖ пока возвращяется, без неё пока проблемы а на полную переделку пока что нету времени.
   Там надо тупо всё переписывать, лучше бы я туда не лазил.

2. Отключаем доп. режимы консоли (quick edit/insert mode) во время работы в фаре,
   но если они были включены при запуске фара то на время запуска внешних прог в окне фара они будут
   включатся назад.

3. Мелочи разные.

drkns 12.12.2009 23:57:53 +0200 - build 1281

1. Уточнения предыдущего билда.

drkns 12.12.2009 23:44:12 +0200 - build 1280

1. Панель информации:
   - статус файла подкачки теперь называется как положено, а не "виртуальная память";
   - добавлено отображение настоящей виртуальной памяти;
   - добавлено отображение физически установленной памяти. Работает в Vista и выше.

2. При нажатии ShiftF8 на элементе ".." и наличии выделения в панели производилась попытка этот элемент удалить, со всеми вытекающими.

t-rex 07.12.2009 23:20:24 +0200 - build 1279

1. Mantis#1157: .. - выход из временной панели в предыдущую.

2. Жопастая жопа да ещё и доисторическая, при OpenFilePlugin() не создавалась новая панель
   а реюзалась существующая.

t-rex 07.12.2009 21:03:31 +0200 - build 1278

1. Устаканивание синхронизации текущего пути и пару связанных мелочей.
   Надо бы ещё CriticalSection поставить вокруг доступа к внутренему strCurrentDirectory().

t-rex 07.12.2009 17:59:07 +0200 - build 1277

1. Будем синхронизировать текущею папку процеса с папкой в фаре,
   ибо из за 1275 она стала вообще не предвиденной что привод ещё к серии проблем.
   А що делать то? Так вроде всё ок, но теперь трудней будет найти глючные плагины которые
   получают текущий путь не у фара а у винды так как теперь кроме как для "не стандартных"
   путей они будут одинаковые.
   Я так думаю надо сделать такое: выкинуть нафиг поддержку анси плагинов. Решается и эта проблема и у людей
   сразу мотивация будет портировать плагины.

t-rex 06.12.2009 23:01:16 +0200 - build 1276

1. Разная мелочь.

t-rex 06.12.2009 20:52:04 +0200 - build 1275

1. Убрал CurrentDirectoryGuard, теперь есть только SynchronizeCurrentDirectory() без востановления,
   ибо частое прыганье текущей папки процесса туда сюда при вызове анси плагинов приводило к разнообразным проблемам.

2. Мелкии корекции в менеджере плагинов.

drkns 06.12.2009 11:14:26 +0200 - build 1274

1. Неправильный символ пометки в меню.

drkns 05.12.2009 18:46:16 +0200 - build 1273

1. Как внезапно выяснилось, эти ваши трюки с админом в заголовке вообще не работали,
   т.к. состояние принадлежности пользователя к админской группе бралось из астрала.
   Там же: убрана проверка версии Windows (надо проверить, как будет работать на NT<6) и ещё пара мелочей.

t-rex 05.12.2009 17:29:08 +0200 - build 1272

1. Переделки в TitleAddons:
   a. Опция в гуи. Просьба всегда добавлять для новых фич гуи, скажем нет техинфо.
   b. Никакие пробелы и т.п. никуда не подставляются, строка вписывается как есть.
   c. Все добавки идут после " - Far ", этот кусок нефиг лапами трогать.
   d. Пробелы с конца удаляются если кому то интересно.
   e. Версия фара во время работы не меняется, нефиг каждый раз её считывать :)
   f. Строка по дефолту теперь "%Ver.%Build %Admin".
   g. В lng теперь админ прописан без скобок и пробела.

t-rex 05.12.2009 16:36:12 +0200 - build 1271

1. Ещё одна переделка в apiGetFinalPathNameByHandle() чтоб было красивей и правильней.

t-rex 05.12.2009 14:27:07 +0200 - build 1270

1. Mantis#1202: Падение при нажатии Shift-F8 в редакторе и вьвере.
   Глюк был всегда, но стало падать тока сейчас.

2. Некоректная сортировка кодировок в Favorites.

3. VMenu: надо коректировать SelectPos при добавлении нового пункта перед помеченым.

t-rex 05.12.2009 11:57:27 +0200 - build 1269

1. VMenu: глючок в DleteItem().

t-rex 05.12.2009 10:53:56 +0200 - build 1268

1. Продолжаем ломать VMenu.

t-rex 05.12.2009 00:20:30 +0200 - build 1267

1. Ещё немного чистки в global.hpp.

2. Глюки в ConsoleTitle.

t-rex 04.12.2009 22:06:38 +0200 - build 1266

1. Частичный рефакторинг класса VMenu (меню, комбы, листбоксы), чтоб можно было относительно удобно вносить в него новый функционал.
   Должны исправится различные глюки, особенно глюки связанные с пометкой, хидден пунктами, мышой и т.п.
   Теперь класс упорно следит за пометкой и т.п., и его нельзя запутать извне.
   Теперь будет проще доделать полноценный функционал фильтра меню.
   Глюки ожидаются, и даже наверно много!

2. Исправления в apiGetFinalPathNameByHandle() и в её использовании.

3. Не собирался debug.

svs 04.12.2009 19:09:57 +0300 - build 1265

1. По мотивам сорцов "GKTem" (а точнее здесь http://msdn.microsoft.com/en-us/library/aa376389%28VS.85%29.aspx) и 
   "vkh" (настраиваемый заголовок) добавлен механизм определения 
   окончания заголовка консоли (раньше жестко был зашит " - Far").
   а) добавка к заголовку представляет из себя шаблон;
   б) добавку Far берет из реестра Interface/TitleAddons:REG_SZ, по умолчанию " - Far%Ver%Admin";
   в) шаблонные символы, которые понимает Far:
         1. %Ver - текущая версия Far Manager, например, " 2.0" - Far самостоятельно добавляет пробел перед версией;
         2. %Build - текущий билд Far Manager, например, " 1259" - Far самостоятельно добавляет пробел перед билдом;
         3. %Admin - в Vista и выше заменяется на значение из lng-файла: по умолчанию " (Администратор)"/" (Administrator)" - Far самостоятельно НЕ добавляет пробел.    

   Развивая эту тему можно добавить... шаблон "%Debug" для особых извращенцев ;-)

2. Функция SetFarTitle() вынесена из interf.?pp в класс ConsoleTitle.

3. Macro: добавка в п.1 "IsUserAdmin" - 1 или 0 - под кем запущен Far
   Тут есть непонятка (для меня :-)...  сейчас IsUserAdmin и в заголовке добавка "(Администратор)" не пишется (для меньше "Висты")
   возможно, что IsUserAdmin для ниже висты все же должен быть 0, даже если мы админы на тачке.
   Пока так и сделано (см. constitle.cpp::GetFarTitleAddons())

chupakabra 04.12.2009 17:32:00 +0200 - build 1264

1. GetFinalPathNameByHandle() завернута в __try __except чтобы предотвратить падение на Windows 7 + Ext2FSD.

t-rex 04.12.2009 10:53:20 +0200 - build 1263

1. from Igor Braginskiy: для CD/CHDIR "обработаем" (проигнорируем) /D,
   мы и так всегда меняем диск а некоторые в алайясах или по привычке набирают этот ключ.

2. from Igor Braginskiy: лишняя перерисовка в запускаторе.

3. Секьюрность в проверке заголовков экзэшников.

4. Потенциальный AV при обработке "echo.".

5. Косметика и около.

chupakabra 04.12.2009 05:47:00 +0200 - build 1262

1. Mantis#0000975: Колонка с именем файла отображается последней в диалоге результатов поиска.

2. Исправление горизонтальной прокрутки VMenu.

t-rex 02.12.2009 23:04:07 +0200 - build 1261

1. Ворнинг и около.

t-rex 02.12.2009 22:03:01 +0200 - build 1260

1. Переборщил немного в PathCanHoldRegularFile().

2. Удалил пару функций дупликатов.

3. Немного косметики подороге.

zg 02.12.2009 00:10:59 +0200 - build 1259

1. продолжение 1258. теперь в колонке Packed реальные значения.

zg 01.12.2009 23:21:54 +0200 - build 1258

1. Mantis#0000916: Мусор в Detailed mode, колонка Packed.

t-rex 01.12.2009 20:37:20 +0200 - build 1257

1. Немного различной косметики в коде.

chupakabra 01.12.2009 08:08:00 +0200 - build 1256

1. Mantis#0001104: При отображении дерева не пытаемся определить реальный корень диска, а используем тот что присутствует в текущем пути.

t-rex 01.12.2009 03:13:36 +0200 - build 1255

1. Все изменения в коде только косметические. Тупо надоела уже мешанина табов и пробелов и т.п.
   Прогрнал на сорцы следующее:
   AStyle --style=ansi --indent=tab=4 --brackets=break --indent-classes --indent-switches --indent-namespaces --indent-preprocessor --break-blocks --delete-empty-lines --unpad-paren --keep-one-line-statements --keep-one-line-blocks
   Не идеально конечно, но уже намного приятней.
  
   Так что не забываем, в коде нужно использовать табы. Таб == 4 пробела.
   Надо будет собраться и написать хоть какой то документ по стилю кода.

t-rex 01.12.2009 00:37:09 +0200 - build 1254

1. Ещё немного чистки в global.hpp.

2. Юзаем везде string.Clear() вместо string.SetLength(0) и string=L"", так и быстрей и красивей.

3. Пару мелких оптимизаций в UnicodeString.

t-rex 30.11.2009 20:20:11 +0200 - build 1253

1. После 1246-3 при закрытии диалога стал посылатся DN_EDITCHANGE всем эдитам.
   Что приводило к различным глюкам включая Mantis#1192: Падение при создании фильтра.

2. Mantis#1190: При использовании в полях ввода переменных окружения в историю попадает как сама переменная, так и её значение.
   Глюк старый но всплыл из за 1246-3.

svs 30.11.2009 12:10:30 +0300 - build 1252

1. Отвалился syslog.cpp...

t-rex 30.11.2009 09:23:05 +0200 - build 1251

1. Поломал случайно загрузку FarMenu.ini в 1248.

t-rex 29.11.2009 23:04:39 +0200 - build 1250

1. Ещё немного чистки в global.hpp.

t-rex 29.11.2009 21:45:45 +0200 - build 1249

1. Корекция кода по работе с clipboard.

t-rex 29.11.2009 20:33:41 +0200 - build 1248

1. Mantis#1188: Длительный (25 секунд) вход в сетевую шару из плагина Network.
   Файл описаний искался в списке шар.

2. Похожий фикс для usermenu. Если нажали F2 находясь в списке шар то не будем искать там FarMenu.ini.

3. Различные мелочи по дороге.

drkns 29.11.2009 19:31:17 +0200 - build 1247

1. Как выяснилось, редактор пихал сигнатуру в уникодные файлы независимо от состояния переключателя в диалоге сохранения.
   И, что интересно, уже весьма давно.
   Отсюда же ноги росли у Mantis#0001079: Опция [x] Add signature (BOM) всегда стоит.

2. Пара уточнений в "блокираторе" 16-ричного просмотра UTF-8.

3. Откат 2 пункта 1237 билда. Этот диалог таки достаёт, да.

4. При сохранении по ShiftF2 текущая позиция в комбинированном списке "Кодовая страница:" бралась откуда-то из астрала.

t-rex 29.11.2009 02:23:03 +0200

1. Флаг NO_RELEASE_PDB для мэйка.

t-rex 28.11.2009 21:57:13 +0200

1. Добавим /Oy- для релиза, чтоб "помочь" fexcept.

drkns 28.11.2009 21:55:50 +0200

1. Синхронизация проектов с makefile.

t-rex 28.11.2009 20:39:31 +0200 - build 1246

1. В Win7 x64 фар не запускается под Application Verifier из за глюка в последнем.
   Будем использовать GetStdHandle() вместо CreateFile(CON*$).
   Если всё будет ок, то в будущем после доп. переделки плагины смогут безболезнено делать детач окну фара.
   Потестируйте на разных телнетах и т.п. и т.д.

2. pdb в релизе.

3. Не работал в общем DIF_EDITEXPAND, и как следствие Mantis#1185: Не работает подстановка имён при создании новой папки/каталога.

4. Mantis#1184: Farmenu.ini не работает из "некорректного" пути.

t-rex 28.11.2009 15:11:26 +0200 - build 1245

1. Несколько мелких оптимизаций в strmix.cpp по работе с UnicodeString.

2. gcc ворнинги.

drkns 28.11.2009 13:10:50 +0200

1. Ещё немного правок в makefile_vc: VC2008 теперь по умолчанию, автоопределение целевой платформы.

drkns 28.11.2009 02:53:22 +0200 - build 1244

1. Всякая косметика в makefile_vc и, как следствие, немного в коде.

t-rex 28.11.2009 02:18:44 +0200 - build 1243

1. Немного поспешил в 1242, вернём взад.

t-rex 28.11.2009 01:08:27 +0200 - build 1242

1. Убрал ограничение на длину строки в MenuFileToReg().

t-rex 28.11.2009 00:35:30 +0200 - build 1241

1. Mantis#1180: Cannot update file description.
   Описания в путях с точкой на конце и т.п.

chupakabra 27.11.2009 23:14:00 +0200 - build 1240

1. Падение после команды вида cd \\MAXW7.

t-rex 27.11.2009 21:52:52 +0200 - build 1239

1. Одна мелочь, на всякий пожарный.

chupakabra 26.11.2009 18:35:00 +0200 - build 1238

1. Mantis#0001176: Не снимается RO при копировании файлов с CD.

drkns 26.11.2009 11:10:35 +0200 - build 1237

1. Mantis#0001175: Неправильно обрабатывается Ctrl-Enter при автозаполнении.

2. При сохранении файла в редакторе по F2, если файл до этого не существовал, теперь выводится диалог сохранения.

3. Project & solution для Visual Studio 2010.

drkns 26.11.2009 02:15:04 +0200 - build 1236

1. К редактору прикручена возможность визуализации табуляций и пробелов.
   Для управления доступны:
    - в интерфейсе - "[ ] Show white space";
    - в API - EOPT_SHOWWHITESPACE, ESPT_SHOWWHITESPACE;
    - в макросах - Editor.Set(20,State).

drkns 25.11.2009 15:56:12 +0200 - build 1235

1. Исправления в общем индикаторе удаления.

t-rex 23.11.2009 20:26:00 +0200 - build 1234

1. Эксперимент с подставлением всей строки а не только дополнения при автокомлите не прошел успешно.

2. Соединил пару ифоф в один в ScreenBuf::Flush().

t-rex 22.11.2009 22:37:12 +0200 - build 1233

1. Более "оптимизированная" работа Opt.ClearType.

drkns 22.11.2009 17:10:02 +0200 - build 1232

1. Mantis#0001172: Ошибка наследования прав доступа при переносе с использованием относительных путей

drkns 22.11.2009 09:18:07 +0200 - build 1231

1. Уточнение предыдущего билда.

drkns 22.11.2009 00:37:00 +0200 - build 1230

1. К комстроке прикручено автодополнение, аналогичное диалоговому.

2. Добавлен диалог настроек комстроки.

3. Перетасовка настроек: начало. Некоторые опции слетят, нужно будет выставить заново вручную.

t-rex 21.11.2009 19:10:19 +0200 - build 1229

1. Залоченый режим фильтра - CtrlAltL.
   Когда фильтр залочен, то все нажатия кроме CtrlAltL и CtrlAltF уходят в меню на обработку.

2. Глючок с позицией курсора в фильтре.

t-rex 21.11.2009 18:17:15 +0200 - build 1228

1. Фильтр должен обрабатывать нажатия раньше всех.

t-rex 21.11.2009 17:16:09 +0200 - build 1227

1. Экспериментальная фича, встроенный фильтр во всех меню, комбах и листбоксах.
   Фильтр включается/выключается по CtrlAltF.
   Когда включен, фильтр ловит все "буквы">=32 и backspace.
   При включенном фильтре, различные глюки гарантируются.

t-rex 21.11.2009 14:06:52 +0200 - build 1226

1. Ещё немного оптимизаций и коректировок в истории.

svs 21.11.2009 11:52:06 +0300 - build 1225

1. Macro: Уточнение в Editor.Pos(), касаемо отрицательных значений...

2. немного форматирования текста :-)

t-rex 21.11.2009 01:59:20 +0200 - build 1224

1. Вернул автокомплит в диалогах.

chupakabra 20.11.2009 21:01:00 +0200 - build 1223

1. Mantis#0001145: Падение FAR при изменении размера окна результатов поиска по Alt+F9.

chupakabra 20.11.2009 20:23:00 +0200 - build 1222

1. Переписана процедура защиты от рекурсивных симлинков.
   FileIndex из GetFileInformationByHandle() больше не используется, т.к. любой кривой драйвер
   может прописать там все что угодно и будем опять иметь ситуацию когда "эксплорер копирует а Фар нет".
   Вместо этого используется сравнение путей, полученных с помощью ConvertNameToReal().

2. Добавлена bool DeleteEndSlash(wchar_t*, bool).

3. Добавлен Object* TPointerArray::lastItem().

drkns 20.11.2009 20:13:22 +0200 - build 1221

1. Не работала кнопка "wipe all" при уничтожении файлов.

drkns 20.11.2009 15:01:43 +0200 - build 1220

1. Продолжение 1219 - ShiftDecimal/NumDel.

zg 20.11.2009 14:06:57 +0200 - build 1219

1. с форума: при включённом нумлоке shift+цифровые стрелки работают как стрелки.

drkns 20.11.2009 13:35:56 +0200 - build 1218

1. Параметры-Настройки интерфейса-[ ] Показывать общий индикатор удаления.
   FarInterfaceSettings->FIS_SHOWTOTALDELPROGRESSINDICATOR

t-rex 20.11.2009 12:42:59 +0200 - build 1217

1. Ещё один древний баг в описаниях.

t-rex 20.11.2009 03:37:16 +0200 - build 1216

1. Ещё немного рефакторинга, прибил пару новых багов и ещё пару старых.

t-rex 20.11.2009 02:18:29 +0200 - build 1215

1. Рефакторинг класса описаний, поправилась куча разных багов.

drkns 19.11.2009 22:44:27 +0200 - build 1214

1. С форума: "Неправильная работа диалога атрибутов".

t-rex 19.11.2009 13:28:28 +0200 - build 1213

1. Более шустрое автоподставление последнего пункта истории в диалогах.

chupakabra 18.11.2009 00:20:00 +0200 - build 1212

1. Дополнение к build 1211.

chupakabra 17.11.2009 23:17:00 +0200 - build 1211

1. Использование GetVolumeNameForVolumeMountPointW() в ConvertNameToReal() вызывало нежелательную сетевую активность
   при наличии в системе сетевых дисков.

t-rex 17.11.2009 22:22:04 +0200 - build 1210

1. Снова затычки, чтоб решить баг винды приводящий к "застреванию" запускатора в Win7 в телнет сессии.

drkns 17.11.2009 00:46:37 +0200 - build 1209

1. Уточнение 1207.1.

t-rex 17.11.2009 00:07:50 +0200 - build 1208

1. Ахтунг! Начальная стадия переделки истории диалогов на использование общего класса истории.
   Формат хранения в реестре изменился!
   Вся текущая история диалогов (старый формат) игнорируется!!!!!!!
   Автозавершение, пока что не работает.
   Имеет смысл почистить [HKEY_CURRENT_USER\Software\Far2\SavedDialogHistory] от старой истории диалогов (ради чистоты и только).

drkns 16.11.2009 17:57:38 +0200 - build 1207

1. Замена 'Junction' на 'Volume' для точек монтирования работала не всегда.

3. Mantis#0001140: В win7 прогресс на таскбаре не останавливается если прервать поиск нажатием на [panel].

t-rex 16.11.2009 15:47:38 +0200 - build 1206

1. Юникод в описаниях:
   а. Если файл описаний имеет BOM то читаем файл в соот. кодировке.
   б. Если нету BOM то считает что файл описаний в OEM или ANSI в зависимости от новой настройки "ANSI by default".
   с. Сохраняться файл описаний будет либо в:
      - OEM или ANSI в зависимости от новой настройки "ANSI by default".
      - UTF8 + BOM если включена новая настройка "Save in UTF8".

   Todo:
   - Надо придумать более понятные имена этим настройкам и написать хэлп.
   - Подумать если стоит сохранять файлы описаний в той же кодировке в какой они изначально были, если был BOM.

drkns + t-rex 15.11.2009 22:40:40 +0200 - build 1205

1. Снова затычки, чтоб решить баг винды приводящий к появлению скролов и т.п. после потери фокуса
   максимизированного консольного окна (известная Win+L проблема со времён XP, и подобные чудеса в Win7).

chupakabra 08.11.2009 09:09:00 +0200 - build 1204

1. From Maximus: Mantis#0001163: Описание не показано, хотя оно есть в Descript.ion.

2. Неэффективный код в VMenu.

chupakabra 08.11.2009 08:08:00 +0200 - build 1203

1. VMenu::Show() не учитывал наличие субменю.

garry 06.11.2009 11:18:34 +0300 - build 1202

1. Проблемы с копирование через WebDav: http://forum.farmanager.com/viewtopic.php?f=9&t=4626
   (исправленный патч от Yegor).

chupakabra 05.11.2009 06:32:00 +0200 - build 1201

1. Mantis#0001104: Падение при попытке открыть панель дерева для mount point.

t-rex 04.11.2009 17:16:24 +0200 - build 1200 (UTF-16 LE :)

1. !?$<history>$<title>?<init>! - вместо history имя истории было мусором.

t-rex 04.11.2009 13:17:09 +0200 - build 1199

1. Изменения в ESPT_GETWORDDIV и EditorSetParameter.
   Вроде как это последнее место в API где не был известен размер буффера для получения данных.
   Теперь в EditorSetParameter есть поле Size (и cParam переименован в wszParam),
   при ESPT_GETWORDDIV, Size должен быть равен размеру буффера wszParam в символах,
   если Size или wszParam равны 0 то EditorControl вернёт нужный размер буффера в символах.

   Плагины использующие ESPT_GETWORDDIV нужно править.

chupakabra 04.11.2009 13:09:00 +0200 - build 1198

1. Mantis#0001158: При окне 80 на 25 меню дисков AltF2 неправильного размера (поломалось в 1190).

t-rex 04.11.2009 00:46:54 +0200 - build 1197

1. Помучаем UnicodeString ещё немного.

2. Ворнинг в gcc.

t-rex 03.11.2009 13:50:19 +0200 - build 1196

1. F9->Options - некорректная работа.

t-rex 03.11.2009 13:10:37 +0200 - build 1195

1. Продолжение Mantis#956: напротив некоторых плагинов в списке стит буква "А". В хелпе об этом ни слова.

2. Для меню плагинов открываля не тот топик хэлпа.

t-rex 02.11.2009 15:12:55 +0200 - build 1194

1. Mantis#1136: Падение Far при большом количестве выделенных файлов и использовании !&.
   Теперь обработка метасимволов использует только динамические буфферы.
   Проверяем что метасимволы не полетели, особенно разные комплексные которые диалоги показывают.

svs 02.11.2009 15:03:32 +0300 - build 1193

1. Mantis#0001155: trim() не отрезает \r и \n в начале строки

2. Имя пользователя в InfoPanel настраиваемо (по умолчанию NameUserPrincipal).
   Добавлен диалог настройки информационной панели.

   НУЖНА ПОМОЩЬ ДЛЯ: lng и hlf - корректно и доступно описать каждый из форматов.


zg 01.11.2009 16:52:52 +0200 - build 1192

1. Mantis#0001144: Ctrl-G обрабатывает каждый выделенный файл несколько раз.

t-rex 31.10.2009 20:39:13 +0200 - build 1191

1. Mantis#1148: Анси-плагины вызывают неприятное торможение в редакторе.
   При вызовах ProcessEditor*, ProcessViewer* и ProcessDialog* будем использовать
   единный CurrentDirectoryGuard для всего цикла вызовов и только если есть анси плагины с такими экспортами.
   В случае ProcessDialogEvent и ProcessEditorInput это все ровно особо не поможет (так как они вызываются дофига)
   поэтому не стоит использовать анси плагины которые экспортирует эти функции.
   Надо в общем подумать если можно придумать что то вместо CurrentDirectoryGuard.

chupakabra 30.10.2009 22:30:00 +0200 - build 1190

1. Mantis#0001083: Некорректная отрисовка VMenu.

yjh 30.10.2009 03:07:09 +0300 - build 1189

1. Для точек монтирования в строке статуса пишем 'Volume' а не 'Junction' -
   так получается нагляднее когда рядом есть и линки и точки монтирования

svs 29.10.2009 16:49:25 +0300 - build 1188

1. Mantis#0001142: Плавная горизонтальная прокрутка в редакторе
   В макросы добавлена функция "N=Editor.Pos(Op,What[,Where])" - Get/Set позиции в редакторе.

     Op: 0 - get, 1 - set
     What:
        1 - CurLine
        2 - CurPos
        3 - CurTabPos
        4 - TopScreenLine
        5 - LeftPos
        6 - Overtype

     Return: -1 - "не в теме", для "get" - текущее значение, для "set" - "угу" (1) или "не угу" (0)

     Пример (при включенном ScrollLock клавиши Left/Right занимаются скроллллингом)

     REGEDIT4

     [HKEY_CURRENT_USER\Software\far2\KeyMacros\Editor\Right]
     "Sequence"="$if(FLock(2,-1) == 1) Editor.Pos(1,5,Editor.Pos(0,5)+1); $else Right $end"
     "DisableOutput"=dword:00000001

     [HKEY_CURRENT_USER\Software\far2\KeyMacros\Editor\Left]
     "Sequence"="$if(FLock(2,-1) == 1) Editor.Pos(1,5,Editor.Pos(0,5)-1); $else Left $end"
     "DisableOutput"=dword:00000001

2. немного замены space на tab

t-rex 27.10.2009 18:04:07 +0200 - build 1187

1. Доделал Mantis#1087.

t-rex 27.10.2009 16:45:19 +0200 - build 1186

1. Mantis#1087: FCTL_SETPANELDIR не возвращает ошибку (0) для несуществующего пути.

2. CodeBlocks project update from Morten MacFly.

zg 27.10.2009 14:29:01 +0200 - build 1185

1. в статусе редактора было перепутано "Col" и текущая строка.

t-rex 26.10.2009 15:17:44 +0200

1. makefile_vc знает теперь и о VC10.

t-rex 26.10.2009 13:42:02 +0200

1. Убрал упоминание о (?{name}pattern) из хэлпа ибо мы это не поддерживаем.

2. Добавил хэлп по "ClearType friendly redraw".

yjh 26.10.2009 10:57:04 +0300 - build 1184

1. Ошибка в plugin.hpp - исходники плагинов бывают не только cpp, но и c.
   В смысле pure C :). 

chupakabra 26.10.2009 06:02:00 +0200 - build 1183

1. Исправлена обработка пустой входной строки в FSF.ConvertPath() и FSF.GetPathRoot().

t-rex 26.10.2009 00:45:52 +0200 - build 1182

1. Новая настройка интерфэса: [ ] ClearType friendly redraw (can be slow)
   По дефолту отключено. Вроде бы решает все проблемы артефактов клиртайпа.
   За одно наверно решает и проблему отрисовки иврита (если конечно шрифт моноширный).

t-rex 24.10.2009 23:39:28 +0200 - build 1181

1. Кто то забыл выставить FSF.GetCurrentDirectory :)

drkns 24.10.2009 20:23:01 +0200 - build 1180

1. Т. к. т. н. "текущий каталог" не всегда совпадает с тем каталогом, который в данный момент на панели, вводится некоторое уточнение:
    - добвлена FSF.GetCurrentDirectory - возвращает внутренний "текущий каталог" far;
    - FCTL_GETCURRENTDIRECTORY переименована в FCTL_GETPANELDIR, ибо этим и является.

    Плагины не сломались, но лучше их таки пересмотреть и при необходимости заменить FCTL_GETCURRENTDIRECTORY на FSF.GetCurrentDirectory.

drkns 23.10.2009 22:51:44 +0200 - build 1179

1. Mantis#0001137: Удаление директорий, в которых есть ссылки.

t-rex 23.10.2009 12:34:50 +0200 - build 1178

1. Вернём назад нормальный размер стека, ибо бага она в TmpPanel.

chupakabra 22.10.2009 22:16:00 +0200 - build 1177

1. Увеличен размер стека (а то tmppanel стала падать после замены MAX_PATH на NT_MAX_PATH)

drkns 21.10.2009 22:31:01 +0200 - build 1176

1. Mantis#0001131: Лишнее сканирование подкаталогов при удалении символической связи

2. Криво обрабатывалось переименование папок по маске.

svs 21.10.2009 18:08:30 +0300 - build 1175

1. В UserMenu "пропало" расстояние между "F10" и "Этим пунктом".

drkns 20.10.2009 20:35:25 +0200 - build 1174

1. При удалении файлов/папок отображается прогресс.

2. Mantis#0001112: Конфликт копирования/перемещения (папка или файл)

3. При отсутствии доступа к папке при попытке входа в неё выдавался неправильный код ошибки.

4. В корнях UNC-путей не показывается элемент "..".

5. printf, коррекция типов и т. п.

6. Показ овнера не работал для путей глубже MAX_PATH.
   На будущее - при передаче имён файловых объектов в функции Windows API используйте класс NTPath, он сам добавит объекту "curdir" в правильном формате.

7. Не работало шифрование папок.

svs 20.10.2009 17:03:59 +0300 - build 1173

1. Не показывает Owner в панелях (Ctrl-8)
   Добавим "curdir" тестируемому объекту.

svs 19.10.2009 11:41:50 +0300 - build 1172

1. Mantis#0001030: Несанкционированная смена атрибутов файла FARMENU.INI 

chupakabra 18.10.2009 20:45:00 +0200 - build 1171

1. Поправлен механизм проверки рекурсивных симлинков.

2. При удалении ScanTree не должен заходить в симлинки.

3. Незначительные изменения в ConvertNameToReal().

drkns 16.10.2009 06:24:11 +0200 - build 1170

1. Забытый отладочный код :)

drkns 16.10.2009 00:08:51 +0200 - build 1169

1. Поправка к 1167.

chupakabra 15.10.2009 23:47:00 +0200 - build 1168

1. Mantis#0001094: Проблема при удалении каталогов по сети.

drkns 15.10.2009 19:12:29 +0200 - build 1167

1. Mantis#0001113: Заполнение экрана символами '?'.

2. Продолжаем давить printf в проблемных местах.

drkns 15.10.2009 00:46:56 +0200 - build 1166

1. Из TechInfo #10 убраны читерские опции [Alt]EditorKey, [Alt]CmdLineKey, [Alt]DialogKey, [Alt]FastFindKey.

   Кнопкосочетания для XLat теперь настраиваются честными макросами, примерно так:
   -------------------------------------------------------------
   REGEDIT4

   [HKEY_CURRENT_USER\Software\Far2\KeyMacros\Common\CtrlShiftX]
   "Sequence"="$XLat"
   -------------------------------------------------------------
   AltR.reg, Apps.reg, CtrlR.reg, CtrlShiftX.reg в addons\XLat\Russian переведены на использование макроязыка.

drkns 14.10.2009 19:25:48 +0200 - build 1165

1. Warnings (level 4).

2. <Get|Free>VirtualFindData для A-плагинов.

drkns 13.10.2009 22:34:34 +0200 - build 1164

1. Warnings.

drkns 13.10.2009 22:26:59 +0200 - build 1163

1. Mantis#0000789: После открытия Viewer под текстом "проглядывается" текст от панелей
   Mantis#0000978: Какие-то неотображаемые символы "съедают" текст при просмотре в UTF-16

  Гадит 0xffff (WEOF), *printf нормально с ним не работает и работать не будет, посему для него написана "замена": классы FormatString и FormatScreen.
  Пока что "умеют" width, precision, align, работают со строками и целыми числами.
  Вьюверу/редактору этого должно хватить, в остальных местах - со временем.

2. Иногда не срабатывали команды типа "cd буква_диска:"

chupakabra 13.10.2009 03:00:00 +0200 - build 1162

1. Дополнение к build 1161.

chupakabra 13.10.2009 02:14:00 +0200 - build 1161

1. Скорректирована работа ConvertNameToReal() для дисков, не имеющих уникального идентификатора тома.

drkns 11.10.2009 21:50:10 +0200 - build 1160

1. PutFilesW теперь выглядит так:

   int WINAPI PutFilesW(
     HANDLE hPlugin,
     struct PluginPanelItem *PanelItem,
     int ItemsNumber,
     int Move,
     const wchar_t *SrcPath,
     int OpMode
   );

   где SrcPath - путь источника (откуда получим файлы).

   Плагины, использующие PutFilesW - сломались, как обычно :)
  
2. Mantis#0001090: Панель с прямыми слэшами становится "нерабочей".

svs 07.10.2009 17:30:36 +0300 - build 1159

1. Mantis#0001099: Узнать, есть ли элемент без горячей клавиши
     N=checkhotkey(S[,N1])

     возвращает:
     -1 - не в своей области
      0 - нет такого
     >0 - позицию элемента

     Параметр N1 - с какой позиции начать искать
     Если S пустая строка, то функция возвращает -1, 0 или номер позиции, у которой отсутствует хоткей

svs 06.10.2009 20:51:50 +0300 - build 1158

1. Macro: CheckHotkey() работает в области "Dialog".
   Если текущий элемент ListBox или открытый Combobox (или открытый History), то CheckHotkey() работает с этим элементов.

chupakabra 05.10.2009 20:49:00 +0200 - build 1157

1. Обновляем текущий каталог для плагинов с OPIF_REALNAMES.

svs 05.10.2009 17:12:13 +0300 - build 1156

1. Mantis#0000956: напротив некоторых плагинов в списке стит буква "А". В хелпе об этом ни слова. 
   from igor_yudincev.

2. Mantis#0001095: Состояние Title (заголовок текущего объекта) пуст при вызове из панелей 

3. Mantins#0001088: Пути в командной строке запуска Фара и слеш (\) 

chupakabra 05.10.2009 12:36:00 +0200 - build 1155

1. Исправлена проблема в ConvertNameToReal() при работе с динамическими дисками.

drkns 30.09.2009 20:43:48 +0200 - build 1154

1. Уточнение 1153.1 для случая корневого каталога пустого диска.

drkns 29.09.2009 18:07:44 +0200 - build 1153

1. apiSetCurrentDirectory всегда возвращал TRUE, даже если искомый каталог отсутствовал.
   Как следствие - можно было "заходить" в несуществующие папки.
   Сюда же Mantis#0001078: FCTL_SETPANELDIR ошибочно успешно отрабатывает для несуществующего пути.

2. Если в редакторе/просмотре отключен titlebar, то и часы на нём рисовать не надо.

3. Так как hex-просмотр текста в UTF8 сейчас не работает чуть менее, чем совсем - запретим эту комбинацию вообще, во избежание однообразных унылых багрепортов.

4. Косметика: в FindFirstFile передаём '*' вместо '*.*'. 

svs 29.09.2009 11:50:38 +0300 - build 1152

1. Mantis#0001064: Error in string handling 
   Очередное уточнение операций:
     1. string + string = string
     2. string + num = string
     3. num + string = string
     4. strnum + string = string
     5. string + strnum = string
     6. num + strnum = num
     7. strnum + num = num

   Т.е. (применяем принудительное преобразование к string):
     msgbox("1" + 0) ==> 1
     msgbox(1 + "2") ==> 3
     msgbox("foo1" + 0) ==> "foo10"
     msgbox(string(1) + "2") ==> "12"
     %i=1; msgbox("0" + string(%i)) ==> "01"
     %i=1; msgbox(int("012ag") + %i) ==> 13
     %i=1; msgbox(string(int("012ag")) + %i) ==> 13
     %i=1; msgbox(string(int("012ag")) + string(%i)) ==> "121"

zg 28.09.2009 20:33:47 +0200 - build 1151

1. Edit::WordDiv устанавливался в значение Editor::WordDiv::m_pData::m_pData.
   если плагин менял WordDiv редактору на большее по размеру значение, память
   переаллоцировалась и Edit::WordDiv указывал в пустоту.

2. при выключенных часах в редакторе и неуникодном тексте обрезалась скобка в строке статуса.

3. gcc warnings.

drkns 28.09.2009 20:02:46 +0200 - build 1150

1. From Tim Sobolev: Mantis#0001074: Impossible to create/edit/view file with name started with 2 or more '.'

svs 28.09.2009 20:59:21 +0300 - build 1149

1. Mantis#0001070: XLat: переключение раскладки клавиатуры при наличии в системе более 2 раскладок 
   Добавлен [HKEY_CURRENT_USER\Software\Far2\XLat]"Layouts" - строка, перечисляющая через ';' HKL раскладок, которые нужно "крутить"
   Например, "Layouts"="04090409;04190419" (или "Layouts"="0409;0419")
   Если указано меньше двух, то механизм "отключается" и раскладки крутятся как и раньше.
   Far для "Layouts" считывает первые 10 значений, остальные, если есть, игнорируются (думаю - за глаза хватит :-).

   Так же добавлен комментарий (чтобы не искать больше :-) про правила... 

2. Mantis#0001064: Error in string handling 
   Macro: Здесь, если "string1 операция string2", то результат как string (для '+' - объединение строк, для остальных "string1")
   
3. Macro: Для Editor.Set() добавлены 5 индексов (первый параметр):
      15: Show scrollbar
      16: Allow editing files opened for writing
      17: Select found (в поиске)
      18: Regular expressions (в поиске)
      19: Pick up the word (в поиске)

drkns 27.09.2009 22:50:36 +0200 - build 1148

1. Фар иногда мог схлопываться, если при старте окно консоли было максимизировано.

2. FSF.ConvertNameToReal больше нет. А есть FSF.ConvertPath(CONVERTPATHMODES Mode,const wchar_t *Src, wchar_t *Dest, int DestSize)
   При Mode=CPM_REAL работает как ConvertNameToReal;
   при Mode=CPM_FULL работает как ConvertNameToFull.

   Ахтунг: использовать GetFullPathNameW для преобразования относительного пути в абсолютный после 1145 билда нельзя, используйте ConvertPath(CPM_FULL, ...).

3. gettable.?pp -> codepage.?pp

garry 27.09.2009 22:54:30 +0300 - build 1147

1. Mantis#0001017  Сделано более общее решение, т.е. поддерживается или нет кодовая страница 
   проверяется как в редакторе так и во вьювере и не только при автодетекте, но и при загрузке 
   кодовой страницы из кэша;

2. Небольшой рефакотринг связанный с таблицами перекодировки: имена функций, а также замена 
   Table -> CodePage;

3. Теперь const UnicodeString& UnicodeString::SetData(const UnicodeString &strCopy) не роняет
   фар, если туда передать NULL;

4. TechInfo #80 (См. сборку #1019).

drkns 27.09.2009 08:56:45 +0200 - build 1146

1. Учитываем, что при использовании префикса \\?\ в путях windows отключает ИИ, заменяющий '/' на '\', посему менять надо самостоятельно.

2. При старте внутренняя strCurrentDirectory инициируется текущим каталогом процесса, дабы работали всякие /e и /p.

drkns 27.09.2009 01:05:56 +0200 - build 1145

1. From Tim Sobolev: собственная реализация ConvertNameToFull.
   Должны починиться все проблемы, связанные с использованием GetFullPathName: спец. имена (nul, con и т. п.), точки/пробелы в конце имён и т. п.

2. Свершилось то, о чём так долго говорили большевики - far не использует SetCurrentDirectory при навигации по папкам.
   Как следствие, бонусы:
     - хождение по папкам глубже MAX_PATH;
     - вход в папки, оканчивающиеся точками, пробелами, и прочими ужасами;
     - папка, открытая на панели, не блокируется от удаления извне;
     - и прочее.
   Соотвественно, могут проявиться и баги. Соблюдаем осторожность.

   Для оемных плагинов текущий каталог всё же выставляется перед вызовом их экспортируемых функций.
   Ибо совместимость.

   Для уникодных плагинов ничего не выставляется.
   Посему некоторые нерадивые плагины могут разнообразно глючить.
   Ещё не поздно исправиться и начать использовать FCTL_GETCURRENTDIRECTORY.
   
svs 26.09.2009 19:07:24 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal 
    from: max rusov 
      PluginW.pas: Добавил поддержку RegExp'ов

zg 26.09.2009 17:05:26 +0200 - build 1144

1. продолжение Mantis#0000921: Проблемы с ECTL_SAVEFILE.

2. при save as из редактора заголовок редактора и консоли не 
   сразу обновлялись новым именем файла.

zg 26.09.2009 14:24:24 +0200 - build 1143

1. уточнение 1136 для несуществующих кодировок.

zg 25.09.2009 22:59:27 +0200 - build 1142

1. Mantis#0000921: Проблемы с ECTL_SAVEFILE.

svs 25.09.2009 18:00:55 +0300 - build 1141

1. Mantis#0001068: В диалоге замены два хоткея "R"

2. Mantis#0001063: Добавление в help-файл списка всех макрокомбинаций 

3. Mantis#0001066: [x] Pick up the word in editor

4. Добавка в Help`ы по RegExp`ам

zg 25.09.2009 16:25:35 +0200 - build 1140

1. при замене с регэкспами если указанной скобки нет, то она меняется на пустую строку.

zg 24.09.2009 23:52:29 +0200 - build 1139

1. f6 в редакторе просмотре сохраняет текущую кодовую страницу.

zg 24.09.2009 23:40:59 +0200 - build 1138

1. плагины в Viewer/Editor могут теперь передавать конкретные кодовые страницы.

zg 24.09.2009 22:19:38 +0200 - build 1137

1. при замене с регэкспами можно в строке замены ссылаться на скобки в строке поиска: $0-$9,$A-$Z.
   любая другая последовательность $* заменяется на *.

2. при замене в диалоге подтверждения показывается реально найденная строка, а не регэксп.

zg 24.09.2009 21:02:09 +0200 - build 1136

1. простейшая имплементация ESPT_CODEPAGE.

zg 24.09.2009 19:03:28 +0200 - build 1135

1. RegExp API

   RegExpControl(HANDLE hHandle, int Command, LONG_PTR Param)

   Command:

   RECTL_CREATE           - hHandle - 0.
                            Param - HANDLE*, в который запишется HANDLE регэкспа.
                            При неудаче вернёт FALSE и Param=INVALID_HANDLE_VALUE.
   RECTL_FREE             - hHandle - HANDLE, который вернул RECTL_CREATE.
   RECTL_COMPILE          - hHandle - HANDLE, который вернул RECTL_CREATE.
                            Param - указатель на строку с регулярным выражением.
   RECTL_OPTIMIZE         - hHandle - HANDLE, который вернул RECTL_CREATE.
   RECTL_MATCHEX          - hHandle - HANDLE, который вернул RECTL_CREATE.
                            Param - указатель на RegExpSearch.
                            RegExpSearch:
                            Text - строка.
                            Position - позиция в строке.
                            Length - длина строки.
                            Match - скобки.
                            Count - количество скобок.
                            Reserved - обязательно должен быть нулём.
   RECTL_SEARCHEX         - hHandle - HANDLE, который вернул RECTL_CREATE.
                            Param - указатель на RegExpSearch.
   RECTL_BRACKETSCOUNT    - hHandle - HANDLE, который вернул RECTL_CREATE.

svs 22.09.2009 21:07:01 +0300 - build 1134

1. Macro: по мотивам Mantis#1064
   msgbox("01") выводит в заголовке "1" вместо "01"
   Остальное согласно спецификации (см. build 1127#6)

drkns 20.09.2009 23:50:53 +0200 - build 1133

1. Если при копировании/переносе нескольких файлов в имени приемника отсутствует заключительный слеш, и сам приемник
   при этом отсутствует - выдаётся уточняющий запрос: под "приемником" подразумевается папка или файл?

zg 19.09.2009 01:53:37 +0200 - build 1132

1. макросы, запущенные плагином из ProcessSynchroEvent, не всегда исполнялись.

chupakabra 17.09.2009 13:24:00 +0200 - build 1131

1. Дополнение к исправлению UserMenu из build 1130.

svs 17.09.2009 12:40:39 +0300 - build 1130

1. from Alexey Samlyukov:
   В UserMenu некорректно отрисовывается длинное название субменю (если не вмещается в размеры экрана)

chupakabra 14.09.2009 19:03:00 +0200 - build 1129

1. Макро SELF_TEST(code), предназначенное для автоматического тестирования кода. code выполняется при запуске отладочной версии.
   В модуль pathmix добавлена процедура тестирования некоторых функций.

zg 15.09.2009 20:52:39 +0200 - build 1128

1. gcc сборка.

2. gcc варнинги.

svs 15.09.2009 20:37:40 +0300 - build 1127

(много форматирования - пробелы на табы)

1. Макросы грузяться после плагинов (необходимо для последующих реализация в макродвижке)

2. keys.hpp: KEY_MACRO_U_BASE - резервирование места под Mantis#18 и Mantis#466

3. EnumRegValueEx() - добавлен агрумент: тип енуменированного значения

4. Macro: Menu.Value - содержит текст текущего пункта меню, как он виден на экране (без &)

5. Macro: добавлен тип double
   Было __int64 и wchar_t*, добавился double. Собственно и говорить то нечего, кроме:
    * разделитель целой и дробной частей - точка;
    * функций sin, cos, tan, etc. нет - это скорее дело для Mantis#0000466 и Mantis#0000018;
    * в памяти такое число занимает 8 байт;
    * константы в реестре (ветка "KeyMacro\Const") в виде REG_SZ (в соответствии с п.2 Far сам преобразует их в double  в момент старта) это криво (может имеет смысл хранить в REG_BINARY?);
    * преобразование double в строку осуществляется по формату "KeyMacro/CONVFMT:REG_SZ" (по умолчанию "%.6g")

6. Macro: уточнение "операций".
    Для начала определения:
        * Int - целое число;
        * Dbl - вещественное число;
        * StrInt - строка, которая полностью преобразуется в Int;
        * StrDbl - строка, которая полностью преобразуется в Dbl;
        * Str - строка, которая не может быть полностью преобразована в Int или Dbl (собственно, просто набор символов).
    В соответствии с этими определениями, там, где это возможно, происходит преобразование строки в число и выполнение операции. Дальше приведены таблицы, показывающие результаты работы операций:

              +     |B.Int    B.Dbl  B.StrInt  B.StrDbl   B.Str
          ----------+------+--------+---------+----------+------
          A.Int     |Int      Dbl    Int       Dbl        Str
          A.Dbl     |Dbl      Dbl    Dbl       Dbl        Str
          A.StrInt  |Int      Dbl    Int       Dbl        Str
          A.StrDbl  |Dbl      Dbl    Dbl       Dbl        Str
          A.Str     |Str      Str    Str       Str        Str
         Здесь Str обозначает конкатенацию двух операндов.

           - * / %  |B.Int    B.Dbl  B.StrInt  B.StrDbl   B.Str
          ----------+------+--------+---------+----------+------
          A.Int     |Int      Dbl    Int       Dbl        A.Str
          A.Dbl     |Dbl      Dbl    Dbl       Dbl        A.Str
          A.StrInt  |Int      Dbl    Int       Dbl        A.Str
          A.StrDbl  |Dbl      Dbl    Dbl       Dbl        A.Str
          A.Str     |A.Str    A.Str  A.Str     A.Str      A.Str
         Здесь A.Str - возвращается значение операнда A.

         Для бинарных операций операнды Dbl или StrDbl предварительно преобразуется к Int.
         
           Op       |B.Int    B.Dbl  B.StrInt  B.StrDbl   B.Str
          ----------+------+--------+---------+----------+------
          A.Int     |Int      Int    Int       Int        A.Str
          A.Dbl     |Int      Int    Int       Int        A.Str
          A.StrInt  |Int      Int    Int       Int        A.Str
          A.StrDbl  |Int      Int    Int       Int        A.Str
          A.Str     |A.Str    A.Str  A.Str     A.Str      A.Str
         Здесь "Op"  | & ^ << >>

         В операциях сравнения (==, !=, <, <=, >, >=) операнды преобразуются (там, где это возможно) и сравниваются.
         В логических OR и AND операнды сравниваются как есть, строки не преобразуются в StrInt и StrDbl, а проверяются на не пустую строку.

7. Macro: Editor.SelValue - содержимое аналогично тому, как Far помещает блок в clipboard (блок текста с наличием crlf в конце строк)

8. Macro: функции "Menu.Select" имеет вид "N=Menu.Select(S[,N[,Dir]])" - добавлен третий параметр, направление поиска, Dir:

    * 0 - от начала в конец списка;
    * 1 - от текущей позиции в начало;
    * 2 - от текущей позиции в конец списка пунктов меню.

9. в хелпе работают макроконструктивы <!Macro:Vars!> и <!Macro:Consts!>, в lng-файлах  ищем "// for <!Macro:Vars" - задают форматы вывода

10. Если Far стартован с ключами /e или /v, то не грузятся макросы из следующих макрообластей: Shell, Search, Disks, MainMenu, InfoPanel, QviewPanel, TreePanel, FindFolder

11. Mantis#0001057: Far Manager версия 1.75 build 2605, x86 При выборе Alt+F1/Alt+F2 -> Process List Вылетает 
    Если в реестре у плагина в значении StartPanelMode пурга, принудительно выставляем нулевой режим панели
    (решение пока влоб, а там, после ухода от статического массива, видно будет)

zg 15.09.2009 18:23:10 +0200 - build 1126

1. Mantis#0001058: Диапазон для класса знаков не работает для русских букв
   RegExp::Optimize урезал уникод до первых 256 символов.

drkns 14.09.2009 19:19:36 +0200 - build 1125

1. Установка атрибутов в некоторых случаях могла приводить к падению. 

chupakabra 14.09.2009 19:03:00 +0200 - build 1124

1. Mantis#0001055 & Mantis#0001056: Проблемы при переходе в корневую папку (Ctrl+\).

drkns 13.09.2009 23:57:35 +0200 - build 1123

1. Применяем #pragma once вместо include guard. Должно положительно отразиться на времени компиляции.

drkns 13.09.2009 20:12:26 +0200 - build 1122

1. С форума: падало, если при открытом infopanel/qview переключиться в файловую панель через меню.

t-rex 13.09.2009 14:49:26 +0200 - build 1121

1. С какого то перепугу кто то отрубил regexp в replace.

2. Не забывайте, include они case sensitive в некоторых операционках.

drkns 13.09.2009 11:24:41 +0200 - build 1120

1. Mantis#0001054: Неправильно отображается свободное место на диске.

chupakabra 12.09.2009 22:53:00 +0200 - build 1119

1. Изменение в API: farConvertNameToReal() всегда возвращает необходимый размер буфера (по аналогии с farGetPathRoot())

drkns 12.09.2009 19:04:40 +0200 - build 1118

1. Очередной divide & conquer:
   - АХТУНГ! - минимальный поддерживаемый sdk теперь 7.0 для vc, w32api-3.13 для gcc;
   - sdkpatches.hpp разделён на отдельные части для vc и gcc;
   - выкинуты макросы i64() и ui64(), ибо vc тоже умеет ll и ull;
   - __try и __except заменяются макросами только в gcc;
   - выкинуто ещё некоторое количество мусора из headers.hpp и pluginold.hpp

2. Немного облегчён класс диалога.

3. macro: itoa() не работал с 64-битными числами.

chupakabra 11.09.2009 01:51:00 +0200 - build 1117

1. Поправлена сборка gcc.

2. makefile_gcc: не оптимизируем отладочную версию; поправлены зависимости (make -j работал некорректно)

chupakabra 11.09.2009 01:02:00 +0200 - build 1116

1. В панели плагина некорректно работал поиск начиная с корня.

2. Добавил TRY EXCEPT в FindFiles::WriteDialogData().

3. Немного переделал код FindFile с целью его упрощения.

drkns 10.09.2009 23:12:56 +0200 - build 1115

1. К scantree прикручена защита от рекурсивных симлинков.

2. В win2k не работало создание хардлинков.

3. Mantis#0001049: Ошибка при поиске файлов по %PATH%.

chupakabra 09.09.2009 16:47:00 +0200 - build 1114

1. GetPathRoot() реализована через ConvertNameToReal().

chupakabra 09.09.2009 06:30:00 +0200 - build 1113

1. Mantis#0001039: Не запоминалось состояние опции "Del removes blocks in edit controls".

chupakabra 09.09.2009 05:40:00 +0200 - build 1112

1. Поправлена сборка gcc и x64.

chupakabra 09.09.2009 05:01:00 +0200 - build 1111

1. ConvertNameToReal() теперь использует NtQueryObject() на Windows XP.
   Старый код с хождением по симлинкам удален полностью.

drkns 08.09.2009 22:18:01 +0200 - build 1110

1. Не работало создание по F7 папки с точкой в конце.

chupakabra 08.09.2009 21:54:00 +0200 - build 1109

1. Для ConvertNameToRealModern() учитываем что входной путь может существовать лишь частично.

2. UnicodeString::Replace(): допускаем, что Data может указывать на данные в самой строке.

3. pathmix: несколько новых функций	для работы с путями.

chupakabra 07.09.2009 18:25:00 +0200 - build 1108

1. Mantis#0001037: зависание внутри ConvertNameToReal().
   Теперь по возможности используется функция GetFinalPathNameByHandle() вместо шаманства с симлинками.

2. Полезные методы для UnicodeString: Replace, Insert, Remove, etc.

t-rex 06.09.2009 22:57:09 +0200 - build 1107

1. Mantis#1038: Неправильное отображение вложенных подкаталогов в дереве.

chupakabra 05.09.2009 04:49:00 +0200 - build 1106

1. VMenu: место под правый горизонтальный скроллер выделяется только если он действительно требуется.
   Это исправляет проблему с плагинами, которые считают ширину листбокса как ("макс. длина строки" + 4).

zg 04.09.2009 16:44:34 +0200 - build 1105

1. после 1103 поиск требовал в два раза больше процессорных ресурсов.

t-rex 04.09.2009 00:16:00 +0200 - build 1104

От греха подальше:

1. При поиске в редакторе с [x] Select found - выставляем курсор на первой букве найденного текста,
   как и в поиске без этой опции и вообще как у нормальных людей.
   В связи с этим сразу отпадает проблема работы regexp поиска с этой опцией, и выкидывается лишний кусок кода
   с гнусным AI который мог к ещё разным проблемам приводить.

drkns 03.09.2009 20:01:23 +0200 - build 1103

1. При поиске по содержимому в статусной строке отображаются проценты для текущего файла.
   Ну и перерисовка там теперь с тем же интервалом, что и везде.

svs 03.09.2009 18:07:57 +0300 - build 1102

1. Корректировка Mantis#0000547
      "...Открываем по F4 файл FarRus.hlf
      F7 ищем цифру 3 и за ней еще какую-нибудь
      3\d
      и ставим галочку [x] Регулярные выражения.
      находим, нажимаем Shift+F7 - все работает, ищет дальше.

      Если еще ставим галочку [x] Выделять найденное
      то первый раз находит, а Shift+F7 не работает..."

   До поры (до разборок) закомментим проблемный кусок/
   Помечен "CHECK!!!: for..."

chupakabra 03.09.2009 15:36:00 +0200 - build 1101

1. Mantis#0001002: крах при работе с VMenu в случае если все элементы скрыты

2. Добавил синхронизацию в VMenu::GetMaxLineWidth()

t-rex 31.08.2009 22:29:55 +0200 - build 1100

1. Продолжим Mantis#1025, было ещё одно внутренее ограничение на длину записи в descript.ion.

drkns 31.08.2009 19:37:49 +0200 - build 1099

1. Mantis#0001029: Переустановка атрибутов без надобности
   Самое смешное - логика "если соответствующие аттрибуты/дата/время не менялись, то и не трогать"
   как бы присутствовала, но была нещадно поломана всякими IsFileWritable.

2. Там же устранено одно досадное недоразумение - дата/время у симлинков/связей теперь выставляются.

3. В поле времени доступно управление миллисекундами.

4. FILE_FLAG_BACKUP_SEMANTICS переехал внутрь apiCreateFile.

t-rex 29.08.2009 23:11:42 +0200 - build 1098

1. Доделка пред. билда.

drkns 29.08.2009 21:53:31 +0200 - build 1097

1. Mantis#0001026: Не работает кнопка «Искать» в диалоге поиска
   
   Господа, убедительная просьба - если приходится ковырять какой-то древний диалог,
   не ленитесь попутно заменять в нём числовые константы именованными, потом самим же легче будет.

drkns 29.08.2009 00:51:58 +0200 - build 1096

1. Задавим несколько memset'ов.

2. Уточнения хелпа.

chupakabra 28.08.2009 18:28:00 +0200 - build 1095

1. FCTL_REDRAWPANEL могла вернуть FALSE в случае успеха

svs 28.08.2009 19:14:22 +0300 - build 

1. Перевод хелпа от Igor Yudincev

svs 28.08.2009 19:01:31 +0300 - build 1094

1. Mantis#0001021: Сохранение состояния 'Select found' 
   кроме этого так же сохраняется состояние "RegExp"

2. Mantis#0000872: RegExp support in Editor and Viewer
   from Igor Yudincev
   Здесь в диалоге замены опция про RegExp пока недоступна (задел на будущее)
   Добавлен коммент в Edit::Search():

    // Q: что важнее: опция диалога или опция RegExp`а?

3. Опция RegExp во вьювере - тоже самое, пока в режиме RO (задел на будущее)

4. Help: "@RegExp. Начало" - раздел есть, нужно аккуратно его корректировать, по мере развития событий.
   Так же, ка ки в редакторе, сохраняется состояние "RegExp".

   ВНИМАНИЕ! Все, что описано в разделе "@RegExp" на данном этапе не пашет (но будет!)

zg 28.08.2009 16:10:30 +0200 - build 1093

1. Mantis#0001025: FAR v2.0.1091 ( и v2.0.981) обрезает записи в descript.ion при F5 или F6 до 260 символов.

2. gcc warnings.

t-rex 27.08.2009 20:09:59 +0200

1. Hungarian lng update from Far Hunor.

drkns 27.08.2009 19:54:05 +0200 - build 1092

1. Символические ссылки теперь можно создавать и в 2000/XP/2003.
   Разумеется, из этого не следует, что они будут там работать.

2. Ещё одна добавка к #0001012.

3. В диалоге подтверждения перезаписи R/O файла кнопка подписывается в зависимости от операции (overwrite/append).

drkns 26.08.2009 20:02:15 +0200 - build 1091

1. Mantis#0001019: Устанавливается атрибут "Encrypted" при копировании (перемещении) папок.

2. Mantis#0001012: "Иногда при копировании в 1090 возникает ощущение, что имя нового копируемого файла появляется когда ещё прогресс старого файла стоит на 100%."

drkns 25.08.2009 20:32:14 +0200 - build 1090

1. Вся визуализация процесса копирования вынесена в (почти) отдельный класс.
   Должны починиться баги с неперерисовкой прогресбара и отображением не того имени (Mantis#0001012).
   Также выкинута куча разнообразного мусора из копира.

2. Т. к. GetUserNameExW есть везде - подсократим код, линкуя её статически.

3. Панель быстрого просмотра перечитывалась и перерисовывалась на каждый чих.

4. Для файловых симлинков в панелях показываем "<symlink>" в колонке размера.

5. MkSymLink() переехала в flink.cpp.

svs 25.08.2009 17:20:04 +0300 - build 1089

1. Mantis#0000970: Дата изменения descript.ion не должна обновляться, если изменений не было
   from Maximus

svs 24.08.2009 19:15:12 +0300 - build 1088

1. В Info-панели после типа FS не стоял пробел.

2. Метка "Память" наезжает на рамку панели.

3. Mantis#0000859: RFE: Show UserName@Domain on the information panel
   Заюзаем 8-й тип - "UserName@Domain" (для локального юзера или были ошибки при получении юзера... будет как сейчас: "юзер")
   + немного форматирования в InfoList::DisplayObject()

   По большому счету форму показа нужно задавать (диалог? techinfo?).

drkns 22.08.2009 00:44:39 +0200 - build 1087

1. Перетрях диалога атрибутов. Сокращения, оптимизации, форматирование, как обычно.
   Плюшки:
   - исправлено несколько мелких багов;
   - добавлена возможность редактировать содержимое reparse point'а. Сильно экспериментально.

2. Уточнения создания reparse point'ов.

3. Из врапера убраны FAR_USE_INTERNALS.

4. Таймауты перерисовки всяческих прогрессбаров теперь контролируюся одной переменной.

5. Перевод для "Standard association".

svs 19.08.2009 11:42:58 +0300 - build 1086

1. Mantis#0000905: Изменения в eval
   Вариант eval("",1) вернет ошибку 12 ("Zero-length macro")
   Считаем, что пустые макропоследовательности недопустимы.

svs 17.08.2009 12:26:34 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal 
    from: max rusov 
      PluginW.pas: убраны FAR_USE_INTERNALS

drkns 16.08.2009 09:05:05 +0200 - build 1085

1. gcc.

drkns 15.08.2009 20:13:55 +0200 - build 1084

1. Уточнения предыдущего билда.
   pointer_array заменен на TPointerArray.

drkns 14.08.2009 23:38:43 +0200 - build 1083

1. Более-менее доделан выбор плагина для SetFindList и prefix.
   Локализация диалога настройки.
   По умолчанию все меню выбора плагина выключены.

svs 14.08.2009 11:51:50 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal 
    from: max rusov 
      PluginW.pas: Добавил поддержку x64. Тестировалось под FreePascal 2.3.1

t-rex 12.08.2009 12:01:41 +0200 - build 1082

1. From Evgeny Zhirnov: Mantis#1006: Добавить explicit к конструктору UnicodeString::UnicodeString(size_t, size_t=0)

svs 11.08.2009 18:55:01 +0300 - build 1081

1. Не работают Ctrl-Home/End на цифровой клавиатуре
   from: Alexey Samlyukov

drkns 09.08.2009 17:21:34 +0200 - build 1080

1. Если на панели был выделен один объект и курсор стоял на "..", то в PanleInfo.SelectedItemsNumber оказывался 0.

chupakabra 09.08.2009 16:10:00 +0200 - build 1079

1. Продолжение 1075: исправление горизонтальной прокрутки для VMenu

chupakabra 09.08.2009 05:13:00 +0200 - build 1078

1. VMenu: автоматическая расстановка шоткатов учитывает горизонтальный скроллинг.

drkns 08.08.2009 20:20:06 +0200 - build 1077

1. Оптимизация сброса в консоль экранного буфера. В некоторых случаях должно стать в разы быстрее.

2. Уточнение в рисовалке меню.

zg 08.08.2009 17:40:18 +0200 - build 1076

1. уточнение 1064 для папок при [ ] Sort folder names by extension.

chupakabra 07.08.2009 21:15:00 +0200 - build 1075

1. Mantis#0000998: По Alt-Right у каждой буквы диска рисуется символ «
   Исправлена горизонтальная прокрутка для VMenu

drkns 06.08.2009 19:14:43 +0200 - build 1074

1. Продолжение 1073: лишние преобразования путей при создании ссылок.
   Там же - убрана мешанина из табов/пробелов и прочая косметика.

drkns 06.08.2009 01:07:51 +0200 - build 1073

1. ConvertNameToReal криво работал с симлинками, указывающими на \\?\UNC\... или \\?\Volume{...

svs 05.08.2009 23:03:44 +0300 - build 1072

1. В ConvertFileSizeString() попутаны префиксы exa и peta
   (see http://en.wikipedia.org/wiki/SI_prefix)

t-rex 05.08.2009 14:56:05 +0200 - build 1071

1. From Evgeny Zhirnov: Mantis#995: Исправление операторов копирования

2. Немного форматирования.

drkns 04.08.2009 21:03:08 +0200 - build 1070

1. Перетрях ассоциаций - упрощения, оптимизации, форматирование и т.п. Как обычно - соблюдаем осторожность.
   Плюшки:
   - каждую ассоциацию теперь можно "включать" и "выключать", не стирая (и, соответственно, не теряя) текст команды.
   - снято ограничение в 32 ассоциации на одно расширение;
   - пункты меню ассоциаций можно двигать вверх-вниз по Ctrl<Up|Down>;

2. При включенном врапе во вьювере блокируется прокрутка вправо.

3. В Modal::ReadInput зачем-то было вот такое чудо:
    if (CloseFARMenu){
      SetExitCode(TRUE);
    Это приводило к тому, что если при открытом меню закрыть фар по [x], то меню закрывалось с ExitCode==1,
    т.е. всегда происходил "запуск" второго по счёту пункта меню. О возможных последствиях такого поведения догадайтесь сами.
    Теперь ExitCode ставится как положено: -1. Если вдруг это шаманство кому-то было нужно - сигнализируйте.

4. С форума: "Падает Far 2.0 build 952 из-за MultiArc..."
   Только не из-за MultiArc, а из-за попыток дописать NULL к UnicodeString. Опять, да.

t-rex 04.08.2009 19:55:56 +0200 - build 1069

1. Mantis#992: /[^ab]/ 
   короче "not set" вообще особо не работал.

svs 04.08.2009 16:42:10 +0300 - build 1068

1. Help для "поиска/замены" в редакторе. Начало.
   * в FarEng.hlf.m4 - русские буковки
   * в FarHun.hlf.m4 - только пустой раздел

   по мере внедрения RegExp хелпы будут обновляться.

svs 04.08.2009 11:27:36 +0300 - build 1067

1. В GetSearchReplaceString() добавлен параметр HelpTopic - пора писать тему помощи для поиска/замены в редакторе (с учетом build 1063)

2. В Panel::ChangeDiskMenu() избавимся от очередного str.Format()
   (From Alexey Samlyukov)

zg 03.08.2009 22:13:13 +0200 - build 1066

1. опечатка в 1064.

chupakabra 03.08.2009 02:32:00 +0200 - build 1065

1. Mantis#0000975
   Диалог с результатами поиска расширен на весь экран.
   Если имя файла слишком длинное - режем в середине, а не в конце.
   Изменение размера по Alt+F9 пока работает не совсем корректно (надо содержимое списка пересчитывать).

2. Для UnicodeString добавлены Append(const wchar_t *, size_t) и Append(wchar_t).

3. В strmix добавлена TruncStrFromCenter - как TruncStr и TruncStrFromEnd, но режет в центре строки.

zg 02.08.2009 15:11:16 +0200 - build 1064

1. новый конструктор UnicodeString(const wchar_t *lpwszData, size_t nLength).

2. Mantis#0000974: file-1.txt выше, чем file.txt

3. PointToName(string)/PointToExt(string) работают быстрее.

4. gcc warnings.

t-rex 31.07.2009 18:11:28 +0200 - build 1063

1. На затравку: ужасная имплементация regexp поиска в редакторе.
   Работает только для поиска вперёд, глючит при "select found", если строка начинается на "/" значит regexp.

2. Совсем немного форматирования, избавление от мешанины табов и пробелов.

svs 31.07.2009 13:49:18 +0300 - build 1062

1. Mantis#0000961: Неполная проверка на наличие файловых ассоциаций в реестре.
   from Ariman.
   Очередное уточнение (отвалились .lnk).

drkns 30.07.2009 21:46:46 +0200 - build 1061

1. Новое кнопкосочетание в панелях - CtrlShiftPgDn.
   Делает ровно то же самое, что и CtrlPgDn, но не перекрывается ассоциациями файлов (по аналогии с F4/CtrlShiftF4).

2. Немного тегов ^<wrap> и форматирования в справке.

drkns 30.07.2009 21:20:07 +0200

1. "Парашютики не забываем..." :)
   "*W.pas" вместо "*.pas" должны присутствовать и в мейкфайлах тоже.

svs 30.07.2009 22:11:37 +0300 - build 

1. Mantis#0000986: Far 2 API - pascal 
   "Ведущий рубрики" Maxim Rusov
   Вместо "*.pas" в двойке будут присутствовать "*W.pas":

   mr> Мне кажется *W - удобнее. В Delphi нельзя использовать ifdef'ы в настройках путей, поэтому приходится подключать модули условно:
   mr> 
   mr>   uses
   mr>     ...
   mr>    {$ifdef Unicode}
   mr>     PluginW,
   mr>    {$else}
   mr>     Plugin,
   mr>    {$endif Unicode}
   mr> 
   mr> Для этого - они должны называться по разному. 

   Файлы FarColorW.pas, FarKeysW.pas и PluginW.pas, относящиеся к АПИ (для Pascal), будут постоянно обновляться "по мере развития событий"

   Если у кого есть что сказать по этому поводу - Wелкам сюда: http://bugs.farmanager.com/view.php?id=986

chupakabra 30.07.2009 17:43:00 +0200 - build 1060

1. Mantis#0000979: ошибка копирования каталога при указании маски в качестве цели
   теперь маска обрабатывается только в CopyFileTree, в ShellCopyOneFile поступает уже готовый путь

chupakabra 29.07.2009 20:27:00 +0200

1. Не используем опции для оптимизации при сборке отладочной версии.

svs 29.07.2009 20:48:11 +0300 - build 

1. без билда
   исправления в scripts\mkdep.awk - "исключаем обработку самого себя"

2. актуализирован mkdep.list (однако чудовищно много зависимостей :-))
   файл mkdep.list содержит все сорцы и с помощью "scripts\mkdep.awk"  генерит far.vc.dep/far.gcc.dep
   far.*.dep нужны для слишком "безумного" nmake

chupakabra 29.07.2009 19:15:00 +0200 - build 1059

1. Mantis#0000982: Подсчет размера папки сильно тормозит на медленных файловых системах
   from CrOm
   ускорена работа функции FarGetPluginDirList

chupakabra 29.07.2009 17:03:00 +0200 - build 1058

1. Mantis#0000985: используем класс NonCopyable для запрета оператора присваивания и конструктора копирования
   from Evgeny Zhirnov

svs 28.07.2009 11:27:23 +0300 - build 1057

1. Mantis#0000981: Far падает, после вызова плагина через CallPlugin
   ...в процессе работы внутренних функций макросы отключаются...

yjh 28.07.2009 06:27:45 +0300 - build 1056

1. В хуке редиректора для win64 добавили поддержку Win2008r2 - там ntdll
   с "полуотладочным" враппером в релизе оставили :(

drkns 26.07.2009 22:12:09 +0200

1. В Vista и выше DEP теперь включён перманентно.

svs 26.07.2009 19:34:54 +0300 - build 1055

1. Mantis#0000405: по Ctrl-Enter выводить Win-диалог свойств диска. 
   from igor_yudincev
   добавлена информация про Ctrl-A и F4 в файлы помощи.

2. Mantis#0000980: FAR2 падает в FileList::PluginGetPanelInfo
   from Maximus.

svs 24.07.2009 17:34:55 +0300 - build 1054

1. Уточнения про CheckShortcutFolder()
   Из-за чего, кстати, неправильно выводилось сообщение про "файл": при переходе по ссылке на не существующую папку получаем - "Файл не найден".

2. Mantis#0000405: по Ctrl-Enter выводить Win-диалог свойств диска. 
   Это временно, до переделки меню в стиле "диалог+листбокс"
   Здесь вместо Ctrl-Enter стандартное поведение - Ctrl-A/F4

3. В Viewer::Search() кто-то не так выставил скобки...

drkns 22.07.2009 20:21:23 +0200 - build 1053

1. В windows 7 погнули WriteConsoleOutputW: ограничение на размер буфера у них теперь не 64 K, а "почти 64 K".
   Из-за этого самого "почти" в консоли выводился мусор вместо текста и периодически падал conhost.
   Посему теперь пишем по 32 K, от греха подальше.
   
2. В windows 7 погнули ReadConsoleInputW, а конкретно заполнение Event.KeyEvent.uChar.UnicodeChar.
   Из-за этого не работал ввод кодов уникодных символов по Alt-NumN.

svs 20.07.2009 18:27:06 +0300 - build 1052

1. Mantis#0000961: Неполная проверка на наличие файловых ассоциаций в реестре.
   from Ariman.
   Порядок проверки ассоциаций:

     1. [HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ext] ProgID
     2. [HKСR\.ext] дефолтное значение
     3. [HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ext\OpenWithProgids] до первого попадания
     4. [HKCR\.ext] OpenWithProgids до первого попадания

drkns 20.07.2009 00:36:26 +0200 - build 1051

1. Продолжаем трясти UserMenu:
   - выкинуто ещё прилично копипасты;
   - сокращено количество обращений к реестру (раза в два).
   Плюшки:
   - работает прокрутка длинных пунктов Alt-стрелками.

2. Новый флаг в FarMenuItemEx: MIF_SUBMENU.
   Пока что отвечает только за отображение ">" справа от имени пункта.
   Пока что только для внутреннего использования.

3. Экранный граббер зачем-то превращал «» в <>.

drkns 18.07.2009 20:39:05 +0200 - build 1050

1. EditorInfo::Options могло содержать неправильные данные.

drkns 17.07.2009 23:45:27 +0200 - build 1049

1. Рефакторинг UserMenu:
   - теперь оно есть класс (привет редактору и вьюверу);
   - выкинута куча копипасты. Будьте бдительны, что-нибудь вполне могло отвалиться;
   - проверка корректности горячей клавиши и названия пункта перенесена в обработчик диалога;
   Плюшки:
   - в качестве горячих клавиш могут использоваться все функциональные, вплоть до F24;
   - Разделителем теперь считается любой пункт с горячей клавишей "-". Если метка не пуста, она будет использована в качестве текста разделителя.
   - пункты меню можно двигать вверх-вниз по Ctrl<Up|Down>.

2. Частично восстановлен PROJECT_DI_MEMOEDIT.

3. Класс CachedWrite вынесен в отдельный файл.

warp 17.07.2009 19:58:00 +0300 - build 1048

1. Добавил (вернул) поддержку в (HANDLE)-2 в OpenFilePlugin. Может PictureView и заработает. 
   Но это ненадолго.

svs 17.07.2009 18:03:52 +0300 - build 1047

1. Mantis#0000905: Изменения в eval 

2. Mantis#0000973: Опечатка в исходнике - файл scrobj.hpp
   :-)

drkns 15.07.2009 18:30:59 +0200 - build 1046

1. В диалог "Подтверждения" добавлена опция "Перезапись и удаление R/O файлов".
   И, соответственно, FCS_OVERWRITEDELETEROFILES в В ACTL_GETCONFIRMATIONS.

2. По Alt+Del не удалялись вложенные папки.

warp 15.07.2009 02:27:00 +0300 - build 1045

1. HIGHLY EXPERIMENTAL PART 2. Добавим возможность до некоторой степени настраивать
   появление меню при наличии нескольких плагинов на обработку файла. Диалог пока не 
   локализован. 

drkns 14.07.2009 21:14:13 +0200 - build 1044

1. Если не удалось загрузить плагин - покажем результат GetLastError().

drkns 14.07.2009 19:48:31 +0200 - build 1043

1. Ещё всякие мелочи в списке кодовых страниц:
   - отметки возле страниц, выбранных в поиске, выводились также при открытии и сохранении файла;
   - при сохранении не блокировался автодетект и иногда сбивалось позиционирование;
   - Константа CP_REVERSEBOM почему-то была равна 65534, а не 1201.

warp 14.07.2009 01:44:00 +0300 - build 1042

1. Добавлены константы для пунктов основного меню. Это облегчит добавление пунктов в него.
   Кроме того устранена некоторая копипаста. Соблюдаем осторожность, вдруг чего упустил.

drkns 13.07.2009 20:06:54 +0200 - build 1041

1. From Maximus5: не работал ShiftDel на непустой папке на временной панели.

drkns 13.07.2009 00:48:31 +0200 - build 1040

1. В 1035 поломался врапперный GetDirList.

drkns 12.07.2009 21:28:54 +0200 - build 1039

1. Здравствуй, прекрасное далёко. Tеперь мы понимаем петабайты и эксабайты.

2. По традиции, немного косметики: давим "void" везде, где он не нужен.

zg 12.07.2009 11:29:40 +0200 - build 1038

1. в StrCmp* добавлен флаг SORT_STRINGSORT. причина - разница результатов:
   printf("%d\n",CompareString(0,NORM_IGNORECASE,"\"aaa aaa\"",9,"\"aaa aaa-2\"",9));
   printf("%d\n",CompareString(0,NORM_IGNORECASE,"\"aaa aaa\"",-1,"\"aaa aaa-2\"",-1));
   в фаре очень желательно, чтобы совпадали.
   починился Mantis#0000804: не отображается существующий description для одной из папок.

2. InsertQuote теперь пустую строку превращает в две кавычки, а не в одну.

drkns 12.07.2009 01:21:59 +0200 - build 1037

1. В D<N|M>_KEY, ECTL_PROCESSKEY, FarKeyToName, FarNameToKey, меню и ACTL_POSTKEYSEQUENCE не производилось unicode<->oem преобразование кодов клавиш для старых плагинов.

drkns 11.07.2009 22:44:36 +0200 - build 1036

1. Если при сохранении файла по ShiftF2 был выбран нестандартный конец строки, то он потом использовался при сохранении любого файла по F2.

2. При нажатии CtrlIns на элементе ".." кладём в буфер не "..", а имя текущей папки.

drkns 10.07.2009 23:47:08 +0200 - build 1035

1. Говорят, иногда сильно тормозило сохранение файлов. Теперь должно сохранять как минимум не медленнее, чем в 1.75, а то и быстрее. :)

2. Очередные пляски вокруг nul, con, com1 и иже с ними. Теперь должно корректно обрабатываться и в подкаталогах.

3. Разные мелочи.

zg 08.07.2009 20:36:05 +0200 - build 1034

1. в StrCmpNI/StrCmpN сравнение уходило за границы строки.

zg 08.07.2009 03:23:36 +0200 - build 1033

1. Mantis#0000964: проблемы с вставкой текста.
   реально проблема в неправильном позиционировании курсора при удалении блока.

warp 08.07.2009 02:17:2009 +0300 - build 1032

1. HIGHLY EXPERIMENTAL. Меню выбора архивного плагина (с теоретической поддержкой Analyse, который 
   пока не работает). Возврат из OpenFilePlugin результата -2 не поддерживается (актуально только 
   для враппера, в 2.0 OpenFilePlugin вероятно умрет совсем). pointer_array надо или заменить на 
   один из используемых списков или наоборот использовать для списоков везде. Старый код сохранен
   в комментарии. На данный момент в меню отображаются имена модулей архивных плагинов.

zg 07.07.2009 14:53:16 +0200 - build 1031

1. уточнение 1030.

zg 07.07.2009 14:26:00 +0200 - build 1030

1. в ACTL_WAITKEY теперь приходят и макрокнопки.

warp 07.07.2009 03:07:00 +0300 - build 1029

1. Вводим функцию Analyse, первичный этап.

drkns 06.07.2009 23:04:55 +0200 - build 1028

1. По просьбам телезрителей DN_GETDIALOGINFO поступает и в ProcessDialogEvent тоже.

drkns 06.07.2009 18:35:27 +0200 - build 1027

1. Невозможно было зайти в папки nul, con, com1 и иже с ними.

2. При входе в \\?\nul неправильно отображалось содержимое панели.

3. Уточнение 1020.1 - в меню кодовых страниц иногда путались названия разделителей.

4. При пометке кодовых страниц в диалоге поиска файлов Space/Ins перемещают курсор на следующую позицию.

5. Забавный баг: если в диалоге нажать ПК и, не отпуская её, ЛК - диалог становился невидимым.
   IsMouseButtonPressed() теперь возвращает состояние всех мышиных клавиш сразу, а не первой попавшейся.

6. Внедрение системы идентификации диалогов. Часть первая - движок.
   API:
     DN_GETDIALOGINFO - far желает получить информацию о вашем диалоге.
       Param1 - 0, Param2 - указатель на структуру DialogInfo, получающую данные.
       Ваш плагин должен корректно заполнить поле StructSize структуры DialogInfo.
       верните TRUE, если заполнили структуру, или FALSE, если проигнорировали.
     DM_GETDIALOGINFO - вы желаете получить информацию о диалоге far или другого плагина.
       Param1 - 0, Param2 - указатель на структуру DialogInfo, получающую данные.
       возвращаемое значение: TRUE - структура заполнена, FALSE - сообщение проигнорировано.
     структура DialogInfo:
       StructSize - размер структуры;
       Id - уникальный идентификатор диалога в формате GUID.
     Событие DN_GETDIALOGINFO _НЕ_ поступает в функцию ProcessDialogEvent.
   Макроязык:
     состояние Dlg.Info.Id - строковое представление идентификатора текущего диалога.
     
   "Technology preview" второй части: диалог поиска (AltF7) имеет идентификатор {8C9EAD29-910F-4b24-A669-EDAFBA6ED964}.

zg 06.07.2009 13:20:05 +0200 - build 1026

1. убраны ненужные после 1021 фиксы из 1014.

zg 05.07.2009 14:39:29 +0200 - build 1025

1. настройка "whole words" влияла на поиск в hex в просмотре, хоть и была задисаблена.

zg 05.07.2009 12:25:19 +0200 - build 1024

1. Mantis#0000963: Не отображается описание для элемента "..".

zeroes 05.07.2009 03:51:27 +200  - build 1023

1. пробуем выполнить "%Programfiles%\test.exe" в ответ:
'D:\Program' is not recognized as an internal or external command,
operable program or batch file.


zg 04.07.2009 16:00:28 +0200 - build 1022

1. уточнение 1016.1.

zg 04.07.2009 15:48:50 +0200 - build 1021

1. после 1012 билда после закрытия диалогов фар отъедает некоторое время. 
   формально это 64 вызова Sleep(1). реально что-то около порядка секунды.

drkns 03.07.2009 21:08:00 +0200 - build 1020

1. Всякая косметика в меню кодовых страниц - названия групп, справка и т. п.
   Также в меню теперь всегда отображается "Automatic detection" (пока что в отключенном состоянии) - сие есть задел на будущее.

2. В статусной строке редактора не отображались атрибуты файла.

3. Mantis#0000871: Код символа под курсором в редакторе всегда юникодный.
   Если текущая кодовая страница - не уникод, если символ под курсором может быть отображен в этой странице, и если его код при этом
   отличается от уникодного - этот код будет показан в статусной строке вместе с уникодным.

garry 03.07.2009 03:32:47 +0300 - build 1019

1. В продолжение 1018 добавлена возможность в ключе реестра Far2\CodePages\Names задавать имена для
   таблиц символов имён которых не знает система. Например, для CP1125 это будет выглядеть примерно так:

   [HKEY_CURRENT_USER\Software\Far2\CodePages\Names]
   "1125"="RUSCII"

garry 03.07.2009 02:25:13 +0300 - build 1018

1. Добавлена поддержка кодовых страниц без имени (для них GetCPInfoEx возвращает ошибку). В частности,
   теперь работает CP1125 (RUSCII). Пока такие кодовые страницы так и отображаются в списке с пустым
   именем;

2. Во враппере исправлено форматирование нестандартных имён кодовых страниц.

drkns 02.07.2009 21:40:21 +0200 - build 1017

1. Внезапно выяснилось, что FCTL_SETSELECTION, во первых, криво работал при "Show selected first",
   во вторых, после него не работал CtrlM.

   Теперь, ВНИМАНИЕ! - правильно выделять из плагинов надо так:
   
   FCTL_BEGINSELECTION
   FCTL_SETSELECTION сколько нужно раз
   FCTL_ENDSELECTION.

zg 02.07.2009 18:51:52 +0200 - build 1016

1. сильно ускорен последовательный вызов FCTL_GETSELECTEDPANELITEM с неуменьшающимися индексами.

2. gcc варнинги.

drkns 01.07.2009 17:43:47 +0200 - build 1015

1. Продолжение 988.

2. При создании папок проверка корректности списка производится в обработчике диалога, а не после его закрытия.

3. В некоторых случаях неровно форматировались строки в списке результатов поиска.

svs 01.07.2009 11:27:19 +0300 - build 1014

1. Mantis#0000949: Баги при вызове AdvControl с ACTL_REDRAWALL

2. Уточнение build 1013

3. Немного логирования в менеждере...

svs 29.06.2009 17:57:12 +0300 - build 1013

1. в этом патче такое:
   1. фрейм не удаляем из CloseDialog, т.к. эта функция вызывается из XXXProc (и из плагинов)
   2. фрейм можно удалить только из "проходных" функций ProcessMouse или ProcessKey.
   3. при выставленном флаге DMODE_ENDLOOP ничего плагину в обработчик диалога не кидаем
   4. теперь в плагинах "Info.DialogRun(hDlg);" можно юзать сколько угодно раз между Init и Free.

zg 27.06.2009 01:59:08 +0200 - build 1012

1. вернём показ дополнительной информации для элемента "..".

drkns 25.06.2009 23:28:35 +0200

1. Секция "compatibility" в манифесте.

2. Поправки в vcproj.

drkns 23.06.2009 08:40:58 +0200 - build 1011

1. Mantis#0000947: Новое поведение Executor'а и %PATHEXT%. В 1009 закрались "апичатки".

lort 22.06.2009 22:43:08 +0300 - build 1010

1. Убрана перерисовка при вызове EUR_UNDO и EUR_REDO

2. Переделки в Undo, перед откатом проверяем есть ли для UNDO_END соответствующий UNDO_BEGIN и наоборот

3. Исправления в Editor.Sel, неправильно производилось выделение, если позиция начала выделения находилась после позиции конца

4. Добавлена макро функция V=Editor.Undo(N)
   здесь N:
     0 - BEGIN - начало блочной операции
     1 - END - конец блочной операции
     2 - UNDO - сделать Undo
     3 - REDO - сделать Redo

drkns 22.06.2009 15:23:38 +0200 - build 1009

1. Mantis#0000947: Новое поведение Executor'а и %PATHEXT%

2. Не всегда правильно перерисовывался диалог копирования.

drkns 22.06.2009 10:43:06 +0200 - build 1008

1. Исправление во враппере на тему FarDialogItem.Param.ListItems/FarDialogItem.Param.ListPos.
   И кто только придумал засунуть их в union :(
   Ну и заодно во всех подобных местах используем SYSTEMINFO::<Minimum|Maximum>ApplicationAddress вместо "магических чисел" 0x2000, 0x5000, MAX_MSG и т. п.

drkns 21.06.2009 19:22:36 +0200 - build 1007

1. Mantis#0000945: Не работает Rename при перемещении файлов (F6, Move) на одном диске

zg 21.06.2009 19:12:40 +0200 - build 1006

1. уточнения в PluginSynchro.

zg 21.06.2009 18:08:33 +0200 - build 1005

1. новое апи. позволяет потоку, запущенному плагином выполнить код в контексте главного потока фара.
   поток может вызвать Info.AdvControl(Info.ModuleNumber,ACTL_SYNCHRO,Param).
   если плагин экспортирует функцию ProcessSynchroEventW то она будет вызвана в контексте главного потока.
   первый параметр при этом будет равен SE_COMMONSYNCHRO (обязательно нужно проверять), второй - Param, переданный AdvControl.
   ProcessSynchroEventW должна возвращать 0.

drkns 21.06.2009 14:31:57 +0200 - build 1004

1. Массовое истребление IsBad*Ptr.

2. Массовое истребление ключевого слова 'struct'.

3. Массовое истребление "W" в именах функций и структур.

zeroes 21.06.2009 14:30:03 +0200 - build 1003

1. При запуске грабера во viewer'е курсор промелькивает в командной строке.
Особенно это было видно при использовании ConEmu. (за фикс thanx 2 Maximas)

zg 21.06.2009 14:15:36 +0200 - build 1002

1. FCTL_SET*SORTORDER для анси плагинов всегда устанавливала обратную сортировку.

zg 21.06.2009 00:15:57 +0200 - build 1001

1. падение при вызове анси плагином DM_GETDLGITEM с неверным индексом элемента диалога.

drkns 19.06.2009 16:07:36 +0200 - build 1000

1. Падение при вызове FCTL_GET[SELECTED]PANELITEM на пустой панели.

t-rex 19.06.2009 03:34:59 +0200 - build 999

1. Коррупция хипа во враппере.

drkns 17.06.2009 18:27:30 +0200 - build 998

1. Криво обрабатывалась команда chcp.

2. Mantis#938: Несовпадение регистра в именах файлов в исходниках.

3. Ещё пара мелочей. 

garry 16.06.2009 00:29:18 +0300 - build 997

1. Исправлены gcc warnings после 993;

2. Исправлена опечатка в makefile_gcc.

3. В xf_realloc_nomove вызов _expand сделан только для VC, так как в GCC far линкуется с msvcrt, где
   _expand работает несколько по другому:
     - http://msdn.microsoft.com/en-us/library/wfzt8b7y(VS.71).aspx
     - http://msdn.microsoft.com/en-us/library/wfzt8b7y(VS.80).aspx

t-rex 15.06.2009 22:44:49 +0200 - build 996

1. Пару мелочей.

drkns 15.06.2009 22:21:41 +0200 - build 995

1. Получение имени открытого в редакторе файла вынесено в отдельную команду - ECTL_GETFILENAME.
   Команда возвращает требуемый размер буфера.

drkns 15.06.2009 20:30:24 +0200 - build 994

1. ECTL_FREEINFO больше нет. Память под EditorInfo::FileName выделяет плагин.
   Требуемый размер можно получить в поле EditorInfo::FileNameSize передав туда 0,
   либо передав NULL в качестве EditorInfo::FileName.
   Также надо пересобрать плагины, работающие со стековыми закладками редактора и ECTL_UNDOREDO.

2. ACTL_FREEWINDOWINFO больше нет. Память под WindowInfo::TypeName и WindowInfo::Name выделяет плагин.
   Требуемые размеры можно получить в полях WindowInfo::TypeNameSize и WindowInfo::NameSize передав туда 0,
   либо передав NULL в качестве WindowInfo::TypeName и WindowInfo::Name соответственно.

garry 15.06.2009 20:16:33 +0300 - build 993

1. Ускорена загрузка файлов в редактор:
	- Для не-Unicode файлов на больших файлах (~200Мб) прирост скорости порядка 30-40%;
	- Для Unicode файлов прирост скорости загрузки порядка 20-30%.

2. Теперь при загрузке в редактор нормально обрабатываются идущие подряд MAC окончания строк;

3. Немного форматирования по ходу дела;

4. Добавлена функция xf_realloc_nomove, которая рабатает аналогично xf_realloc, за исключением
   того, что в случае перемещения буфера, она не копирует данные в новое расположение;

5. Кое-где применена функция xf_realloc_nomove.

zg 14.06.2009 23:03:14 +0200 - build 992

1. DM_FREEDLGITEM больше нет.
   все плагины, использовавшие DM_GETDLGITEM/DM_FREEDLGITEM/DM_GETCONSTTEXTPTR/DM_GETDLGITEMSHORT/DM_SETDLGITEMSHORT - сломались.
   DM_GETDLGITEM - изменён, Param2 указатель на память куда будет скопирован элемент. возвращается необходимый размер буфера.

2. в диалоге копирования текла память.

zg 14.06.2009 21:38:11 +0200 - build 991

1. откатим b984 пункт 2. иначе apply command иногда для некоторых файлов выполнялось по два раза.

zg 14.06.2009 19:58:18 +0200 - build 990

1. farmail корректно определяет кодировку редактора.

2. если было больше одной любимой кодировки, то анси плагины получали много клонированных кодировок.

lort 13.06.2009 21:07:43 +0300 - build 989

1. При переоткрытии редактора с новым файлом не сбрасывалось состояние undo

2. Запись за границу буфера если в редакторе конец строки состоит из трёх символов (\r\r\n)

drkns 13.06.2009 11:59:46 +0200 - build 988

1. Обход очередного бага Windows (ключевые слова: "ClearType", "векторный шрифт", "мусор").

zg 10.06.2009 20:01:03 +0200 - build 987

1. если set содержала '/', то передавалась cmd.

svs 10.06.2009 14:06:05 +0300 - build 986

1. "echo." ==> "Режим вывода команд на экран (ECHO) включен."

2. Macro: Кнопоксочетания не парсились в функциях (например, "msgbox(CtrlPgUp)")

3. Macro: девиз "eval() без параметров неправильно формирует стек". в общем баг.
   + в eval: если передаем пустую строку, то нефига ничего компилить: вернет -1.

4. API: Исходя из п.3 ACTL_KEYMACRO+MCMD_POSTMACROSTRING вернет FALSE для пустой строки

svs 09.06.2009 23:18:26 +0300 - build 985

1. В исполняторе учтем экрано-символ '^' и вариант "echo." (эхо с точкой!)

2. Mantis#0000912: Ctrl+PageUp problem after using Temp panel 

3. Очередное "изнасилование" ApplyCommand.

4. немного форматирования кода ;-)

svs 08.06.2009 22:32:42 +0300 - build 984

1. Значение параметра "Interface/ShowMenuBar" (Opt.ShowMenuBar) влияло на позицию начала показа панелей.

2. Траблы с прорисовкой после "Apply Command". Часть 1.
   Влияет наличие RedrawDesktop. Временно отключим.
   Побочный эффект - мерцание панелей.

3. Сразу после "Apply Command" установим нулевой фрейм (панели) - вопрос спорный ;-)

4. Подземные стуки с текущим каталогом после 929
   добавляем проверку TestCurrentDirectory()

svs 08.06.2009 15:45:39 +0300 - build 983

1. "cd\" - живи.
   http://forum.farmanager.com/viewtopic.php?f=6&t=4126

2. небольшие проблемы с "~", например, "cd ~\.." не работал.

3. Mantis#0000910: Команды "CD", "SET" и подобные в диалоге "Apply To" (Ctrl-G) 

4. "Apply Command", UserMenu и Ассоциации сделаем однотипно.
   Сейчас есть глюк с прорисовкой - поборимся позже.
   В последствии необходимо из трех однотипных кусков сделать 1 функцию.
   Так же у Ctrl-G был глюк с неудалением временных файлов, если использовались метасимволы-листинги.

drkns 07.06.2009 15:38:57 +0200 - build 982

1. Mantis#0000918: При использовании "Apply to" нужен дополнительный перевод строки

2. При запуске cd без параметра выдавалось ненужное сообщение об ошибке.

t-rex 06.06.2009 17:10:43 +0200 - build 981

1. from chupakabra: Несколько проблем с поиском в архивах.

2. Немного форматирования за одно.

t-rex 06.06.2009 03:51:51 +0200 - build 980

from chupakabra:

1. В результатах поиска нельзя было просмотреть файлы из архивов.

drkns 05.06.2009 22:07:40 +0200

1. Коррекция и обновление документации и справки.

svs 04.06.2009 18:38:04 +0300 - build 979

1. Проблемы с UserMenu

t-rex 04.06.2009 07:39:36 +0200 - build 978

1. Забыл удалить UnicodeString:: у функций при переносе в хидер.

2. GCC ворнинги.

t-rex 03.06.2009 14:19:42 +0200 - build 977

1. Убираем alpha/beta/RC из версии.

t-rex 03.06.2009 00:54:05 +0200 - build 976

1. Mantis#911: Запись за границу буфера в UnicodeString.cpp (для OEM строк)

2. За одно мелкие оптимизации для OEM строк.

3. Пробелы -> Табы в UnicodeString.cpp

drkns 02.06.2009 18:12:34 +0200 - build 975

1. Учитываем, что у папок "по умолчанию" 0 потоков, а не 1.

2. 974 пункт 2 не актуален, ибо падало не там.

svs 02.06.2009 08:47:52 +0300 - build 974

1. Mantis#0000908: Проблемы с сообщением ошибок в макросе

2. Падение, если в процессе загрузки попадался кривой макрос.

drkns 01.06.2009 21:10:37 +0200 - build 973

1. Mantis#0000907: Маски не работают в fexist()

2. Коррекция типов в UserDefinedList: BOOL -> bool.

drkns 01.06.2009 19:13:49 +0200 - build 972

1. В 970 в ParseMacroString проверялись не те флаги, как результат - не работало и вдобавок падало.
   
2. Продолжаем перетряхивать FindFile, часть вторая. Там же поправлена пара мелких глюков.

3. Коррекция типов в BaseFileMask и иже с ним: BOOL -> bool.

4. Уточнение 1 пункта 966 билда.

zeroes 01.06.2009 18:51:19 +0200 - build 971

1. косметика в Farrus.lng "Прерыва&ние операций (Esc)" -> "Прерыва&ние
операций" потому что упоминаний про (Esc) нет в других языковых lng.

svs 01.06.2009 16:49:22 +0300 - build 970

1. Mantis#0000905: Изменения в eval 
     msgbox(eval("!!",1))
     Видим пустой msgbox
     Под ним - красное окошко "Macro parsing error"
     Во-первых msgbox не должен быть пустой 

   так, в общем тут 2 проблемы.
   1. вывод сообщения не должен выводиться всегда... в некоторых случаях нужен режим silent
   2. так вышло, что последовательность исполнения была такой:
    а) eval
    б) eval выводит диалог (он еще не виден, т.к. стоит дизаблеоутпут)
    в) как только в памяти оказался этот диалог об ошибке, макродвиг продолжил исполнение (по сути управление получи ФАР)
    г) дошли до функции msgbox, НО! eval еще не положил в стек значение парсинга.
    д) при исполнении msgbox разлочил экран и мы увидели 2 диалога.
   в общим фиксед, но фиксед только п.2.

   АХТУНГ! НА БУДУЩЕЕ.

   Любые диагностические сообщения в макродвиге должны быть оформлены подобно тому, как это сейчас сделано в 
   KeyMacro::ParseMacroString, т.е.
   1) разлочить экран
   2) увеличть InternalInput (запретить исполнение макроса)
   3) вывести диалог
   4) уменьшить InternalInput
   5) залочить экран, если перед этим он был залочен

2. Bug: Если "Interrupt operation" выключен и мы пытались загрузить большой файл, недождавшись прервали загрузку, то
   на экране оставался месаг про загрузку этого самого файла.

svs 01.06.2009 15:26:55 +0300 - build 969

1. Mantis#0000902: Нельзя выйти из папки первого уровня при работе с диском через \\?\ 

2. Mantis#0000898: недоработка: нет проверки на открываемый размер файла
   доп.месаг, если размер все же не удалось получить...

3. Mantis#0000903: не работает функция ограничения открываемого файла в редакторе по размеру 

4. Mantis#0000894: Должно быть - S=replace(Str,Find,Replace[,Cnt]) а можно вызвать только с двумя параметрами 

drkns 31.05.2009 20:56:30 +0200 - build 968

1. Неправильно работал apiGetFileSizeEx в предыдущем билде.

drkns 31.05.2009 17:25:14 +0200 - build 967

1. Mantis#0000900: Exception: при попытке выполнить команду edit:\\.\PhysicalDrive0.

2. Mantis#0000897: Глюки с \\.\C:. Пока только первая часть - "view:\\.\C: - Видим в заголовке въювера \\\.\C: (три слэша)".

3. Mantis#0000899: Неверное сообщение что файл не существует.

4. В IsNetworkPath() не учитывался формат \\?\UNC\.

5. При разборе макросов теперь всегда выдаётся предупреждение, если макрос содержит ошибки.

drkns 30.05.2009 18:24:54 +0200 - build 966

1. При удалении папки с рекурсивными симлинками (например, профиль пользователя в Vista/2008)
   могла возникать ошибка "The folder is not empty".

2. Не работала логика "показывать статус копирования не чаще 5 раз в секунду".
   Показывалось очень сильно чаще, что при копировании большого количества мелких файлов было чревато.

t-rex 30.05.2009 02:47:02 +0200 - build 965

from chupakabra:

1. Mantis#691: Патч для FindFiles::SetPluginDirectory
   Коректировка и оптимизация.

2. Mantis#637: Проблемы плагинов с OPIF_REALNAMES

3. Mantis#878: Сообщение при отсутствии прав на чтение каталога

t-rex 30.05.2009 02:16:58 +0200 - build 964

1. Ещё штрих.

t-rex 30.05.2009 01:20:25 +0200 - build 963

1. Да, и ещё немного тоже самого :) Но теперь вроде с клавой всё :)
   Осталось сделать также для зверька, изменений размера и т.п.

t-rex 30.05.2009 01:04:20 +0200 - build 962

1. Ещё коректировки в обработке HIDDEN, теперь вроде с клавой точно работает нормально.

t-rex 29.05.2009 21:43:15 +0200 - build 961

1. Оптимизация 960 на случай когда нету никаких HIDDEN.

t-rex 29.05.2009 21:33:45 +0200 - build 960

1. Правильный скроллинг при наличии ?IF_HIDDEN (Mantis#47), пока что только для клавы.
   Мыши нужно доделать примерно таким же образом.

svs 29.05.2009 20:55:05 +0300 - build 959

1. Перетрях UserMenu - форматирование, комментирование , упрощение, etc.

   "Кривые в реестре пункты меню" пропускаются. Раньше процесс прерывался, сейчас продолжается.

   Ахтунг. В режиме isSilent имеем проблемы с командами, которые выводят что-то на экран
           Здесь необходимо переделка, например, перед исполнением подсунуть временный экранный буфер, а потом его содержимое подсунуть в ScreenBuf...
   Это относится к ассоцияциям, юзерменю...

   Для реализации Shift-F4 (в редакторе править только текущий пункт/submenu) необходимо переделать функции MenuRegToFile и MenuFileToReg
   Здесь затыка в "strItemKey.Format (L"%s\\Item%d",MenuKey,I);".

t-rex 29.05.2009 03:58:00 +0200 - build 958

1. from lort: Исправление для 955. GetCPInfo для некоторых таблиц не работает, преобразовываем к ANSI в таких случаях.

2. from Kostia Romanov (kildor): немного переводов в eng.hlf.

t-rex 29.05.2009 01:43:23 +0200 - build 957

from netghost:

1. Mantis#890: Far unicode (both x86 and x64) crash when opening Drive Menu on Windows 7 x64
   Add additional checks for WNetEnumResource call output

drkns 28.05.2009 21:26:32 +0200 - build 956

1. С форума: "Падает Far 2.0 build 952 из-за MultiArc..."
   Только не из-за MultiArc, а из-за попыток дописать NULL к UnicodeString.

t-rex 28.05.2009 15:10:00 +0200 - build 955

from lort:

1. Mantis#879: Поддержка не OEM кодировок в редакторе для старых плагинов
   Умные не юникодные плагины теперь будут реже портить текст в редакторе.

drkns 28.05.2009 10:16:03 +0200 - build 954

1. Mantis#0000883: Фар 2.0 падает в Windows 7 при выборе дисков.

drkns 27.05.2009 15:51:25 +0200 - build 953

1. Ещё несколько лишних sprintf.

2. Дивайдим, конкурим и перетряхиваем findfile.?pp. Часть первая.

svs 27.05.2009 19:53:33 +0300 - build 952

1. Уточнение билда 951

svs 27.05.2009 17:37:41 +0300 - build 951

1. После 2578/929 выявились глубинно-древние камни. При запуске "Far apath ppath" на этапе инициализации приложения для ppath
   происходила подставнока диска от apath.

2. + нефига выводить месагбокс, пока менеджер не стартанул

t-rex 27.05.2009 14:51:32 +0200 - build 950

1. Устаканивание IsWordDiv.

svs 27.05.2009 10:43:02 +0300 - build 949

1. Mantis#0000813: Поддержка консольных алиасов в ассоциациях.

2. Встроенные команды "умеют" /?. Прочие варианты, не реализуемые внутри ФАРа отдаются по цепочке дальше.

svs 26.05.2009 23:56:23 +0300 - build 948

1. У ProcessUserMenu() параметр bool

2. Добавлена IsSpaceOrEos(), руками не мацать, нужна.

3. В GetRegKey() баг, т.к. XXX.GetLength() для 1 символа, считанного из реестра возвращала размер 2

drkns 26.05.2009 20:47:53 +0200 - build 947

1. Разные мелкие оптимизации - избавляемся от конкатенации строк по sprintf(%s%s), квотирования по sprintf(\"%s\") и прочей подобной стрельбы из пушки по воробьям.

drkns 26.05.2009 20:33:47 +0200 - build 946

1. Mantis0000877: Поиск при использовании фильтра зависает.

ts 25.05.2009 23:25:04 +0200 - build 945

1. Уточнение к 940 когда размер колонок в процентах < 100% и нет колонок с автоматически вычесляемой шириной.

drkns 25.05.2009 20:24:51 +0200 - build 944

1. Поиск умеет работать с альтернативными потоками данных.

2. Оптимизация vc-проекта.

svs 25.05.2009 15:18:37 +0300 - build 943

1. Добавка в Help про Redo

2. Ins в строках ввода сбрасывал выделенный блок

t-rex 24.05.2009 16:44:00 +0200 - build 942

1. Продолжаем дивайдить и конкурить хидеры. Уже почти.

ts 24.05.2009 14:16:49 +0200 - build 941

1. Правка опечатки в 940

ts 24.05.2009 09:34:50 +0200 - build 940

1. Mantis#0000805: Ширина колонок панели в процентах
   Реализация расчёта ширины колонок (пункт 3)

zg 24.05.2009 02:37:37 +0200 - build 939

1. убрана HotkeyRules.

t-rex 23.05.2009 23:23:24 +0200 - build 938

From lort:

1. Везде юзаем DList вместо TList.

t-rex 23.05.2009 23:06:59 +0200 - build 937

From lort:

1. Mantis#867: Поддержка redo в редакторе

t-rex 23.05.2009 22:27:45 +0200 - build 936

1. Продолжаем дивайдить и конкурить хидеры.

drkns 23.05.2009 17:43:14 +0200 - build 935

1. Продолжаем разделять и властвовать.

zg 23.05.2009 17:33:03 +0200 - build 934

1. после 930 в редакторе не работали alti/altu/altd. возможно и вдругих местах наблюдалось что-то подобное.

t-rex 23.05.2009 15:57:09 +0200 - build 933

1. Ещё мелкая оптимизация в UnicodeString.

2. Избавился от struct.hpp.

t-rex 23.05.2009 04:18:17 +0200 - build 932

1. Вроде как получилось сделать нормальное решение для KeyToKey
   которое даже несколько лучше чем в 1.75, особенно тем что теперь
   это в общем работает для всех имеющихся раскладок.

t-rex & drkns 23.05.2009 00:53:26 +0200 - build 931

1. Временное решение для KeyToKey.

t-rex 22.05.2009 19:45:37 +0200 - build 930

1. Продолжаем дивайдить и конкурить хидеры.

2. По дороге было замечено что InitKeysArray() и KeyToKeyLayout() (бывший LocalKeyToKey) вообще не правильно
   для 2.0 сделаны. Пометил как BUGBUG.

svs 22.05.2009 14:03:57 +0300 - build 929

1. Неправльно работала функция KeyNameToKey() для "полупрямых" клавишь вида ShiftShiftCtrlDown (ну или ShiftCtrlShiftDown)
   + еще одно "ускорение" KeyNameToKey()

2. "Хождение по сетевым папкам с тормозами"
   Оптимизация работы SetDir`ов и ChageDir`ов, исключающих повторные действия, если CurDir уже является тем же, что хотим установить.
   Основные тормоза возникли где-то в районе "после 5-й беты 1.75" - Фунция PrepareDiskPath().

t-rex 22.05.2009 12:19:59 +0200 - build 928

1. Ещё меская оптимизация в UnicodeString.

2. Продолжаем по маленьку дивайдить и конкурить хидеры.

drkns 21.05.2009 20:29:20 +0200 - build 927

1. Запускатор: перебор расширений производится в порядке, указанном в %pathext%.
   Заодно некоторый перетрях PrepareExecuteModule и IsCommandPEExeGUI.

t-rex 21.05.2009 19:52:11 +0200 - build 926

1. Анси плагин "External Filter" всегда выводил странную ошибку в конце работы.
   Плагин проверяет LastError для своих нужд а во врапере вызов UnicodeToAnsiBin
   приводил к выставлению LastError при нулевых строках что и обманывало плагин.

t-rex 20.05.2009 22:48:48 +0200 - build 925

1. Мда, надо идти работать в Макдональдс (http://faqs.org.ru/progr/c_cpp/cpp_lite3.htm).

t-rex 20.05.2009 00:53:17 +0200 - build 924

1. "" -> L"".

2. Ещё пара мелочей.

t-rex 20.05.2009 00:11:19 +0200 - build 923

1. Оптимизация в макросах на предмет использования VMStack.
   Скажем так, тот макрос который считает простые числа, будет работать маленько быстрей :)

2. Оптимизация в создании пустых UnicodeString. Местами вполне может быть очень значительно.

drkns 19.05.2009 21:12:35 +0200 - build 922

1. В Execute() лишний раз вызывалась GetShellAction().

2. Не пытаемся преобразовать путь в полный, если он c префиксом \\?\ или \\.\

3. В диалоге сохранения опция "[ ] Add signature" блокируется для 1-байтных кодовых страниц.

4. Mantis#0000869: Проблема с относительными путями при открытии файла через ShiftF4

5. Вьювер теперь корректно показывает размер "файлов" \\?\c:, \\.\physicaldrive0 и т. п.

6. Пара мелочей в farwinapi.

t-rex 19.05.2009 16:30:33 +0200 - build 921

1. Раз есть TStack то выкинем TVMStack и заюзаем первый для него.

2. Форматирование и gcc варнинги в TStack.

svs 18.05.2009 22:12:02 +0300 - build 920

2. Mantis#0000809: push/pop-dir для "встроенных" батников 
   "Бетмэн. Начало"
   Добавлены команды PUSHD, POPD, CLRD (очистка стека каталогов) - описаны в хелпе (в FarEng.hlf есть русские букофки)
   Взаимодействия с %COMSPEC% нет.

3. Для PROMT добавлен конструкт "$+" - отображение нужного числа знаков плюс (+) в зависимости от текущей глубины стека 
   каталогов PUSHD, по одному знаку на каждый сохраненный путь.

4. В дополнение - переменная среды FARDIRSTACK - содержимое вершины стека каталогов (который управляется командами pushd и popd)
   FARDIRSTACK позаимствована из униха (там это DIRSTACK)

t-rex 18.05.2009 18:24:35 +0200 - build 919

1. Враппер почему то отдавал анси плагинам кодировки выбраные в поиске а не favorites.

t-rex 18.05.2009 02:32:07 +0200 - build 918

1. And The Saga Continues.

t-rex 18.05.2009 01:13:47 +0200 - build 917

1. Вернём возможность показывать папки "." и ".." которые можно создать на фате, и подружим это с фиксом в 916.

2. Небольшая оптимизация в классе NTPath.

t-rex 17.05.2009 23:50:46 +0200 - build 916

1. В некоторых случаях показывались папки "." и по два раза ".." (и за одно форматирование кода).

t-rex 17.05.2009 17:06:27 +0200

1. Hungarian lng and hlf update from Far Hunor.

t-rex 17.05.2009 16:28:43 +0200 - build 915

1. Меню плагинов неправильно сортировалось если ветка реестра хоткеев была пуста.

t-rex 17.05.2009 14:33:23 +0200 - build 914

1. Mantis#776, назначение хоткея плагину работало в общем только для плагинов в под папках Фара,
   или если путь к плагину был длинней чем к фару. Теперь работает нормально для всех.

2. Ещё переделки и улучшения в классе PluginManager а также просто форматирование кода.

3. Хоткей для "tab size" в диалоге настроек редактора/въювера переводил фокус не туда куда надо.

t-rex 17.05.2009 00:10:20 +0200 - build 913

1. По наводке от Andrey Budko, оптимизация KeyNameToKey, теперь макросы загружаются немного быстрей.

2. Доп. оптимизация и мин. переделка класса PluginManager.

t-rex 16.05.2009 16:57:19 +0200

1. Добавил возможность собрать debug с gcc.

t-rex 16.05.2009 12:57:57 +0200 - buid 912

1. По наводке от Andrey Budko, оптимизация работы с реестром. Как минимум на порядок ускоряет загрузку и закрытие Фара.

2. gcc ворнинги.

t-rex 15.05.2009 21:21:33 +0200 - build 911

1. В 910 забыл изменить PluginManager::LoadPluginsFromCache() в соответствии с новым форматом кэша.

2. За одно теперь работает /co, а он видимо никогда вообще и не работал.

t-rex 15.05.2009 20:09:55 +0200 - build 910

1. На форуме жаловались что большое количество плагинов медленно грузится,
   но раз уж полез то переделал кэш плагинов в более приемлемый и оптимизированный вид.
   Там ещё бы надо в PluginManager::GetPlugin bsearch заюзать для полной красоты,
   раз уж список плагинов всегда находится в отсортированном состоянии.
   
drkns 14.05.2009 21:44:41 +0200 - build 909

1. Ещё некоторые мелочи на тему панели задач.

drkns 14.05.2009 00:49:36 +0200 - build 908

1. В Windows 7 статус выполняемых операций проецируется на кнопку в панели задач. Для gcc пока отключено.

2. При подсчёте размера папки по F3 в сообщении выводится уже насчитанное.

3. При поиске во вьювере отображается индикатор прогресса. 

4. Лишняя перерисовка в дереве папок.

garry 13.05.2009 16:48:26 +0300 - build 907

1. Настройка System\FindCodePage теперь REG_DWORD и содержит кодовую страницу для поиска;
2. Исправлены проблемы при инициализации списка кодовых страниц при поиске по всем кодовым страницам;
3. (С форума) В диалоге поиска, после заполнения списка кодовых страниц, в общем случае выбранная 
   кодовая страница может не совпадать с той кодовой страницей, которую мы хотели установить.
   Эта ситуация учтена.

svs 13.05.2009 11:23:49 +0300 - build 906

1. Mantis#0000860: msave() - сохранение переменных содержащих '\n' 
   Кроме msave() таккая же беда была и в KeyMacro::WriteVarsConst()

drkns 09.05.2009 17:52:42 +0200 - build 905

1. Mantis#0000861: Некорректная обработка кавычек в поиске файлов.
   Плюс немного оптимизации - проверка корректности маски выполняется в обработчике диалога, а не после его закрытия.

drkns 07.05.2009 12:50:05 +0200 - build 904

1. И ещё одно уточнение, там же.

drkns 07.05.2009 12:50:05 +0200 - build 903

1. Уточнение в отображении индикаторов прогресса в редакторе.

svs 06.05.2009 18:54:33 +0300 - build 902

1. Mantis#0000851: Странности с макроконстантами 
   Снова EnumRegValueEx.

zg 06.05.2009 15:30:08 +0200 - build 901

1. варнинги в gcc 4.4.0.

drkns 04.05.2009 20:11:56 +0200 - build 900

1. Фар падал при поиске текста в архивах.

2. Не работал поиск по всем кодовым страницам (а на самом деле - баг в EnumRegValue).

3. От SVS: Mantis0000851: Странности с макроконстантами (а на самом деле - баг в EnumRegValueEx).

drkns 04.05.2009 12:36:22 +0200 - build 899

1. Mantis#0000852: Memory leak in apiFindFirstStream().

2. Утечки памяти в History::ReadHistory() и History::SaveHistory().

drkns 03.05.2009 16:29:21 +0200 - build 898

1. В ScanTree закрывались не все хендлы.

2. Уберём пока эксперименты с Find<First|Next>File.

drkns 02.05.2009 11:16:01 +0200 - build 897

1. С форума: ошибка при установке атрибутов группе файлов

drkns 01.05.2009 13:42:58 +0200 - build 896

1. SetAttr:
   - Блокируем "Sparse" на томах без FILE_SUPPORTS_SPARSE_FILES.
   - "not indexed"/"temporary"/"offline" не блокируются нигде, ибо нет способа узнать, умеет ФС такое или нет.

2. Find<First|Next>File возвращал не все атрибуты на некоторых ФС.

3. Уточнение Mantis#45: содержимое символических ссылок копируется не тогда, когда ФС приёмника !="ntfs",
   а тогда, когда у ФС приёмника не установлен флаг FILE_SUPPORTS_REPARSE_POINTS.

drkns 01.05.2009 01:17:29 +0200 - build 895

1. Mantis#0000833: Не работают шорткаты у старых плагинов

2. Разблокируем в SetAttr и temporary/offline, чего добру пропадать.

drkns 30.04.2009 19:48:32 +0200 - build 894

1. x64 warnings.

drkns 30.04.2009 17:30:41 +0200 - build 893

1. В статусных сообщениях, выводимых редактором при загрузке/сохрании/поиске/замене, теперь присутствует прогрессбар.

2. По Ctrl-A можно управлять атрибутом "Sparse".
   Ахтунг: СНЯТИЕ сего атрибута работает только в Vista и выше.

3. Продолжение Mantis#0000153.

svs 29.04.2009 22:15:50 +0300 - build 892

1. Проблемы с прорисовкой:
   1. мы в корне, Tree.Far отсутствует, курсор на файле ниже предполагаемого Tree.Far, режим панели составной (имя, размер, etc.)
   2. Alt-F10, ждем построения дерева, после появления "панели" выбора в дереве жмем Esc
   3. Видим что строки "поехали".

   Сделано пока в лоб, в нужных местах выставлены комменты для TODO, может кто элегантней код сделает по проверке нужности обновления панелей.

drkns 29.04.2009 19:59:23 +0200 - build 891

1. Продолжение Mantis#0000153.

2. В 16-ричном просмотре используется новый вид скроллбара.

svs 29.04.2009 13:20:20 +0300 - build 890

1. Mantis#0000847: Сбивается выделение (Alt-Ins) при попытке выделить текст с помощью клавиатуры во время msgbox()

drkns 28.04.2009 22:55:03 +0200 - build 889

1. По мотивам Mantis#0000153: "Было бы логичнее и при ручном нажатии [Rename] предлагать уже модифицированное счётчиком имя."

2. Используем GetFileSizeEx() вместо GetFileSize().

svs 28.04.2009 18:03:38 +0300 - build 888

1. Mantis#0000841: Мусор в msgbox при неуказании опциональных параметров 

ts 28.04.2009 03:02:57 +0200 - build 887

1. Mantis#0000805: Ширина колонок панели в процентах
   Подготовка к реализации: задание и хранение настроек (пункт 1 и 2)
   TODO: непосредственно расчет ширины колонок

drkns 27.04.2009 22:48:55 +0200 - build 886

1. В диалог подтверждения перезаписи добавлена кнопка "Rename".

2. PreRedrawFunc() вызывалась при каждом Dialog::Show(), т. е. на каждый чих, что приводило к забавным видеоэффектам.
   Теперь вызывается только тогда, когда надо.

3. Для поиска слешей в строках используем <First|Last>Slash() вместо wcs[r]chr и [R]Pos.

svs 27.04.2009 21:04:01 +0300 - build 885

1. Mantis#0000843: Задержка при установке блока с помощью Editor.Sel 

2. Mantis#0000842: Far повисает на старте встретив Multi-String в разделе KeyMacros\Vars
   Так, здесь проблема не в макросах, а в EnumRegValueEx
   Немного переделал эту функцию - в т.к. ValueName в динамике (если ошибся - поправьте :-)

3. В apiRegEnumKeyEx потенциальный баг... с лишним циклом при получении имени кея

4. KeyMacro\Vars & KeyMacro\Consts могут быть REG_MULTI_SZ

svs 27.04.2009 10:27:38 +0300 - build 884

1. Mantis#0000838: Ошибка при выделении блока (Editor.Sel)
   Уточнение про "Если позиция начала и конца блока совпадают, то эта операция равносильна снятию пометки блока"

drkns 25.04.2009 19:59:55 +0200 - build 883

1. В метасимволах !@! и !$! не работал модификатор 'A'. Туда же добавлены 'W' (создавать список в уникоде) и 'U' (создавать список в UTF8).

drkns 24.04.2009 23:58:40 +0200 - build 882

1. Мелкий баг в 881.

drkns 24.04.2009 23:37:02 +0200 - build 881

1. В режимах панели доступно два новых типа колонок: количество потоков / суммарный размер потоков.

svs 23.04.2009 19:38:08 +0300 - build 880

1. Mantis#0000838: Ошибка при выделении блока (Editor.Sel)

2. Mantis#0000212: Добавить timestamp в истории каталогов/просмотра/редактирования
   Часть первая: внедрение математики, пока без отображения и экшена
   TODO: экшен и отображалку нужно делать в History::Select()
   Здесь так же можно добавить файловые атрибуты, тогда можно будет делать вот так: "удалить все скрытые каталоги"

garry 23.04.2009 09:48:24 +0300 - build 879

1. Усовершенствования в работе с кодовыми страницами:
    - В общем списке кодовых страниц снова отображаются системные OEM и ANSI кодовые страницы;
    - В диалоге поиска файлов нормально обрабатывается ситуация, когда в списке выбора кодовых страниц
      одна кодовая страница присутсвует два раза;
    - Исправлено следующее: если открыть выпадающий список кодовых страниц, спозиционироваться на какой-либо элемент, 
      а затем нажать ESC, то фар запоминал последнюю выбранную в выпадающем списке кодовую страницу, в то время как
      в самом списке оставалась выбрана старая кодовая страница. Соответственно, поиск осуществлялся не по той
      кодовой странице.

svs 22.04.2009 21:07:28 +0300 - build 878

1. Mantis#0000836: Ошибки в макрофункции Editor.Sel()

svs 22.04.2009 11:36:53 +0300 - build 877

1. Уточнение локировок
      есть история каталогов:
      C:\
      C:\Far.Unicode.200
      C:\Far.Unicode.200\contrib
      отмечаю последний и жму del
      выхожу по каталогам наверх -- все пункты истории залочены

svs 21.04.2009 21:54:10 +0300 - build 876

1. History.
   Добавлены локировки пунктов (защита от очисток и удалений)

   В FarHun.hlf.m4 и FarEng.hlf.m4 есть русские буковки.

2. Исправлены чудеса в CopyKeyTree - 1000 не всегда достаточно для хранения данных.
   (это когда делаем "far /u foo" и в ветке foo "немного" данных отсутствует)

svs 20.04.2009 21:04:27 +0300 - build 

1. В FarHun.hlf.m4 те же изменения, что и в 17.04.2009
   текст нужно "конвертнуть" на нужный язык (там на russian)

drkns 20.04.2009 15:52:31 +0200

1. В 875 отвалилась хитрая сортировка заголовков в индексе справки.

drkns 20.04.2009 13:40:12 +0200 - build 875

1. Mantis#0000078: Размер свободного места в симлинке при входе по сети 
   Mantis#0000758: Far неправильно показывает место на диске в ссылках на сетевой ресурс

   Здесь учитываем то, что GetDiskFreeSpaceEx - умный, и сам умеет находить правильный корень для любых ссылок.
   TODO: надо учесть сей момент и в копире, с поправкой на то, что целевой путь может отсутствовать и создаваться только в процессе копирования.

2. При свёрнутом хелпе и 80x25 разъезжался текст лицензии в справке.

3. FarHun.hlf.m4 добавлен в vcproj.

zg 20.04.2009 13:17:47 +0200 - build 874

1. при извлечении hotplug устройств в случае, когда 'device description' было равно 'friendly name' либо 'friendly name' было пустым,
   почему-то отображалось 'friendly name'. хотя более логичным является отображение 'device description'.

2. gcc варнинги.

svs 20.04.2009 12:11:42 +0300 - build 873

1. Mantis#0000832: Неработоспособность ключа /x 

svs 17.04.2009 13:23:10 +0300 - build 872

1. (from ts) правки во враппере для FarCharTableA, аналогичные 869

2. (from Ariman) Mantis#0000830: Неверный расчет перемещения в функции Viewer::Up() для UTF-8

3. (from Ariman) Mantis#0000810: Неверный результат функции Viewer::vread для UTF-8 

svs 17.04.2009 10:51:27 +0300 - build 

1. В hlf-файлах применен параметр CtrlStartPosChar - указывает место, где будет начало последующего текста
   для примера "изменен" раздел @Editor

2. Добавлены 2 раздела: @KeyMacroEditList и @KeyMacroViewerList, "показывающие" какие макросы активны в редакторе и вьювере.
   Здесь применены хелповые макроконструктивы <!Macro:XXXX!>. Парсер хелпа заменяет их на последовательность строк вида
   <название макроклавиши> <описание из поля Description>
   все значения берутся не из реестра, а из памяти (те макросы, которые ФАР загрузил при старте и которые были назначены в текущем сеансе).

   В FarEng.hlf.m4 есть русские букоФки.

drkns 15.04.2009 20:40:53 +0200 - build 871

1. В редакторе при установке кодовой страницы и сохранении файла производились попытки перекодировать пустые строки.

2. Во враппере в FCTL_GET[ANOTHER]PANELINFO производились попытки перекодировать PanelInfo.[Selected]PanelItems при отсутствии элементов на панели.

drkns & zg 14.04.2009 16:50:22 +0200 - build 870

1. IsHotPlugDevice() неправильно работала в Windows 7.

t-rex 14.04.2009 03:29:27 +0200 - build 869

1. av в EnumCodePagesProc при "не стандартных" имён таблиц, например под wine.

garry 13.04.2009 16:31:57 +0300 - build 868

1. Исправлен небольшой баг в раскраске привнесённый в 867.

garry 13.04.2009 14:14:05 +0300 - build 867

1. Исправления/улучшения работы с раскраской:
    - Исправлены проблемы возникающие, если элементы раскраски расположены не по порядку. К сожалению, в этом случае
      полностью избавиться от сканирования строки с начала не получается;
    - Функции RealPosToTab/TabPosToReal, если было включено преобразование табов в пробелы, подсчитывали расстояние 
      без учёта FEDITLINE_EDITBEYONDEND, а если отключено, то с учётом. Теперь FEDITLINE_EDITBEYONDEND не учитывается
      вне зависимсоти от режима работы с табами. Вследствие чего раскраска за пределами строки возможна в любом режиме;
    - Исправлены мелкие недочёты;
    - Произведены некоторые дополнительные оптимизации.

drkns 12.04.2009 16:48:16 +0200

1. Добавим форматов в Far.ico. 

drkns 08.04.2009 22:13:25 +0200 - build 866

1. Погнул выравнивание в предыдущем билде. 

svs 08.04.2009 23:23:47 +0300 - build 865

1. Mantis#0000816: Курсор не прячется при открытии viewer

2. Mantis#0000817: Неправильная макро-область

drkns 08.04.2009 18:08:04 +0200 - build 864

1. Mantis#0000820: В корне подмонтированных через SUBST дисках ошибочно показывается переход в родительский каталог

2. Убран мусор из pluginold.hpp.

3. Заголовки некоторых *.<с|h>pp были в oem.

4. В syslog криво использовалась IsDebuggerPresent().

drkns 07.04.2009 18:55:13 +0200 - build 863

1. Не работала проверка на HelpOnHelpTopic при вызове справки - при удерживании F1 стек возврата забивался черт знает чем.

2. Используем LIF_GRAYED вместо LIF_DISABLE в диалогах поиска и копирования.

3. x64 warnings.

4. Изменения в API:
    - в FSF.GetFileOwner добавлен 4-й параметр - размер приёмника;
    - Функция возвращает требуемый размер буфера.

5. Утечка памяти в FileList::ChangeDir.

6. Истреблён NM в некоторых местах.

7. Копир, поиск, дерево и прочие, использующие ScanTree - падали на путях глубже 130 каталогов.

t-rex 07.04.2009 17:43:53 +0200 - build 862

1. Верхний пункт истории был в общем не доступен.

drkns 06.04.2009 19:45:29 +0200 - build 861

1. Убрано ограничение на размер строки ввода в диалогах, там же поправлено несколько BUGBUG и убраны неиспользуемые переменные.

